# aocjavasdk_v100r020c00_en

Device Management
- API version: 1.0.0
  - Build date: 2020-12-28T20:43:14.319+08:00

Device management APIs, including: Creating, deleting, modifying, viewing, and importing NEs  ** SLA: **  |SLA item|Definition| |-----|-----| |Request success rate| ≥ 99%| |Availability|Tier2| |Data consistency|Eventually consistent, inconsistent duration <1 minute| |Throughput|1000 tps| |TP50 request delay|200 ms| |TP99.9 request delay|1000 ms| 


*Automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen)*


## Requirements

Building the API client library requires:
1. Java 1.7+
2. Maven/Gradle

## Installation

To install the API client library to your local Maven repository, simply execute:

```shell
mvn clean install
```

To deploy it to a remote Maven repository instead, configure the settings of the repository and execute:

```shell
mvn clean deploy
```

Refer to the [OSSRH Guide](http://central.sonatype.org/pages/ossrh-guide.html) for more information.

### Maven users

Add this dependency to your project's POM:

```xml
<dependency>
  <groupId>com.huawei.aoc.api</groupId>
  <artifactId>aocjavasdk_v100r020c00_en</artifactId>
  <version>1.0.0</version>
  <scope>compile</scope>
</dependency>
```

### Gradle users

Add this dependency to your project's build file:

```groovy
compile "com.huawei.aoc.api:aocjavasdk_v100r020c00_en:1.0.0"
```

### Others

At first generate the JAR by executing:

```shell
mvn clean package
```

Then manually install the following JARs:

* `target/aocjavasdk_v100r020c00_en-1.0.0.jar`
* `target/lib/*.jar`

## Getting Started

Please follow the [installation](#installation) instruction and execute the following Java code:

```java

import com.huawei.aoc.api.*;
import com.huawei.aoc.api.auth.*;
import com.huawei.aoc.api.model.*;
import com.huawei.aoc.api.service.NeCommuParamTemplateServiceApi;

import java.io.File;
import java.util.*;

public class NeCommuParamTemplateServiceApiExample {

    public static void main(String[] args) {
        
        NeCommuParamTemplateServiceApi apiInstance = new NeCommuParamTemplateServiceApi();
        String name = "name_example"; // String | Template name, which is matched in fuzzy mode.
        String templateType = "templateType_example"; // String | Template type. The value can be SNMP, NETCONF, TELNET, STELNET, or QX.
        Integer limit = 1000; // Integer | Maximum number of templates that can be queried at a time. The default value is 1000.
        String marker = "marker_example"; // String | Pagination marker.
        String sortName = "sortName_example"; // String | Sorting field.
        String sortType = "sortType_example"; // String | Sorting type.
        try {
            NECommuParamTemplateListDTO result = apiInstance.getNECommuParamTemplates(name, templateType, limit, marker, sortName, sortType);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling NeCommuParamTemplateServiceApi#getNECommuParamTemplates");
            e.printStackTrace();
        }
    }
}

```

## Documentation for API Endpoints

All URIs are relative to *https://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*NeCommuParamTemplateServiceApi* | [**getNECommuParamTemplates**](docs/NeCommuParamTemplateServiceApi.md#getNECommuParamTemplates) | **GET** /rest/neresmgmtservice/v1/necommuparam-templates | Query a Communication Parameter Template
*NeCommuParamTemplateService1Api* | [**createNECommuParamTemplate**](docs/NeCommuParamTemplateService1Api.md#createNECommuParamTemplate) | **POST** /rest/neresmgmtservice/v1/necommuparam-templates | Create a Communication Parameter Template
*NeCommuParamTemplateService4Api* | [**deleteNECommuParamTemplates**](docs/NeCommuParamTemplateService4Api.md#deleteNECommuParamTemplates) | **DELETE** /rest/neresmgmtservice/v1/necommuparam-templates | Delete a Communication Parameter Template
*NeResManagementServiceApi* | [**getNEBasicInfos**](docs/NeResManagementServiceApi.md#getNEBasicInfos) | **GET** /rest/neresmgmtservice/v1/nes | Query a Device
*NeResManagementService1Api* | [**createNE**](docs/NeResManagementService1Api.md#createNE) | **POST** /rest/neresmgmtservice/v1/nes | Create a Device
*NeResManagementService3Api* | [**batchDeleteNEs**](docs/NeResManagementService3Api.md#batchDeleteNEs) | **POST** /rest/neresmgmtservice/v1/nes/action/batch-delete | Delete a Device
*NeResManagementService4Api* | [**getNeDetailInfoById**](docs/NeResManagementService4Api.md#getNeDetailInfoById) | **GET** /rest/neresmgmtservice/v1/nes/{ne-id} | Query Device Details
*NeResManagementService5Api* | [**updateNEInfo**](docs/NeResManagementService5Api.md#updateNEInfo) | **PUT** /rest/neresmgmtservice/v1/nes/{ne-id} | Modify Device Information


## Documentation for Models

 - [CommuParamCondition](docs/CommuParamCondition.md)
 - [CommuUpdateParams](docs/CommuUpdateParams.md)
 - [CreateNECommuParamTemplateRspDTO](docs/CreateNECommuParamTemplateRspDTO.md)
 - [NEBasicInfoDTO](docs/NEBasicInfoDTO.md)
 - [NEBasicInfoListDTO](docs/NEBasicInfoListDTO.md)
 - [NECommonParamContent](docs/NECommonParamContent.md)
 - [NECommuParamDTO](docs/NECommuParamDTO.md)
 - [NECommuParamTemplateDTO](docs/NECommuParamTemplateDTO.md)
 - [NECommuParamTemplateDetailDTO](docs/NECommuParamTemplateDetailDTO.md)
 - [NECommuParamTemplateFullInfoDTO](docs/NECommuParamTemplateFullInfoDTO.md)
 - [NECommuParamTemplateListDTO](docs/NECommuParamTemplateListDTO.md)
 - [NECommunicationStatusDTO](docs/NECommunicationStatusDTO.md)
 - [NEFilter](docs/NEFilter.md)
 - [NEFullInfoDTO](docs/NEFullInfoDTO.md)
 - [NEFullInfoListDTO](docs/NEFullInfoListDTO.md)
 - [NeDetailInfoDto](docs/NeDetailInfoDto.md)
 - [OperateResult](docs/OperateResult.md)


## Documentation for Authorization

All endpoints do not require authorization.
Authentication schemes defined for the API:

## Recommendation

It's recommended to create an instance of `ApiClient` per thread in a multithreaded environment to avoid any potential issues.

## Author



