/*
 * Distributed Transaction Status Management APIs
 * Distributed transaction status management APIs: 1. Query a Transaction 2. Delete a Transaction 3. Retry a Transaction 4. Query Transaction Tracks 
 *
 * OpenAPI spec version: v1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * Conditions for querying distributed transactions
 */
@ApiModel(description = "Conditions for querying distributed transactions")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-12-28T20:43:35.344+08:00")
public class ConditionDataDto {
  @SerializedName("currentPage")
  private Integer currentPage = null;

  @SerializedName("pageSize")
  private Integer pageSize = null;

  @SerializedName("queryValue")
  private String queryValue = null;

  @SerializedName("dtId")
  private String dtId = null;

  @SerializedName("sponsorMicrosvc")
  private String sponsorMicrosvc = null;

  @SerializedName("startTime")
  private String startTime = null;

  @SerializedName("endTime")
  private String endTime = null;

  @SerializedName("detail")
  private String detail = null;

  @SerializedName("sortName")
  private String sortName = null;

  @SerializedName("sortAsc")
  private Boolean sortAsc = null;

  public ConditionDataDto currentPage(Integer currentPage) {
    this.currentPage = currentPage;
    return this;
  }

   /**
   * Current page number, which is mandatory.
   * @return currentPage
  **/
  @ApiModelProperty(value = "Current page number, which is mandatory.")
  public Integer getCurrentPage() {
    return currentPage;
  }

  public void setCurrentPage(Integer currentPage) {
    this.currentPage = currentPage;
  }

  public ConditionDataDto pageSize(Integer pageSize) {
    this.pageSize = pageSize;
    return this;
  }

   /**
   * Page size.
   * @return pageSize
  **/
  @ApiModelProperty(value = "Page size.")
  public Integer getPageSize() {
    return pageSize;
  }

  public void setPageSize(Integer pageSize) {
    this.pageSize = pageSize;
  }

  public ConditionDataDto queryValue(String queryValue) {
    this.queryValue = queryValue;
    return this;
  }

   /**
   * Keyword for query.
   * @return queryValue
  **/
  @ApiModelProperty(value = "Keyword for query.")
  public String getQueryValue() {
    return queryValue;
  }

  public void setQueryValue(String queryValue) {
    this.queryValue = queryValue;
  }

  public ConditionDataDto dtId(String dtId) {
    this.dtId = dtId;
    return this;
  }

   /**
   * Transaction ID.
   * @return dtId
  **/
  @ApiModelProperty(value = "Transaction ID.")
  public String getDtId() {
    return dtId;
  }

  public void setDtId(String dtId) {
    this.dtId = dtId;
  }

  public ConditionDataDto sponsorMicrosvc(String sponsorMicrosvc) {
    this.sponsorMicrosvc = sponsorMicrosvc;
    return this;
  }

   /**
   * Initiator microservice.
   * @return sponsorMicrosvc
  **/
  @ApiModelProperty(value = "Initiator microservice.")
  public String getSponsorMicrosvc() {
    return sponsorMicrosvc;
  }

  public void setSponsorMicrosvc(String sponsorMicrosvc) {
    this.sponsorMicrosvc = sponsorMicrosvc;
  }

  public ConditionDataDto startTime(String startTime) {
    this.startTime = startTime;
    return this;
  }

   /**
   * Transaction start time.
   * @return startTime
  **/
  @ApiModelProperty(value = "Transaction start time.")
  public String getStartTime() {
    return startTime;
  }

  public void setStartTime(String startTime) {
    this.startTime = startTime;
  }

  public ConditionDataDto endTime(String endTime) {
    this.endTime = endTime;
    return this;
  }

   /**
   * Transaction end time.
   * @return endTime
  **/
  @ApiModelProperty(value = "Transaction end time.")
  public String getEndTime() {
    return endTime;
  }

  public void setEndTime(String endTime) {
    this.endTime = endTime;
  }

  public ConditionDataDto detail(String detail) {
    this.detail = detail;
    return this;
  }

   /**
   * Transaction details.
   * @return detail
  **/
  @ApiModelProperty(value = "Transaction details.")
  public String getDetail() {
    return detail;
  }

  public void setDetail(String detail) {
    this.detail = detail;
  }

  public ConditionDataDto sortName(String sortName) {
    this.sortName = sortName;
    return this;
  }

   /**
   * Sorting dimension, for example, lastTime.
   * @return sortName
  **/
  @ApiModelProperty(value = "Sorting dimension, for example, lastTime.")
  public String getSortName() {
    return sortName;
  }

  public void setSortName(String sortName) {
    this.sortName = sortName;
  }

  public ConditionDataDto sortAsc(Boolean sortAsc) {
    this.sortAsc = sortAsc;
    return this;
  }

   /**
   * Whether the query result is in ascending order.
   * @return sortAsc
  **/
  @ApiModelProperty(value = "Whether the query result is in ascending order.")
  public Boolean isSortAsc() {
    return sortAsc;
  }

  public void setSortAsc(Boolean sortAsc) {
    this.sortAsc = sortAsc;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ConditionDataDto conditionDataDto = (ConditionDataDto) o;
    return Objects.equals(this.currentPage, conditionDataDto.currentPage) &&
        Objects.equals(this.pageSize, conditionDataDto.pageSize) &&
        Objects.equals(this.queryValue, conditionDataDto.queryValue) &&
        Objects.equals(this.dtId, conditionDataDto.dtId) &&
        Objects.equals(this.sponsorMicrosvc, conditionDataDto.sponsorMicrosvc) &&
        Objects.equals(this.startTime, conditionDataDto.startTime) &&
        Objects.equals(this.endTime, conditionDataDto.endTime) &&
        Objects.equals(this.detail, conditionDataDto.detail) &&
        Objects.equals(this.sortName, conditionDataDto.sortName) &&
        Objects.equals(this.sortAsc, conditionDataDto.sortAsc);
  }

  @Override
  public int hashCode() {
    return Objects.hash(currentPage, pageSize, queryValue, dtId, sponsorMicrosvc, startTime, endTime, detail, sortName, sortAsc);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ConditionDataDto {\n");
    
    sb.append("    currentPage: ").append(toIndentedString(currentPage)).append("\n");
    sb.append("    pageSize: ").append(toIndentedString(pageSize)).append("\n");
    sb.append("    queryValue: ").append(toIndentedString(queryValue)).append("\n");
    sb.append("    dtId: ").append(toIndentedString(dtId)).append("\n");
    sb.append("    sponsorMicrosvc: ").append(toIndentedString(sponsorMicrosvc)).append("\n");
    sb.append("    startTime: ").append(toIndentedString(startTime)).append("\n");
    sb.append("    endTime: ").append(toIndentedString(endTime)).append("\n");
    sb.append("    detail: ").append(toIndentedString(detail)).append("\n");
    sb.append("    sortName: ").append(toIndentedString(sortName)).append("\n");
    sb.append("    sortAsc: ").append(toIndentedString(sortAsc)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

