/*
 * Resource Management
 * Resource management APIs: · Create a Resource Pool · Apply for Resources · Release Resources · Release Resources Based on User Information · Query Resource Usage · Delete a Resource Pool 
 *
 * OpenAPI spec version: 1.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import com.huawei.aoc.api.model.UrlElemList;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * CreatePoolInput
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-12-28T20:54:54.962+08:00")
public class CreatePoolInput {
  @SerializedName("recovery-threshold")
  private Integer recoveryThreshold = null;

  @SerializedName("segment")
  private Boolean segment = null;

  @SerializedName("url-elements")
  private String urlElements = null;

  @SerializedName("threshold")
  private Integer threshold = null;

  @SerializedName("step")
  private Long step = 500l;

  @SerializedName("end")
  private Long end = null;

  @SerializedName("begin")
  private Long begin = null;

  @SerializedName("url-elem-list")
  private List<UrlElemList> urlElemList = null;

  @SerializedName("taskid")
  private String taskid = null;

  @SerializedName("tid")
  private String tid = null;

  public CreatePoolInput recoveryThreshold(Integer recoveryThreshold) {
    this.recoveryThreshold = recoveryThreshold;
    return this;
  }

   /**
   * Recovery threshold.
   * minimum: -2147483648
   * maximum: 2147483647
   * @return recoveryThreshold
  **/
  @ApiModelProperty(value = "Recovery threshold.")
  public Integer getRecoveryThreshold() {
    return recoveryThreshold;
  }

  public void setRecoveryThreshold(Integer recoveryThreshold) {
    this.recoveryThreshold = recoveryThreshold;
  }

  public CreatePoolInput segment(Boolean segment) {
    this.segment = segment;
    return this;
  }

   /**
   * Whether the resource pool is a segmented resource pool.
   * @return segment
  **/
  @ApiModelProperty(value = "Whether the resource pool is a segmented resource pool.")
  public Boolean isSegment() {
    return segment;
  }

  public void setSegment(Boolean segment) {
    this.segment = segment;
  }

  public CreatePoolInput urlElements(String urlElements) {
    this.urlElements = urlElements;
    return this;
  }

   /**
   * Resource pool name.
   * @return urlElements
  **/
  @ApiModelProperty(value = "Resource pool name.")
  public String getUrlElements() {
    return urlElements;
  }

  public void setUrlElements(String urlElements) {
    this.urlElements = urlElements;
  }

  public CreatePoolInput threshold(Integer threshold) {
    this.threshold = threshold;
    return this;
  }

   /**
   * Threshold.
   * minimum: -2147483648
   * maximum: 2147483647
   * @return threshold
  **/
  @ApiModelProperty(value = "Threshold.")
  public Integer getThreshold() {
    return threshold;
  }

  public void setThreshold(Integer threshold) {
    this.threshold = threshold;
  }

  public CreatePoolInput step(Long step) {
    this.step = step;
    return this;
  }

   /**
   * Step.
   * minimum: -9223372036854775808
   * maximum: -9223372036854775808
   * @return step
  **/
  @ApiModelProperty(value = "Step.")
  public Long getStep() {
    return step;
  }

  public void setStep(Long step) {
    this.step = step;
  }

  public CreatePoolInput end(Long end) {
    this.end = end;
    return this;
  }

   /**
   * End position of a resource pool.
   * minimum: -9223372036854775808
   * maximum: -9223372036854775808
   * @return end
  **/
  @ApiModelProperty(value = "End position of a resource pool.")
  public Long getEnd() {
    return end;
  }

  public void setEnd(Long end) {
    this.end = end;
  }

  public CreatePoolInput begin(Long begin) {
    this.begin = begin;
    return this;
  }

   /**
   * Start position of a resource pool.
   * minimum: -9223372036854775808
   * maximum: -9223372036854775808
   * @return begin
  **/
  @ApiModelProperty(value = "Start position of a resource pool.")
  public Long getBegin() {
    return begin;
  }

  public void setBegin(Long begin) {
    this.begin = begin;
  }

  public CreatePoolInput urlElemList(List<UrlElemList> urlElemList) {
    this.urlElemList = urlElemList;
    return this;
  }

  public CreatePoolInput addUrlElemListItem(UrlElemList urlElemListItem) {
    if (this.urlElemList == null) {
      this.urlElemList = new ArrayList<UrlElemList>();
    }
    this.urlElemList.add(urlElemListItem);
    return this;
  }

   /**
   * Get urlElemList
   * @return urlElemList
  **/
  @ApiModelProperty(value = "")
  public List<UrlElemList> getUrlElemList() {
    return urlElemList;
  }

  public void setUrlElemList(List<UrlElemList> urlElemList) {
    this.urlElemList = urlElemList;
  }

  public CreatePoolInput taskid(String taskid) {
    this.taskid = taskid;
    return this;
  }

   /**
   * Task ID.
   * @return taskid
  **/
  @ApiModelProperty(value = "Task ID.")
  public String getTaskid() {
    return taskid;
  }

  public void setTaskid(String taskid) {
    this.taskid = taskid;
  }

  public CreatePoolInput tid(String tid) {
    this.tid = tid;
    return this;
  }

   /**
   * Distributed or global transaction ID.
   * @return tid
  **/
  @ApiModelProperty(value = "Distributed or global transaction ID.")
  public String getTid() {
    return tid;
  }

  public void setTid(String tid) {
    this.tid = tid;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CreatePoolInput createPoolInput = (CreatePoolInput) o;
    return Objects.equals(this.recoveryThreshold, createPoolInput.recoveryThreshold) &&
        Objects.equals(this.segment, createPoolInput.segment) &&
        Objects.equals(this.urlElements, createPoolInput.urlElements) &&
        Objects.equals(this.threshold, createPoolInput.threshold) &&
        Objects.equals(this.step, createPoolInput.step) &&
        Objects.equals(this.end, createPoolInput.end) &&
        Objects.equals(this.begin, createPoolInput.begin) &&
        Objects.equals(this.urlElemList, createPoolInput.urlElemList) &&
        Objects.equals(this.taskid, createPoolInput.taskid) &&
        Objects.equals(this.tid, createPoolInput.tid);
  }

  @Override
  public int hashCode() {
    return Objects.hash(recoveryThreshold, segment, urlElements, threshold, step, end, begin, urlElemList, taskid, tid);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CreatePoolInput {\n");
    
    sb.append("    recoveryThreshold: ").append(toIndentedString(recoveryThreshold)).append("\n");
    sb.append("    segment: ").append(toIndentedString(segment)).append("\n");
    sb.append("    urlElements: ").append(toIndentedString(urlElements)).append("\n");
    sb.append("    threshold: ").append(toIndentedString(threshold)).append("\n");
    sb.append("    step: ").append(toIndentedString(step)).append("\n");
    sb.append("    end: ").append(toIndentedString(end)).append("\n");
    sb.append("    begin: ").append(toIndentedString(begin)).append("\n");
    sb.append("    urlElemList: ").append(toIndentedString(urlElemList)).append("\n");
    sb.append("    taskid: ").append(toIndentedString(taskid)).append("\n");
    sb.append("    tid: ").append(toIndentedString(tid)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

