/*
 * Distributed Transaction Status Management APIs
 * Distributed transaction status management APIs: 1. Query a Transaction 2. Delete a Transaction 3. Retry a Transaction 4. Query Transaction Tracks 
 *
 * OpenAPI spec version: v1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * Information about the participant involved in the distributed transaction
 */
@ApiModel(description = "Information about the participant involved in the distributed transaction")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-12-28T20:43:35.344+08:00")
public class DTPCohortDto {
  @SerializedName("cohortId")
  private String cohortId = null;

  @SerializedName("cohortMicrosvc")
  private String cohortMicrosvc = null;

  @SerializedName("cohortInstance")
  private String cohortInstance = null;

  @SerializedName("cohortPcrModeType")
  private String cohortPcrModeType = null;

  @SerializedName("state")
  private String state = null;

  @SerializedName("createTime")
  private String createTime = null;

  @SerializedName("updateTime")
  private String updateTime = null;

  @SerializedName("detail")
  private String detail = null;

  public DTPCohortDto cohortId(String cohortId) {
    this.cohortId = cohortId;
    return this;
  }

   /**
   * Participant ID.
   * @return cohortId
  **/
  @ApiModelProperty(value = "Participant ID.")
  public String getCohortId() {
    return cohortId;
  }

  public void setCohortId(String cohortId) {
    this.cohortId = cohortId;
  }

  public DTPCohortDto cohortMicrosvc(String cohortMicrosvc) {
    this.cohortMicrosvc = cohortMicrosvc;
    return this;
  }

   /**
   * Participant microservice.
   * @return cohortMicrosvc
  **/
  @ApiModelProperty(value = "Participant microservice.")
  public String getCohortMicrosvc() {
    return cohortMicrosvc;
  }

  public void setCohortMicrosvc(String cohortMicrosvc) {
    this.cohortMicrosvc = cohortMicrosvc;
  }

  public DTPCohortDto cohortInstance(String cohortInstance) {
    this.cohortInstance = cohortInstance;
    return this;
  }

   /**
   * Participant instance.
   * @return cohortInstance
  **/
  @ApiModelProperty(value = "Participant instance.")
  public String getCohortInstance() {
    return cohortInstance;
  }

  public void setCohortInstance(String cohortInstance) {
    this.cohortInstance = cohortInstance;
  }

  public DTPCohortDto cohortPcrModeType(String cohortPcrModeType) {
    this.cohortPcrModeType = cohortPcrModeType;
    return this;
  }

   /**
   * Participant PCR mode type.
   * @return cohortPcrModeType
  **/
  @ApiModelProperty(value = "Participant PCR mode type.")
  public String getCohortPcrModeType() {
    return cohortPcrModeType;
  }

  public void setCohortPcrModeType(String cohortPcrModeType) {
    this.cohortPcrModeType = cohortPcrModeType;
  }

  public DTPCohortDto state(String state) {
    this.state = state;
    return this;
  }

   /**
   * Status.
   * @return state
  **/
  @ApiModelProperty(value = "Status.")
  public String getState() {
    return state;
  }

  public void setState(String state) {
    this.state = state;
  }

  public DTPCohortDto createTime(String createTime) {
    this.createTime = createTime;
    return this;
  }

   /**
   * Time when a transaction is created.
   * @return createTime
  **/
  @ApiModelProperty(value = "Time when a transaction is created.")
  public String getCreateTime() {
    return createTime;
  }

  public void setCreateTime(String createTime) {
    this.createTime = createTime;
  }

  public DTPCohortDto updateTime(String updateTime) {
    this.updateTime = updateTime;
    return this;
  }

   /**
   * Time when a transaction is updated.
   * @return updateTime
  **/
  @ApiModelProperty(value = "Time when a transaction is updated.")
  public String getUpdateTime() {
    return updateTime;
  }

  public void setUpdateTime(String updateTime) {
    this.updateTime = updateTime;
  }

  public DTPCohortDto detail(String detail) {
    this.detail = detail;
    return this;
  }

   /**
   * Details of the participant involved in the transaction.
   * @return detail
  **/
  @ApiModelProperty(value = "Details of the participant involved in the transaction.")
  public String getDetail() {
    return detail;
  }

  public void setDetail(String detail) {
    this.detail = detail;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    DTPCohortDto dtPCohortDto = (DTPCohortDto) o;
    return Objects.equals(this.cohortId, dtPCohortDto.cohortId) &&
        Objects.equals(this.cohortMicrosvc, dtPCohortDto.cohortMicrosvc) &&
        Objects.equals(this.cohortInstance, dtPCohortDto.cohortInstance) &&
        Objects.equals(this.cohortPcrModeType, dtPCohortDto.cohortPcrModeType) &&
        Objects.equals(this.state, dtPCohortDto.state) &&
        Objects.equals(this.createTime, dtPCohortDto.createTime) &&
        Objects.equals(this.updateTime, dtPCohortDto.updateTime) &&
        Objects.equals(this.detail, dtPCohortDto.detail);
  }

  @Override
  public int hashCode() {
    return Objects.hash(cohortId, cohortMicrosvc, cohortInstance, cohortPcrModeType, state, createTime, updateTime, detail);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class DTPCohortDto {\n");
    
    sb.append("    cohortId: ").append(toIndentedString(cohortId)).append("\n");
    sb.append("    cohortMicrosvc: ").append(toIndentedString(cohortMicrosvc)).append("\n");
    sb.append("    cohortInstance: ").append(toIndentedString(cohortInstance)).append("\n");
    sb.append("    cohortPcrModeType: ").append(toIndentedString(cohortPcrModeType)).append("\n");
    sb.append("    state: ").append(toIndentedString(state)).append("\n");
    sb.append("    createTime: ").append(toIndentedString(createTime)).append("\n");
    sb.append("    updateTime: ").append(toIndentedString(updateTime)).append("\n");
    sb.append("    detail: ").append(toIndentedString(detail)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

