/*
 * Distributed Transaction Status Management APIs
 * Distributed transaction status management APIs: 1. Query a Transaction 2. Delete a Transaction 3. Retry a Transaction 4. Query Transaction Tracks 
 *
 * OpenAPI spec version: v1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import com.huawei.aoc.api.model.DTPCohortDto;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * Information about a distributed transaction record
 */
@ApiModel(description = "Information about a distributed transaction record")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-12-28T20:43:35.344+08:00")
public class DTPInfoDto {
  @SerializedName("dtId")
  private String dtId = null;

  @SerializedName("sponsorMicrosvc")
  private String sponsorMicrosvc = null;

  @SerializedName("sponsorInstance")
  private String sponsorInstance = null;

  @SerializedName("state")
  private String state = null;

  @SerializedName("createTime")
  private String createTime = null;

  @SerializedName("updateTime")
  private String updateTime = null;

  @SerializedName("dtpCohorts")
  private List<DTPCohortDto> dtpCohorts = null;

  public DTPInfoDto dtId(String dtId) {
    this.dtId = dtId;
    return this;
  }

   /**
   * Transaction ID.
   * @return dtId
  **/
  @ApiModelProperty(value = "Transaction ID.")
  public String getDtId() {
    return dtId;
  }

  public void setDtId(String dtId) {
    this.dtId = dtId;
  }

  public DTPInfoDto sponsorMicrosvc(String sponsorMicrosvc) {
    this.sponsorMicrosvc = sponsorMicrosvc;
    return this;
  }

   /**
   * Initiator microservice.
   * @return sponsorMicrosvc
  **/
  @ApiModelProperty(value = "Initiator microservice.")
  public String getSponsorMicrosvc() {
    return sponsorMicrosvc;
  }

  public void setSponsorMicrosvc(String sponsorMicrosvc) {
    this.sponsorMicrosvc = sponsorMicrosvc;
  }

  public DTPInfoDto sponsorInstance(String sponsorInstance) {
    this.sponsorInstance = sponsorInstance;
    return this;
  }

   /**
   * Initiator instance.
   * @return sponsorInstance
  **/
  @ApiModelProperty(value = "Initiator instance.")
  public String getSponsorInstance() {
    return sponsorInstance;
  }

  public void setSponsorInstance(String sponsorInstance) {
    this.sponsorInstance = sponsorInstance;
  }

  public DTPInfoDto state(String state) {
    this.state = state;
    return this;
  }

   /**
   * Status.
   * @return state
  **/
  @ApiModelProperty(value = "Status.")
  public String getState() {
    return state;
  }

  public void setState(String state) {
    this.state = state;
  }

  public DTPInfoDto createTime(String createTime) {
    this.createTime = createTime;
    return this;
  }

   /**
   * Time when a transaction is created.
   * @return createTime
  **/
  @ApiModelProperty(value = "Time when a transaction is created.")
  public String getCreateTime() {
    return createTime;
  }

  public void setCreateTime(String createTime) {
    this.createTime = createTime;
  }

  public DTPInfoDto updateTime(String updateTime) {
    this.updateTime = updateTime;
    return this;
  }

   /**
   * Time when a transaction is updated.
   * @return updateTime
  **/
  @ApiModelProperty(value = "Time when a transaction is updated.")
  public String getUpdateTime() {
    return updateTime;
  }

  public void setUpdateTime(String updateTime) {
    this.updateTime = updateTime;
  }

  public DTPInfoDto dtpCohorts(List<DTPCohortDto> dtpCohorts) {
    this.dtpCohorts = dtpCohorts;
    return this;
  }

  public DTPInfoDto addDtpCohortsItem(DTPCohortDto dtpCohortsItem) {
    if (this.dtpCohorts == null) {
      this.dtpCohorts = new ArrayList<DTPCohortDto>();
    }
    this.dtpCohorts.add(dtpCohortsItem);
    return this;
  }

   /**
   * Get dtpCohorts
   * @return dtpCohorts
  **/
  @ApiModelProperty(value = "")
  public List<DTPCohortDto> getDtpCohorts() {
    return dtpCohorts;
  }

  public void setDtpCohorts(List<DTPCohortDto> dtpCohorts) {
    this.dtpCohorts = dtpCohorts;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    DTPInfoDto dtPInfoDto = (DTPInfoDto) o;
    return Objects.equals(this.dtId, dtPInfoDto.dtId) &&
        Objects.equals(this.sponsorMicrosvc, dtPInfoDto.sponsorMicrosvc) &&
        Objects.equals(this.sponsorInstance, dtPInfoDto.sponsorInstance) &&
        Objects.equals(this.state, dtPInfoDto.state) &&
        Objects.equals(this.createTime, dtPInfoDto.createTime) &&
        Objects.equals(this.updateTime, dtPInfoDto.updateTime) &&
        Objects.equals(this.dtpCohorts, dtPInfoDto.dtpCohorts);
  }

  @Override
  public int hashCode() {
    return Objects.hash(dtId, sponsorMicrosvc, sponsorInstance, state, createTime, updateTime, dtpCohorts);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class DTPInfoDto {\n");
    
    sb.append("    dtId: ").append(toIndentedString(dtId)).append("\n");
    sb.append("    sponsorMicrosvc: ").append(toIndentedString(sponsorMicrosvc)).append("\n");
    sb.append("    sponsorInstance: ").append(toIndentedString(sponsorInstance)).append("\n");
    sb.append("    state: ").append(toIndentedString(state)).append("\n");
    sb.append("    createTime: ").append(toIndentedString(createTime)).append("\n");
    sb.append("    updateTime: ").append(toIndentedString(updateTime)).append("\n");
    sb.append("    dtpCohorts: ").append(toIndentedString(dtpCohorts)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

