/*
 * Resource Management
 * Resource management APIs: · Create a Resource Pool · Apply for Resources · Release Resources · Release Resources Based on User Information · Query Resource Usage · Delete a Resource Pool 
 *
 * OpenAPI spec version: 1.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import com.huawei.aoc.api.model.UrlElemList;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * DestroyPoolInput
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-12-28T20:54:54.962+08:00")
public class DestroyPoolInput {
  @SerializedName("segment")
  private Boolean segment = null;

  @SerializedName("url-elements")
  private String urlElements = null;

  @SerializedName("end")
  private Long end = null;

  @SerializedName("begin")
  private Long begin = null;

  @SerializedName("url-elem-list")
  private List<UrlElemList> urlElemList = null;

  @SerializedName("taskid")
  private String taskid = null;

  @SerializedName("tid")
  private String tid = null;

  public DestroyPoolInput segment(Boolean segment) {
    this.segment = segment;
    return this;
  }

   /**
   * Whether the resource pool is a segmented resource pool.
   * @return segment
  **/
  @ApiModelProperty(value = "Whether the resource pool is a segmented resource pool.")
  public Boolean isSegment() {
    return segment;
  }

  public void setSegment(Boolean segment) {
    this.segment = segment;
  }

  public DestroyPoolInput urlElements(String urlElements) {
    this.urlElements = urlElements;
    return this;
  }

   /**
   * Resource pool name.
   * @return urlElements
  **/
  @ApiModelProperty(value = "Resource pool name.")
  public String getUrlElements() {
    return urlElements;
  }

  public void setUrlElements(String urlElements) {
    this.urlElements = urlElements;
  }

  public DestroyPoolInput end(Long end) {
    this.end = end;
    return this;
  }

   /**
   * End position of a resource pool.
   * minimum: -9223372036854775808
   * maximum: -9223372036854775808
   * @return end
  **/
  @ApiModelProperty(value = "End position of a resource pool.")
  public Long getEnd() {
    return end;
  }

  public void setEnd(Long end) {
    this.end = end;
  }

  public DestroyPoolInput begin(Long begin) {
    this.begin = begin;
    return this;
  }

   /**
   * Start position of a resource pool.
   * minimum: -9223372036854775808
   * maximum: -9223372036854775808
   * @return begin
  **/
  @ApiModelProperty(value = "Start position of a resource pool.")
  public Long getBegin() {
    return begin;
  }

  public void setBegin(Long begin) {
    this.begin = begin;
  }

  public DestroyPoolInput urlElemList(List<UrlElemList> urlElemList) {
    this.urlElemList = urlElemList;
    return this;
  }

  public DestroyPoolInput addUrlElemListItem(UrlElemList urlElemListItem) {
    if (this.urlElemList == null) {
      this.urlElemList = new ArrayList<UrlElemList>();
    }
    this.urlElemList.add(urlElemListItem);
    return this;
  }

   /**
   * Get urlElemList
   * @return urlElemList
  **/
  @ApiModelProperty(value = "")
  public List<UrlElemList> getUrlElemList() {
    return urlElemList;
  }

  public void setUrlElemList(List<UrlElemList> urlElemList) {
    this.urlElemList = urlElemList;
  }

  public DestroyPoolInput taskid(String taskid) {
    this.taskid = taskid;
    return this;
  }

   /**
   * Task ID.
   * @return taskid
  **/
  @ApiModelProperty(value = "Task ID.")
  public String getTaskid() {
    return taskid;
  }

  public void setTaskid(String taskid) {
    this.taskid = taskid;
  }

  public DestroyPoolInput tid(String tid) {
    this.tid = tid;
    return this;
  }

   /**
   * Distributed or global transaction ID.
   * @return tid
  **/
  @ApiModelProperty(value = "Distributed or global transaction ID.")
  public String getTid() {
    return tid;
  }

  public void setTid(String tid) {
    this.tid = tid;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    DestroyPoolInput destroyPoolInput = (DestroyPoolInput) o;
    return Objects.equals(this.segment, destroyPoolInput.segment) &&
        Objects.equals(this.urlElements, destroyPoolInput.urlElements) &&
        Objects.equals(this.end, destroyPoolInput.end) &&
        Objects.equals(this.begin, destroyPoolInput.begin) &&
        Objects.equals(this.urlElemList, destroyPoolInput.urlElemList) &&
        Objects.equals(this.taskid, destroyPoolInput.taskid) &&
        Objects.equals(this.tid, destroyPoolInput.tid);
  }

  @Override
  public int hashCode() {
    return Objects.hash(segment, urlElements, end, begin, urlElemList, taskid, tid);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class DestroyPoolInput {\n");
    
    sb.append("    segment: ").append(toIndentedString(segment)).append("\n");
    sb.append("    urlElements: ").append(toIndentedString(urlElements)).append("\n");
    sb.append("    end: ").append(toIndentedString(end)).append("\n");
    sb.append("    begin: ").append(toIndentedString(begin)).append("\n");
    sb.append("    urlElemList: ").append(toIndentedString(urlElemList)).append("\n");
    sb.append("    taskid: ").append(toIndentedString(taskid)).append("\n");
    sb.append("    tid: ").append(toIndentedString(tid)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

