/*
 * Device Configuration History
 * Device configuration history APIs: · Query Device Configuration History · Query Details About Historical Device Configuration Records · Query Configuration Records · Export Historical Configuration Records · Query the Progress of Exporting Configuration Records · Download Exported Configuration Records · Save Southbound Device Configurations 
 *
 * OpenAPI spec version: 1.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import com.huawei.aoc.api.model.ExportCmdList;
import com.huawei.aoc.api.model.ExportDeviceidList;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * ExportHiscmdInput
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-12-28T20:44:35.779+08:00")
public class ExportHiscmdInput {
  @SerializedName("page-num")
  private Integer pageNum = null;

  @SerializedName("start-time")
  private Long startTime = null;

  @SerializedName("end-time")
  private Long endTime = null;

  @SerializedName("timezone")
  private String timezone = null;

  @SerializedName("format")
  private String format = null;

  @SerializedName("language")
  private String language = null;

  @SerializedName("is-all-hiscmd")
  private Boolean isAllHiscmd = null;

  @SerializedName("service-instance")
  private String serviceInstance = null;

  @SerializedName("export-deviceid-list")
  private List<ExportDeviceidList> exportDeviceidList = null;

  @SerializedName("message")
  private String message = null;

  @SerializedName("feature-name")
  private String featureName = null;

  @SerializedName("is-device-view")
  private Boolean isDeviceView = null;

  @SerializedName("timeout")
  private Long timeout = null;

  /**
   * Configuration status.
   */
  @JsonAdapter(ResultEnum.Adapter.class)
  public enum ResultEnum {
    OK("ok"),
    
    FAILED("failed"),
    
    PROCESSING("processing");

    private String value;

    ResultEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static ResultEnum fromValue(String text) {
      for (ResultEnum b : ResultEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<ResultEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final ResultEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public ResultEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return ResultEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("result")
  private ResultEnum result = null;

  @SerializedName("page-line")
  private Integer pageLine = null;

  @SerializedName("ampmlang")
  private String ampmlang = null;

  @SerializedName("export-cmd-list")
  private List<ExportCmdList> exportCmdList = null;

  public ExportHiscmdInput pageNum(Integer pageNum) {
    this.pageNum = pageNum;
    return this;
  }

   /**
   * Page number, which starts from 1.
   * minimum: 1
   * maximum: 2147483647
   * @return pageNum
  **/
  @ApiModelProperty(value = "Page number, which starts from 1.")
  public Integer getPageNum() {
    return pageNum;
  }

  public void setPageNum(Integer pageNum) {
    this.pageNum = pageNum;
  }

  public ExportHiscmdInput startTime(Long startTime) {
    this.startTime = startTime;
    return this;
  }

   /**
   * Start time for exporting data.
   * minimum: -9223372036854775808
   * maximum: -9223372036854775808
   * @return startTime
  **/
  @ApiModelProperty(value = "Start time for exporting data.")
  public Long getStartTime() {
    return startTime;
  }

  public void setStartTime(Long startTime) {
    this.startTime = startTime;
  }

  public ExportHiscmdInput endTime(Long endTime) {
    this.endTime = endTime;
    return this;
  }

   /**
   * End time for exporting data.
   * minimum: -9223372036854775808
   * maximum: -9223372036854775808
   * @return endTime
  **/
  @ApiModelProperty(value = "End time for exporting data.")
  public Long getEndTime() {
    return endTime;
  }

  public void setEndTime(Long endTime) {
    this.endTime = endTime;
  }

  public ExportHiscmdInput timezone(String timezone) {
    this.timezone = timezone;
    return this;
  }

   /**
   * Time zone.
   * @return timezone
  **/
  @ApiModelProperty(value = "Time zone.")
  public String getTimezone() {
    return timezone;
  }

  public void setTimezone(String timezone) {
    this.timezone = timezone;
  }

  public ExportHiscmdInput format(String format) {
    this.format = format;
    return this;
  }

   /**
   * Format.
   * @return format
  **/
  @ApiModelProperty(value = "Format.")
  public String getFormat() {
    return format;
  }

  public void setFormat(String format) {
    this.format = format;
  }

  public ExportHiscmdInput language(String language) {
    this.language = language;
    return this;
  }

   /**
   * Language of the exported data.
   * @return language
  **/
  @ApiModelProperty(value = "Language of the exported data.")
  public String getLanguage() {
    return language;
  }

  public void setLanguage(String language) {
    this.language = language;
  }

  public ExportHiscmdInput isAllHiscmd(Boolean isAllHiscmd) {
    this.isAllHiscmd = isAllHiscmd;
    return this;
  }

   /**
   * Whether to export all records.
   * @return isAllHiscmd
  **/
  @ApiModelProperty(value = "Whether to export all records.")
  public Boolean isIsAllHiscmd() {
    return isAllHiscmd;
  }

  public void setIsAllHiscmd(Boolean isAllHiscmd) {
    this.isAllHiscmd = isAllHiscmd;
  }

  public ExportHiscmdInput serviceInstance(String serviceInstance) {
    this.serviceInstance = serviceInstance;
    return this;
  }

   /**
   * Service instance.
   * @return serviceInstance
  **/
  @ApiModelProperty(value = "Service instance.")
  public String getServiceInstance() {
    return serviceInstance;
  }

  public void setServiceInstance(String serviceInstance) {
    this.serviceInstance = serviceInstance;
  }

  public ExportHiscmdInput exportDeviceidList(List<ExportDeviceidList> exportDeviceidList) {
    this.exportDeviceidList = exportDeviceidList;
    return this;
  }

  public ExportHiscmdInput addExportDeviceidListItem(ExportDeviceidList exportDeviceidListItem) {
    if (this.exportDeviceidList == null) {
      this.exportDeviceidList = new ArrayList<ExportDeviceidList>();
    }
    this.exportDeviceidList.add(exportDeviceidListItem);
    return this;
  }

   /**
   * Get exportDeviceidList
   * @return exportDeviceidList
  **/
  @ApiModelProperty(value = "")
  public List<ExportDeviceidList> getExportDeviceidList() {
    return exportDeviceidList;
  }

  public void setExportDeviceidList(List<ExportDeviceidList> exportDeviceidList) {
    this.exportDeviceidList = exportDeviceidList;
  }

  public ExportHiscmdInput message(String message) {
    this.message = message;
    return this;
  }

   /**
   * Message body.
   * @return message
  **/
  @ApiModelProperty(value = "Message body.")
  public String getMessage() {
    return message;
  }

  public void setMessage(String message) {
    this.message = message;
  }

  public ExportHiscmdInput featureName(String featureName) {
    this.featureName = featureName;
    return this;
  }

   /**
   * Feature.
   * @return featureName
  **/
  @ApiModelProperty(value = "Feature.")
  public String getFeatureName() {
    return featureName;
  }

  public void setFeatureName(String featureName) {
    this.featureName = featureName;
  }

  public ExportHiscmdInput isDeviceView(Boolean isDeviceView) {
    this.isDeviceView = isDeviceView;
    return this;
  }

   /**
   * Whether the device view is used.
   * @return isDeviceView
  **/
  @ApiModelProperty(value = "Whether the device view is used.")
  public Boolean isIsDeviceView() {
    return isDeviceView;
  }

  public void setIsDeviceView(Boolean isDeviceView) {
    this.isDeviceView = isDeviceView;
  }

  public ExportHiscmdInput timeout(Long timeout) {
    this.timeout = timeout;
    return this;
  }

   /**
   * Timeout interval.
   * minimum: 0
   * maximum: 4294967295
   * @return timeout
  **/
  @ApiModelProperty(value = "Timeout interval.")
  public Long getTimeout() {
    return timeout;
  }

  public void setTimeout(Long timeout) {
    this.timeout = timeout;
  }

  public ExportHiscmdInput result(ResultEnum result) {
    this.result = result;
    return this;
  }

   /**
   * Configuration status.
   * @return result
  **/
  @ApiModelProperty(value = "Configuration status.")
  public ResultEnum getResult() {
    return result;
  }

  public void setResult(ResultEnum result) {
    this.result = result;
  }

  public ExportHiscmdInput pageLine(Integer pageLine) {
    this.pageLine = pageLine;
    return this;
  }

   /**
   * Number of records per page.
   * minimum: 1
   * maximum: 2147483647
   * @return pageLine
  **/
  @ApiModelProperty(value = "Number of records per page.")
  public Integer getPageLine() {
    return pageLine;
  }

  public void setPageLine(Integer pageLine) {
    this.pageLine = pageLine;
  }

  public ExportHiscmdInput ampmlang(String ampmlang) {
    this.ampmlang = ampmlang;
    return this;
  }

   /**
   * Time format (AM/PM).
   * @return ampmlang
  **/
  @ApiModelProperty(value = "Time format (AM/PM).")
  public String getAmpmlang() {
    return ampmlang;
  }

  public void setAmpmlang(String ampmlang) {
    this.ampmlang = ampmlang;
  }

  public ExportHiscmdInput exportCmdList(List<ExportCmdList> exportCmdList) {
    this.exportCmdList = exportCmdList;
    return this;
  }

  public ExportHiscmdInput addExportCmdListItem(ExportCmdList exportCmdListItem) {
    if (this.exportCmdList == null) {
      this.exportCmdList = new ArrayList<ExportCmdList>();
    }
    this.exportCmdList.add(exportCmdListItem);
    return this;
  }

   /**
   * Get exportCmdList
   * @return exportCmdList
  **/
  @ApiModelProperty(value = "")
  public List<ExportCmdList> getExportCmdList() {
    return exportCmdList;
  }

  public void setExportCmdList(List<ExportCmdList> exportCmdList) {
    this.exportCmdList = exportCmdList;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ExportHiscmdInput exportHiscmdInput = (ExportHiscmdInput) o;
    return Objects.equals(this.pageNum, exportHiscmdInput.pageNum) &&
        Objects.equals(this.startTime, exportHiscmdInput.startTime) &&
        Objects.equals(this.endTime, exportHiscmdInput.endTime) &&
        Objects.equals(this.timezone, exportHiscmdInput.timezone) &&
        Objects.equals(this.format, exportHiscmdInput.format) &&
        Objects.equals(this.language, exportHiscmdInput.language) &&
        Objects.equals(this.isAllHiscmd, exportHiscmdInput.isAllHiscmd) &&
        Objects.equals(this.serviceInstance, exportHiscmdInput.serviceInstance) &&
        Objects.equals(this.exportDeviceidList, exportHiscmdInput.exportDeviceidList) &&
        Objects.equals(this.message, exportHiscmdInput.message) &&
        Objects.equals(this.featureName, exportHiscmdInput.featureName) &&
        Objects.equals(this.isDeviceView, exportHiscmdInput.isDeviceView) &&
        Objects.equals(this.timeout, exportHiscmdInput.timeout) &&
        Objects.equals(this.result, exportHiscmdInput.result) &&
        Objects.equals(this.pageLine, exportHiscmdInput.pageLine) &&
        Objects.equals(this.ampmlang, exportHiscmdInput.ampmlang) &&
        Objects.equals(this.exportCmdList, exportHiscmdInput.exportCmdList);
  }

  @Override
  public int hashCode() {
    return Objects.hash(pageNum, startTime, endTime, timezone, format, language, isAllHiscmd, serviceInstance, exportDeviceidList, message, featureName, isDeviceView, timeout, result, pageLine, ampmlang, exportCmdList);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ExportHiscmdInput {\n");
    
    sb.append("    pageNum: ").append(toIndentedString(pageNum)).append("\n");
    sb.append("    startTime: ").append(toIndentedString(startTime)).append("\n");
    sb.append("    endTime: ").append(toIndentedString(endTime)).append("\n");
    sb.append("    timezone: ").append(toIndentedString(timezone)).append("\n");
    sb.append("    format: ").append(toIndentedString(format)).append("\n");
    sb.append("    language: ").append(toIndentedString(language)).append("\n");
    sb.append("    isAllHiscmd: ").append(toIndentedString(isAllHiscmd)).append("\n");
    sb.append("    serviceInstance: ").append(toIndentedString(serviceInstance)).append("\n");
    sb.append("    exportDeviceidList: ").append(toIndentedString(exportDeviceidList)).append("\n");
    sb.append("    message: ").append(toIndentedString(message)).append("\n");
    sb.append("    featureName: ").append(toIndentedString(featureName)).append("\n");
    sb.append("    isDeviceView: ").append(toIndentedString(isDeviceView)).append("\n");
    sb.append("    timeout: ").append(toIndentedString(timeout)).append("\n");
    sb.append("    result: ").append(toIndentedString(result)).append("\n");
    sb.append("    pageLine: ").append(toIndentedString(pageLine)).append("\n");
    sb.append("    ampmlang: ").append(toIndentedString(ampmlang)).append("\n");
    sb.append("    exportCmdList: ").append(toIndentedString(exportCmdList)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

