/*
 * Device Configuration History
 * Device configuration history APIs: · Query Device Configuration History · Query Details About Historical Device Configuration Records · Query Configuration Records · Export Historical Configuration Records · Query the Progress of Exporting Configuration Records · Download Exported Configuration Records · Save Southbound Device Configurations 
 *
 * OpenAPI spec version: 1.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * GetBriefHiscmdInput
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-12-28T20:44:35.779+08:00")
public class GetBriefHiscmdInput {
  @SerializedName("page-num")
  private Integer pageNum = null;

  @SerializedName("ascend")
  private Boolean ascend = null;

  @SerializedName("start-time")
  private Long startTime = null;

  @SerializedName("device-id-list")
  private String deviceIdList = null;

  @SerializedName("end-time")
  private Long endTime = null;

  @SerializedName("sort-column")
  private String sortColumn = null;

  @SerializedName("language")
  private String language = null;

  @SerializedName("service-instance")
  private String serviceInstance = null;

  @SerializedName("request-id")
  private String requestId = null;

  @SerializedName("message")
  private String message = null;

  @SerializedName("feature-name")
  private String featureName = null;

  /**
   * Search criteria: configuration result.
   */
  @JsonAdapter(ResultEnum.Adapter.class)
  public enum ResultEnum {
    OK("ok"),
    
    FAILED("failed"),
    
    PROCESSING("processing");

    private String value;

    ResultEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static ResultEnum fromValue(String text) {
      for (ResultEnum b : ResultEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<ResultEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final ResultEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public ResultEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return ResultEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("result")
  private ResultEnum result = null;

  @SerializedName("page-line")
  private Integer pageLine = null;

  @SerializedName("key-value")
  private String keyValue = null;

  public GetBriefHiscmdInput pageNum(Integer pageNum) {
    this.pageNum = pageNum;
    return this;
  }

   /**
   * Sorting condition: page number.
   * minimum: 1
   * maximum: 2147483647
   * @return pageNum
  **/
  @ApiModelProperty(value = "Sorting condition: page number.")
  public Integer getPageNum() {
    return pageNum;
  }

  public void setPageNum(Integer pageNum) {
    this.pageNum = pageNum;
  }

  public GetBriefHiscmdInput ascend(Boolean ascend) {
    this.ascend = ascend;
    return this;
  }

   /**
   * Sorting condition: descending or not.
   * @return ascend
  **/
  @ApiModelProperty(value = "Sorting condition: descending or not.")
  public Boolean isAscend() {
    return ascend;
  }

  public void setAscend(Boolean ascend) {
    this.ascend = ascend;
  }

  public GetBriefHiscmdInput startTime(Long startTime) {
    this.startTime = startTime;
    return this;
  }

   /**
   * Search criteria: start time of recording.
   * minimum: -9223372036854775808
   * maximum: -9223372036854775808
   * @return startTime
  **/
  @ApiModelProperty(value = "Search criteria: start time of recording.")
  public Long getStartTime() {
    return startTime;
  }

  public void setStartTime(Long startTime) {
    this.startTime = startTime;
  }

  public GetBriefHiscmdInput deviceIdList(String deviceIdList) {
    this.deviceIdList = deviceIdList;
    return this;
  }

   /**
   * Device ID list.
   * @return deviceIdList
  **/
  @ApiModelProperty(value = "Device ID list.")
  public String getDeviceIdList() {
    return deviceIdList;
  }

  public void setDeviceIdList(String deviceIdList) {
    this.deviceIdList = deviceIdList;
  }

  public GetBriefHiscmdInput endTime(Long endTime) {
    this.endTime = endTime;
    return this;
  }

   /**
   * Search criteria: end time of recording.
   * minimum: -9223372036854775808
   * maximum: -9223372036854775808
   * @return endTime
  **/
  @ApiModelProperty(value = "Search criteria: end time of recording.")
  public Long getEndTime() {
    return endTime;
  }

  public void setEndTime(Long endTime) {
    this.endTime = endTime;
  }

  public GetBriefHiscmdInput sortColumn(String sortColumn) {
    this.sortColumn = sortColumn;
    return this;
  }

   /**
   * Sorting field.
   * @return sortColumn
  **/
  @ApiModelProperty(value = "Sorting field.")
  public String getSortColumn() {
    return sortColumn;
  }

  public void setSortColumn(String sortColumn) {
    this.sortColumn = sortColumn;
  }

  public GetBriefHiscmdInput language(String language) {
    this.language = language;
    return this;
  }

   /**
   * Encoding format.
   * @return language
  **/
  @ApiModelProperty(value = "Encoding format.")
  public String getLanguage() {
    return language;
  }

  public void setLanguage(String language) {
    this.language = language;
  }

  public GetBriefHiscmdInput serviceInstance(String serviceInstance) {
    this.serviceInstance = serviceInstance;
    return this;
  }

   /**
   * Search criteria: service instance.
   * @return serviceInstance
  **/
  @ApiModelProperty(value = "Search criteria: service instance.")
  public String getServiceInstance() {
    return serviceInstance;
  }

  public void setServiceInstance(String serviceInstance) {
    this.serviceInstance = serviceInstance;
  }

  public GetBriefHiscmdInput requestId(String requestId) {
    this.requestId = requestId;
    return this;
  }

   /**
   * Request ID.
   * @return requestId
  **/
  @ApiModelProperty(value = "Request ID.")
  public String getRequestId() {
    return requestId;
  }

  public void setRequestId(String requestId) {
    this.requestId = requestId;
  }

  public GetBriefHiscmdInput message(String message) {
    this.message = message;
    return this;
  }

   /**
   * Search criteria: message body details.
   * @return message
  **/
  @ApiModelProperty(value = "Search criteria: message body details.")
  public String getMessage() {
    return message;
  }

  public void setMessage(String message) {
    this.message = message;
  }

  public GetBriefHiscmdInput featureName(String featureName) {
    this.featureName = featureName;
    return this;
  }

   /**
   * Search criteria: feature name.
   * @return featureName
  **/
  @ApiModelProperty(value = "Search criteria: feature name.")
  public String getFeatureName() {
    return featureName;
  }

  public void setFeatureName(String featureName) {
    this.featureName = featureName;
  }

  public GetBriefHiscmdInput result(ResultEnum result) {
    this.result = result;
    return this;
  }

   /**
   * Search criteria: configuration result.
   * @return result
  **/
  @ApiModelProperty(value = "Search criteria: configuration result.")
  public ResultEnum getResult() {
    return result;
  }

  public void setResult(ResultEnum result) {
    this.result = result;
  }

  public GetBriefHiscmdInput pageLine(Integer pageLine) {
    this.pageLine = pageLine;
    return this;
  }

   /**
   * Sorting criteria: number of records per page.
   * minimum: 0
   * maximum: 2147483647
   * @return pageLine
  **/
  @ApiModelProperty(value = "Sorting criteria: number of records per page.")
  public Integer getPageLine() {
    return pageLine;
  }

  public void setPageLine(Integer pageLine) {
    this.pageLine = pageLine;
  }

  public GetBriefHiscmdInput keyValue(String keyValue) {
    this.keyValue = keyValue;
    return this;
  }

   /**
   * Search criteria: used as the key value for search.
   * @return keyValue
  **/
  @ApiModelProperty(value = "Search criteria: used as the key value for search.")
  public String getKeyValue() {
    return keyValue;
  }

  public void setKeyValue(String keyValue) {
    this.keyValue = keyValue;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetBriefHiscmdInput getBriefHiscmdInput = (GetBriefHiscmdInput) o;
    return Objects.equals(this.pageNum, getBriefHiscmdInput.pageNum) &&
        Objects.equals(this.ascend, getBriefHiscmdInput.ascend) &&
        Objects.equals(this.startTime, getBriefHiscmdInput.startTime) &&
        Objects.equals(this.deviceIdList, getBriefHiscmdInput.deviceIdList) &&
        Objects.equals(this.endTime, getBriefHiscmdInput.endTime) &&
        Objects.equals(this.sortColumn, getBriefHiscmdInput.sortColumn) &&
        Objects.equals(this.language, getBriefHiscmdInput.language) &&
        Objects.equals(this.serviceInstance, getBriefHiscmdInput.serviceInstance) &&
        Objects.equals(this.requestId, getBriefHiscmdInput.requestId) &&
        Objects.equals(this.message, getBriefHiscmdInput.message) &&
        Objects.equals(this.featureName, getBriefHiscmdInput.featureName) &&
        Objects.equals(this.result, getBriefHiscmdInput.result) &&
        Objects.equals(this.pageLine, getBriefHiscmdInput.pageLine) &&
        Objects.equals(this.keyValue, getBriefHiscmdInput.keyValue);
  }

  @Override
  public int hashCode() {
    return Objects.hash(pageNum, ascend, startTime, deviceIdList, endTime, sortColumn, language, serviceInstance, requestId, message, featureName, result, pageLine, keyValue);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetBriefHiscmdInput {\n");
    
    sb.append("    pageNum: ").append(toIndentedString(pageNum)).append("\n");
    sb.append("    ascend: ").append(toIndentedString(ascend)).append("\n");
    sb.append("    startTime: ").append(toIndentedString(startTime)).append("\n");
    sb.append("    deviceIdList: ").append(toIndentedString(deviceIdList)).append("\n");
    sb.append("    endTime: ").append(toIndentedString(endTime)).append("\n");
    sb.append("    sortColumn: ").append(toIndentedString(sortColumn)).append("\n");
    sb.append("    language: ").append(toIndentedString(language)).append("\n");
    sb.append("    serviceInstance: ").append(toIndentedString(serviceInstance)).append("\n");
    sb.append("    requestId: ").append(toIndentedString(requestId)).append("\n");
    sb.append("    message: ").append(toIndentedString(message)).append("\n");
    sb.append("    featureName: ").append(toIndentedString(featureName)).append("\n");
    sb.append("    result: ").append(toIndentedString(result)).append("\n");
    sb.append("    pageLine: ").append(toIndentedString(pageLine)).append("\n");
    sb.append("    keyValue: ").append(toIndentedString(keyValue)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

