/*
 * Device Configuration History
 * Device configuration history APIs: · Query Device Configuration History · Query Details About Historical Device Configuration Records · Query Configuration Records · Export Historical Configuration Records · Query the Progress of Exporting Configuration Records · Download Exported Configuration Records · Save Southbound Device Configurations 
 *
 * OpenAPI spec version: 1.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * GetFpHiscmdInput
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-12-28T20:44:35.779+08:00")
public class GetFpHiscmdInput {
  @SerializedName("page-num")
  private Integer pageNum = null;

  /**
   * Search criteria: processing result.
   */
  @JsonAdapter(ResultEnum.Adapter.class)
  public enum ResultEnum {
    OK("ok"),
    
    FAILED("failed"),
    
    PROCESSING("processing");

    private String value;

    ResultEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static ResultEnum fromValue(String text) {
      for (ResultEnum b : ResultEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<ResultEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final ResultEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public ResultEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return ResultEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("result")
  private ResultEnum result = null;

  @SerializedName("start-time")
  private Long startTime = null;

  @SerializedName("end-time")
  private Long endTime = null;

  @SerializedName("page-line")
  private Integer pageLine = null;

  @SerializedName("message")
  private String message = null;

  @SerializedName("feature-name")
  private String featureName = null;

  @SerializedName("device-id")
  private String deviceId = null;

  public GetFpHiscmdInput pageNum(Integer pageNum) {
    this.pageNum = pageNum;
    return this;
  }

   /**
   * Sorting condition: page number.
   * minimum: 1
   * maximum: 2147483647
   * @return pageNum
  **/
  @ApiModelProperty(value = "Sorting condition: page number.")
  public Integer getPageNum() {
    return pageNum;
  }

  public void setPageNum(Integer pageNum) {
    this.pageNum = pageNum;
  }

  public GetFpHiscmdInput result(ResultEnum result) {
    this.result = result;
    return this;
  }

   /**
   * Search criteria: processing result.
   * @return result
  **/
  @ApiModelProperty(value = "Search criteria: processing result.")
  public ResultEnum getResult() {
    return result;
  }

  public void setResult(ResultEnum result) {
    this.result = result;
  }

  public GetFpHiscmdInput startTime(Long startTime) {
    this.startTime = startTime;
    return this;
  }

   /**
   * Search criteria: first record time.
   * minimum: -9223372036854775808
   * maximum: -9223372036854775808
   * @return startTime
  **/
  @ApiModelProperty(value = "Search criteria: first record time.")
  public Long getStartTime() {
    return startTime;
  }

  public void setStartTime(Long startTime) {
    this.startTime = startTime;
  }

  public GetFpHiscmdInput endTime(Long endTime) {
    this.endTime = endTime;
    return this;
  }

   /**
   * Search criteria: last record time.
   * minimum: -9223372036854775808
   * maximum: -9223372036854775808
   * @return endTime
  **/
  @ApiModelProperty(value = "Search criteria: last record time.")
  public Long getEndTime() {
    return endTime;
  }

  public void setEndTime(Long endTime) {
    this.endTime = endTime;
  }

  public GetFpHiscmdInput pageLine(Integer pageLine) {
    this.pageLine = pageLine;
    return this;
  }

   /**
   * Sorting criteria: number of records per page.
   * minimum: 1
   * maximum: 2147483647
   * @return pageLine
  **/
  @ApiModelProperty(value = "Sorting criteria: number of records per page.")
  public Integer getPageLine() {
    return pageLine;
  }

  public void setPageLine(Integer pageLine) {
    this.pageLine = pageLine;
  }

  public GetFpHiscmdInput message(String message) {
    this.message = message;
    return this;
  }

   /**
   * Search criteria: message body details.
   * @return message
  **/
  @ApiModelProperty(value = "Search criteria: message body details.")
  public String getMessage() {
    return message;
  }

  public void setMessage(String message) {
    this.message = message;
  }

  public GetFpHiscmdInput featureName(String featureName) {
    this.featureName = featureName;
    return this;
  }

   /**
   * Search criteria: feature name.
   * @return featureName
  **/
  @ApiModelProperty(value = "Search criteria: feature name.")
  public String getFeatureName() {
    return featureName;
  }

  public void setFeatureName(String featureName) {
    this.featureName = featureName;
  }

  public GetFpHiscmdInput deviceId(String deviceId) {
    this.deviceId = deviceId;
    return this;
  }

   /**
   * Search criteria: device ID.
   * @return deviceId
  **/
  @ApiModelProperty(value = "Search criteria: device ID.")
  public String getDeviceId() {
    return deviceId;
  }

  public void setDeviceId(String deviceId) {
    this.deviceId = deviceId;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetFpHiscmdInput getFpHiscmdInput = (GetFpHiscmdInput) o;
    return Objects.equals(this.pageNum, getFpHiscmdInput.pageNum) &&
        Objects.equals(this.result, getFpHiscmdInput.result) &&
        Objects.equals(this.startTime, getFpHiscmdInput.startTime) &&
        Objects.equals(this.endTime, getFpHiscmdInput.endTime) &&
        Objects.equals(this.pageLine, getFpHiscmdInput.pageLine) &&
        Objects.equals(this.message, getFpHiscmdInput.message) &&
        Objects.equals(this.featureName, getFpHiscmdInput.featureName) &&
        Objects.equals(this.deviceId, getFpHiscmdInput.deviceId);
  }

  @Override
  public int hashCode() {
    return Objects.hash(pageNum, result, startTime, endTime, pageLine, message, featureName, deviceId);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetFpHiscmdInput {\n");
    
    sb.append("    pageNum: ").append(toIndentedString(pageNum)).append("\n");
    sb.append("    result: ").append(toIndentedString(result)).append("\n");
    sb.append("    startTime: ").append(toIndentedString(startTime)).append("\n");
    sb.append("    endTime: ").append(toIndentedString(endTime)).append("\n");
    sb.append("    pageLine: ").append(toIndentedString(pageLine)).append("\n");
    sb.append("    message: ").append(toIndentedString(message)).append("\n");
    sb.append("    featureName: ").append(toIndentedString(featureName)).append("\n");
    sb.append("    deviceId: ").append(toIndentedString(deviceId)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

