/*
 * Resource Management
 * Resource management APIs: · Create a Resource Pool · Apply for Resources · Release Resources · Release Resources Based on User Information · Query Resource Usage · Delete a Resource Pool 
 *
 * OpenAPI spec version: 1.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import com.huawei.aoc.api.model.UrlFilterMaps;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * GetResourceUsageInput
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-12-28T20:54:54.962+08:00")
public class GetResourceUsageInput {
  @SerializedName("page-num")
  private Integer pageNum = null;

  /**
   * URL-based sorting in ascending or descending order.
   */
  @JsonAdapter(SortTypeEnum.Adapter.class)
  public enum SortTypeEnum {
    ASC("ASC"),
    
    DESC("DESC");

    private String value;

    SortTypeEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static SortTypeEnum fromValue(String text) {
      for (SortTypeEnum b : SortTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<SortTypeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final SortTypeEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public SortTypeEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return SortTypeEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("sort-type")
  private SortTypeEnum sortType = null;

  @SerializedName("limit")
  private Integer limit = null;

  @SerializedName("url-filter-maps")
  private List<UrlFilterMaps> urlFilterMaps = null;

  @SerializedName("tid")
  private String tid = null;

  public GetResourceUsageInput pageNum(Integer pageNum) {
    this.pageNum = pageNum;
    return this;
  }

   /**
   * Current page number.
   * minimum: -2147483648
   * maximum: 2147483647
   * @return pageNum
  **/
  @ApiModelProperty(value = "Current page number.")
  public Integer getPageNum() {
    return pageNum;
  }

  public void setPageNum(Integer pageNum) {
    this.pageNum = pageNum;
  }

  public GetResourceUsageInput sortType(SortTypeEnum sortType) {
    this.sortType = sortType;
    return this;
  }

   /**
   * URL-based sorting in ascending or descending order.
   * @return sortType
  **/
  @ApiModelProperty(value = "URL-based sorting in ascending or descending order.")
  public SortTypeEnum getSortType() {
    return sortType;
  }

  public void setSortType(SortTypeEnum sortType) {
    this.sortType = sortType;
  }

  public GetResourceUsageInput limit(Integer limit) {
    this.limit = limit;
    return this;
  }

   /**
   * Number of records on each page.
   * minimum: 1
   * maximum: 100
   * @return limit
  **/
  @ApiModelProperty(value = "Number of records on each page.")
  public Integer getLimit() {
    return limit;
  }

  public void setLimit(Integer limit) {
    this.limit = limit;
  }

  public GetResourceUsageInput urlFilterMaps(List<UrlFilterMaps> urlFilterMaps) {
    this.urlFilterMaps = urlFilterMaps;
    return this;
  }

  public GetResourceUsageInput addUrlFilterMapsItem(UrlFilterMaps urlFilterMapsItem) {
    if (this.urlFilterMaps == null) {
      this.urlFilterMaps = new ArrayList<UrlFilterMaps>();
    }
    this.urlFilterMaps.add(urlFilterMapsItem);
    return this;
  }

   /**
   * Get urlFilterMaps
   * @return urlFilterMaps
  **/
  @ApiModelProperty(value = "")
  public List<UrlFilterMaps> getUrlFilterMaps() {
    return urlFilterMaps;
  }

  public void setUrlFilterMaps(List<UrlFilterMaps> urlFilterMaps) {
    this.urlFilterMaps = urlFilterMaps;
  }

  public GetResourceUsageInput tid(String tid) {
    this.tid = tid;
    return this;
  }

   /**
   * Distributed or global transaction ID.
   * @return tid
  **/
  @ApiModelProperty(value = "Distributed or global transaction ID.")
  public String getTid() {
    return tid;
  }

  public void setTid(String tid) {
    this.tid = tid;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetResourceUsageInput getResourceUsageInput = (GetResourceUsageInput) o;
    return Objects.equals(this.pageNum, getResourceUsageInput.pageNum) &&
        Objects.equals(this.sortType, getResourceUsageInput.sortType) &&
        Objects.equals(this.limit, getResourceUsageInput.limit) &&
        Objects.equals(this.urlFilterMaps, getResourceUsageInput.urlFilterMaps) &&
        Objects.equals(this.tid, getResourceUsageInput.tid);
  }

  @Override
  public int hashCode() {
    return Objects.hash(pageNum, sortType, limit, urlFilterMaps, tid);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetResourceUsageInput {\n");
    
    sb.append("    pageNum: ").append(toIndentedString(pageNum)).append("\n");
    sb.append("    sortType: ").append(toIndentedString(sortType)).append("\n");
    sb.append("    limit: ").append(toIndentedString(limit)).append("\n");
    sb.append("    urlFilterMaps: ").append(toIndentedString(urlFilterMaps)).append("\n");
    sb.append("    tid: ").append(toIndentedString(tid)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

