/*
 * Device Management
 * Device management APIs, including: Creating, deleting, modifying, viewing, and importing NEs  ** SLA: **  |SLA item|Definition| |-----|-----| |Request success rate| ≥ 99%| |Availability|Tier2| |Data consistency|Eventually consistent, inconsistent duration <1 minute| |Throughput|1000 tps| |TP50 request delay|200 ms| |TP99.9 request delay|1000 ms| 
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * Basic information in the device list.
 */
@ApiModel(description = "Basic information in the device list.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-12-28T21:10:14.216+08:00")
public class NEBasicInfoDTO {
  @SerializedName("neResId")
  private String neResId = null;

  @SerializedName("name")
  private String name = null;

  @SerializedName("typeName")
  private String typeName = null;

  @SerializedName("ipv4Addr")
  private String ipv4Addr = null;

  @SerializedName("softwareVersion")
  private String softwareVersion = null;

  @SerializedName("manufacturer")
  private String manufacturer = null;

  @SerializedName("mac")
  private String mac = null;

  @SerializedName("esn")
  private String esn = null;

  @SerializedName("commuParamTypes")
  private List<String> commuParamTypes = null;

  @SerializedName("communicationStatus")
  private Integer communicationStatus = null;

  public NEBasicInfoDTO neResId(String neResId) {
    this.neResId = neResId;
    return this;
  }

   /**
   * Device ID.
   * @return neResId
  **/
  @ApiModelProperty(value = "Device ID.")
  public String getNeResId() {
    return neResId;
  }

  public void setNeResId(String neResId) {
    this.neResId = neResId;
  }

  public NEBasicInfoDTO name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Device name.
   * @return name
  **/
  @ApiModelProperty(value = "Device name.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public NEBasicInfoDTO typeName(String typeName) {
    this.typeName = typeName;
    return this;
  }

   /**
   * Device type name.
   * @return typeName
  **/
  @ApiModelProperty(value = "Device type name.")
  public String getTypeName() {
    return typeName;
  }

  public void setTypeName(String typeName) {
    this.typeName = typeName;
  }

  public NEBasicInfoDTO ipv4Addr(String ipv4Addr) {
    this.ipv4Addr = ipv4Addr;
    return this;
  }

   /**
   * Device IPv4 address.
   * @return ipv4Addr
  **/
  @ApiModelProperty(value = "Device IPv4 address.")
  public String getIpv4Addr() {
    return ipv4Addr;
  }

  public void setIpv4Addr(String ipv4Addr) {
    this.ipv4Addr = ipv4Addr;
  }

  public NEBasicInfoDTO softwareVersion(String softwareVersion) {
    this.softwareVersion = softwareVersion;
    return this;
  }

   /**
   * Device software version number.
   * @return softwareVersion
  **/
  @ApiModelProperty(value = "Device software version number.")
  public String getSoftwareVersion() {
    return softwareVersion;
  }

  public void setSoftwareVersion(String softwareVersion) {
    this.softwareVersion = softwareVersion;
  }

  public NEBasicInfoDTO manufacturer(String manufacturer) {
    this.manufacturer = manufacturer;
    return this;
  }

   /**
   * Vendor.
   * @return manufacturer
  **/
  @ApiModelProperty(value = "Vendor.")
  public String getManufacturer() {
    return manufacturer;
  }

  public void setManufacturer(String manufacturer) {
    this.manufacturer = manufacturer;
  }

  public NEBasicInfoDTO mac(String mac) {
    this.mac = mac;
    return this;
  }

   /**
   * Bridge MAC address.
   * @return mac
  **/
  @ApiModelProperty(value = "Bridge MAC address.")
  public String getMac() {
    return mac;
  }

  public void setMac(String mac) {
    this.mac = mac;
  }

  public NEBasicInfoDTO esn(String esn) {
    this.esn = esn;
    return this;
  }

   /**
   * ESN.
   * @return esn
  **/
  @ApiModelProperty(value = "ESN.")
  public String getEsn() {
    return esn;
  }

  public void setEsn(String esn) {
    this.esn = esn;
  }

  public NEBasicInfoDTO commuParamTypes(List<String> commuParamTypes) {
    this.commuParamTypes = commuParamTypes;
    return this;
  }

  public NEBasicInfoDTO addCommuParamTypesItem(String commuParamTypesItem) {
    if (this.commuParamTypes == null) {
      this.commuParamTypes = new ArrayList<String>();
    }
    this.commuParamTypes.add(commuParamTypesItem);
    return this;
  }

   /**
   * Device protocol type. The value can be SNMP, NETCONF, TELNET, STELNET, or QX.
   * @return commuParamTypes
  **/
  @ApiModelProperty(value = "Device protocol type. The value can be SNMP, NETCONF, TELNET, STELNET, or QX.")
  public List<String> getCommuParamTypes() {
    return commuParamTypes;
  }

  public void setCommuParamTypes(List<String> commuParamTypes) {
    this.commuParamTypes = commuParamTypes;
  }

  public NEBasicInfoDTO communicationStatus(Integer communicationStatus) {
    this.communicationStatus = communicationStatus;
    return this;
  }

   /**
   * Device connection status. The value can be 0 (OK) or 1 (abnormal).
   * @return communicationStatus
  **/
  @ApiModelProperty(value = "Device connection status. The value can be 0 (OK) or 1 (abnormal).")
  public Integer getCommunicationStatus() {
    return communicationStatus;
  }

  public void setCommunicationStatus(Integer communicationStatus) {
    this.communicationStatus = communicationStatus;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    NEBasicInfoDTO neBasicInfoDTO = (NEBasicInfoDTO) o;
    return Objects.equals(this.neResId, neBasicInfoDTO.neResId) &&
        Objects.equals(this.name, neBasicInfoDTO.name) &&
        Objects.equals(this.typeName, neBasicInfoDTO.typeName) &&
        Objects.equals(this.ipv4Addr, neBasicInfoDTO.ipv4Addr) &&
        Objects.equals(this.softwareVersion, neBasicInfoDTO.softwareVersion) &&
        Objects.equals(this.manufacturer, neBasicInfoDTO.manufacturer) &&
        Objects.equals(this.mac, neBasicInfoDTO.mac) &&
        Objects.equals(this.esn, neBasicInfoDTO.esn) &&
        Objects.equals(this.commuParamTypes, neBasicInfoDTO.commuParamTypes) &&
        Objects.equals(this.communicationStatus, neBasicInfoDTO.communicationStatus);
  }

  @Override
  public int hashCode() {
    return Objects.hash(neResId, name, typeName, ipv4Addr, softwareVersion, manufacturer, mac, esn, commuParamTypes, communicationStatus);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class NEBasicInfoDTO {\n");
    
    sb.append("    neResId: ").append(toIndentedString(neResId)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    typeName: ").append(toIndentedString(typeName)).append("\n");
    sb.append("    ipv4Addr: ").append(toIndentedString(ipv4Addr)).append("\n");
    sb.append("    softwareVersion: ").append(toIndentedString(softwareVersion)).append("\n");
    sb.append("    manufacturer: ").append(toIndentedString(manufacturer)).append("\n");
    sb.append("    mac: ").append(toIndentedString(mac)).append("\n");
    sb.append("    esn: ").append(toIndentedString(esn)).append("\n");
    sb.append("    commuParamTypes: ").append(toIndentedString(commuParamTypes)).append("\n");
    sb.append("    communicationStatus: ").append(toIndentedString(communicationStatus)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

