/*
 * Device Management
 * Device management APIs, including: Creating, deleting, modifying, viewing, and importing NEs  ** SLA: **  |SLA item|Definition| |-----|-----| |Request success rate| ≥ 99%| |Availability|Tier2| |Data consistency|Eventually consistent, inconsistent duration <1 minute| |Throughput|1000 tps| |TP50 request delay|200 ms| |TP99.9 request delay|1000 ms| 
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import com.huawei.aoc.api.model.NECommonParamContent;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * Device communication parameter.
 */
@ApiModel(description = "Device communication parameter.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-12-28T21:10:14.216+08:00")
public class NECommuParamDTO {
  @SerializedName("neResId")
  private String neResId = null;

  @SerializedName("neNativeId")
  private String neNativeId = null;

  @SerializedName("neIP")
  private String neIP = null;

  @SerializedName("commuParamType")
  private String commuParamType = null;

  @SerializedName("commuParamRemark")
  private String commuParamRemark = null;

  @SerializedName("commuParamContent")
  private NECommonParamContent commuParamContent = null;

  public NECommuParamDTO neResId(String neResId) {
    this.neResId = neResId;
    return this;
  }

   /**
   * Device ID.
   * @return neResId
  **/
  @ApiModelProperty(value = "Device ID.")
  public String getNeResId() {
    return neResId;
  }

  public void setNeResId(String neResId) {
    this.neResId = neResId;
  }

  public NECommuParamDTO neNativeId(String neNativeId) {
    this.neNativeId = neNativeId;
    return this;
  }

   /**
   * Device FDN.
   * @return neNativeId
  **/
  @ApiModelProperty(value = "Device FDN.")
  public String getNeNativeId() {
    return neNativeId;
  }

  public void setNeNativeId(String neNativeId) {
    this.neNativeId = neNativeId;
  }

  public NECommuParamDTO neIP(String neIP) {
    this.neIP = neIP;
    return this;
  }

   /**
   * IP address.
   * @return neIP
  **/
  @ApiModelProperty(value = "IP address.")
  public String getNeIP() {
    return neIP;
  }

  public void setNeIP(String neIP) {
    this.neIP = neIP;
  }

  public NECommuParamDTO commuParamType(String commuParamType) {
    this.commuParamType = commuParamType;
    return this;
  }

   /**
   * Protocol type. The value can be SNMP, NETCONF, TELNET, STELNET, or QX.
   * @return commuParamType
  **/
  @ApiModelProperty(value = "Protocol type. The value can be SNMP, NETCONF, TELNET, STELNET, or QX.")
  public String getCommuParamType() {
    return commuParamType;
  }

  public void setCommuParamType(String commuParamType) {
    this.commuParamType = commuParamType;
  }

  public NECommuParamDTO commuParamRemark(String commuParamRemark) {
    this.commuParamRemark = commuParamRemark;
    return this;
  }

   /**
   * Function.
   * @return commuParamRemark
  **/
  @ApiModelProperty(value = "Function.")
  public String getCommuParamRemark() {
    return commuParamRemark;
  }

  public void setCommuParamRemark(String commuParamRemark) {
    this.commuParamRemark = commuParamRemark;
  }

  public NECommuParamDTO commuParamContent(NECommonParamContent commuParamContent) {
    this.commuParamContent = commuParamContent;
    return this;
  }

   /**
   * Get commuParamContent
   * @return commuParamContent
  **/
  @ApiModelProperty(value = "")
  public NECommonParamContent getCommuParamContent() {
    return commuParamContent;
  }

  public void setCommuParamContent(NECommonParamContent commuParamContent) {
    this.commuParamContent = commuParamContent;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    NECommuParamDTO neCommuParamDTO = (NECommuParamDTO) o;
    return Objects.equals(this.neResId, neCommuParamDTO.neResId) &&
        Objects.equals(this.neNativeId, neCommuParamDTO.neNativeId) &&
        Objects.equals(this.neIP, neCommuParamDTO.neIP) &&
        Objects.equals(this.commuParamType, neCommuParamDTO.commuParamType) &&
        Objects.equals(this.commuParamRemark, neCommuParamDTO.commuParamRemark) &&
        Objects.equals(this.commuParamContent, neCommuParamDTO.commuParamContent);
  }

  @Override
  public int hashCode() {
    return Objects.hash(neResId, neNativeId, neIP, commuParamType, commuParamRemark, commuParamContent);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class NECommuParamDTO {\n");
    
    sb.append("    neResId: ").append(toIndentedString(neResId)).append("\n");
    sb.append("    neNativeId: ").append(toIndentedString(neNativeId)).append("\n");
    sb.append("    neIP: ").append(toIndentedString(neIP)).append("\n");
    sb.append("    commuParamType: ").append(toIndentedString(commuParamType)).append("\n");
    sb.append("    commuParamRemark: ").append(toIndentedString(commuParamRemark)).append("\n");
    sb.append("    commuParamContent: ").append(toIndentedString(commuParamContent)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

