/*
 * Device Management
 * Device management APIs, including: Creating, deleting, modifying, viewing, and importing NEs  ** SLA: **  |SLA item|Definition| |-----|-----| |Request success rate| ≥ 99%| |Availability|Tier2| |Data consistency|Eventually consistent, inconsistent duration <1 minute| |Throughput|1000 tps| |TP50 request delay|200 ms| |TP99.9 request delay|1000 ms| 
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * Device search criteria.
 */
@ApiModel(description = "Device search criteria.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-12-28T21:10:14.216+08:00")
public class NEFilter {
  @SerializedName("name")
  private String name = null;

  @SerializedName("typeName")
  private String typeName = null;

  @SerializedName("ipv4Addr")
  private String ipv4Addr = null;

  @SerializedName("neResIds")
  private List<String> neResIds = null;

  public NEFilter name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Device name.
   * @return name
  **/
  @ApiModelProperty(value = "Device name.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public NEFilter typeName(String typeName) {
    this.typeName = typeName;
    return this;
  }

   /**
   * Device type name.
   * @return typeName
  **/
  @ApiModelProperty(value = "Device type name.")
  public String getTypeName() {
    return typeName;
  }

  public void setTypeName(String typeName) {
    this.typeName = typeName;
  }

  public NEFilter ipv4Addr(String ipv4Addr) {
    this.ipv4Addr = ipv4Addr;
    return this;
  }

   /**
   * Device IPv4 address.
   * @return ipv4Addr
  **/
  @ApiModelProperty(value = "Device IPv4 address.")
  public String getIpv4Addr() {
    return ipv4Addr;
  }

  public void setIpv4Addr(String ipv4Addr) {
    this.ipv4Addr = ipv4Addr;
  }

  public NEFilter neResIds(List<String> neResIds) {
    this.neResIds = neResIds;
    return this;
  }

  public NEFilter addNeResIdsItem(String neResIdsItem) {
    if (this.neResIds == null) {
      this.neResIds = new ArrayList<String>();
    }
    this.neResIds.add(neResIdsItem);
    return this;
  }

   /**
   * Device ID list.
   * @return neResIds
  **/
  @ApiModelProperty(value = "Device ID list.")
  public List<String> getNeResIds() {
    return neResIds;
  }

  public void setNeResIds(List<String> neResIds) {
    this.neResIds = neResIds;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    NEFilter neFilter = (NEFilter) o;
    return Objects.equals(this.name, neFilter.name) &&
        Objects.equals(this.typeName, neFilter.typeName) &&
        Objects.equals(this.ipv4Addr, neFilter.ipv4Addr) &&
        Objects.equals(this.neResIds, neFilter.neResIds);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, typeName, ipv4Addr, neResIds);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class NEFilter {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    typeName: ").append(toIndentedString(typeName)).append("\n");
    sb.append("    ipv4Addr: ").append(toIndentedString(ipv4Addr)).append("\n");
    sb.append("    neResIds: ").append(toIndentedString(neResIds)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

