/*
 * Application Templates
 * · Create an Application Template Instance · Update an Application Template · Query a Template in Use · Query a Template Group in Use · Query Parameters in Use · Submit an Application Template · Cancel an Application Template · Query Available Templates · Query Available Template Groups · Query Driver ID Details · Preview the Device List · Query Configurations Based on a Device · Query Parameters Based on a Device · Modify Parameters Based on a Device · Query NE Task Overview · Query NE Task Details 
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import com.huawei.aoc.api.model.ConditionsResult;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * PreviewDeviceListReq
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-12-28T20:43:49.954+08:00")
public class PreviewDeviceListReq {
  @SerializedName("app-id")
  private String appId = null;

  @SerializedName("conditions")
  private List<ConditionsResult> conditions = null;

  @SerializedName("page-index")
  private Integer pageIndex = null;

  @SerializedName("page-size")
  private Integer pageSize = null;

  /**
   * Sorting criteria, Ascending order; Descending order.
   */
  @JsonAdapter(SortModeEnum.Adapter.class)
  public enum SortModeEnum {
    ASC("ASC"),
    
    DESC("DESC");

    private String value;

    SortModeEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static SortModeEnum fromValue(String text) {
      for (SortModeEnum b : SortModeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<SortModeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final SortModeEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public SortModeEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return SortModeEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("sort-mode")
  private SortModeEnum sortMode = null;

  /**
   * Sorting criteria, sort by parameter name.
   */
  @JsonAdapter(SortFieldEnum.Adapter.class)
  public enum SortFieldEnum {
    PARAMETERKEY("PARAMETERKEY");

    private String value;

    SortFieldEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static SortFieldEnum fromValue(String text) {
      for (SortFieldEnum b : SortFieldEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<SortFieldEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final SortFieldEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public SortFieldEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return SortFieldEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("sort-field")
  private SortFieldEnum sortField = null;

  public PreviewDeviceListReq appId(String appId) {
    this.appId = appId;
    return this;
  }

   /**
   * Temporary application ID.
   * @return appId
  **/
  @ApiModelProperty(required = true, value = "Temporary application ID.")
  public String getAppId() {
    return appId;
  }

  public void setAppId(String appId) {
    this.appId = appId;
  }

  public PreviewDeviceListReq conditions(List<ConditionsResult> conditions) {
    this.conditions = conditions;
    return this;
  }

  public PreviewDeviceListReq addConditionsItem(ConditionsResult conditionsItem) {
    if (this.conditions == null) {
      this.conditions = new ArrayList<ConditionsResult>();
    }
    this.conditions.add(conditionsItem);
    return this;
  }

   /**
   * Filter criteria.
   * @return conditions
  **/
  @ApiModelProperty(value = "Filter criteria.")
  public List<ConditionsResult> getConditions() {
    return conditions;
  }

  public void setConditions(List<ConditionsResult> conditions) {
    this.conditions = conditions;
  }

  public PreviewDeviceListReq pageIndex(Integer pageIndex) {
    this.pageIndex = pageIndex;
    return this;
  }

   /**
   * Pagination criteria, page index.
   * @return pageIndex
  **/
  @ApiModelProperty(value = "Pagination criteria, page index.")
  public Integer getPageIndex() {
    return pageIndex;
  }

  public void setPageIndex(Integer pageIndex) {
    this.pageIndex = pageIndex;
  }

  public PreviewDeviceListReq pageSize(Integer pageSize) {
    this.pageSize = pageSize;
    return this;
  }

   /**
   * Pagination criteria, page size.
   * @return pageSize
  **/
  @ApiModelProperty(value = "Pagination criteria, page size.")
  public Integer getPageSize() {
    return pageSize;
  }

  public void setPageSize(Integer pageSize) {
    this.pageSize = pageSize;
  }

  public PreviewDeviceListReq sortMode(SortModeEnum sortMode) {
    this.sortMode = sortMode;
    return this;
  }

   /**
   * Sorting criteria, Ascending order; Descending order.
   * @return sortMode
  **/
  @ApiModelProperty(value = "Sorting criteria, Ascending order; Descending order.")
  public SortModeEnum getSortMode() {
    return sortMode;
  }

  public void setSortMode(SortModeEnum sortMode) {
    this.sortMode = sortMode;
  }

  public PreviewDeviceListReq sortField(SortFieldEnum sortField) {
    this.sortField = sortField;
    return this;
  }

   /**
   * Sorting criteria, sort by parameter name.
   * @return sortField
  **/
  @ApiModelProperty(value = "Sorting criteria, sort by parameter name.")
  public SortFieldEnum getSortField() {
    return sortField;
  }

  public void setSortField(SortFieldEnum sortField) {
    this.sortField = sortField;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PreviewDeviceListReq previewDeviceListReq = (PreviewDeviceListReq) o;
    return Objects.equals(this.appId, previewDeviceListReq.appId) &&
        Objects.equals(this.conditions, previewDeviceListReq.conditions) &&
        Objects.equals(this.pageIndex, previewDeviceListReq.pageIndex) &&
        Objects.equals(this.pageSize, previewDeviceListReq.pageSize) &&
        Objects.equals(this.sortMode, previewDeviceListReq.sortMode) &&
        Objects.equals(this.sortField, previewDeviceListReq.sortField);
  }

  @Override
  public int hashCode() {
    return Objects.hash(appId, conditions, pageIndex, pageSize, sortMode, sortField);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PreviewDeviceListReq {\n");
    
    sb.append("    appId: ").append(toIndentedString(appId)).append("\n");
    sb.append("    conditions: ").append(toIndentedString(conditions)).append("\n");
    sb.append("    pageIndex: ").append(toIndentedString(pageIndex)).append("\n");
    sb.append("    pageSize: ").append(toIndentedString(pageSize)).append("\n");
    sb.append("    sortMode: ").append(toIndentedString(sortMode)).append("\n");
    sb.append("    sortField: ").append(toIndentedString(sortField)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

