/*
 * Application Templates
 * · Create an Application Template Instance · Update an Application Template · Query a Template in Use · Query a Template Group in Use · Query Parameters in Use · Submit an Application Template · Cancel an Application Template · Query Available Templates · Query Available Template Groups · Query Driver ID Details · Preview the Device List · Query Configurations Based on a Device · Query Parameters Based on a Device · Modify Parameters Based on a Device · Query NE Task Overview · Query NE Task Details 
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * QueryDeviceConfigurationReq
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-12-28T20:43:49.954+08:00")
public class QueryDeviceConfigurationReq {
  @SerializedName("app-id")
  private String appId = null;

  /**
   * Application object, device; network.
   */
  @JsonAdapter(AppTypeEnum.Adapter.class)
  public enum AppTypeEnum {
    DEVICE("DEVICE"),
    
    SERVICE("SERVICE");

    private String value;

    AppTypeEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static AppTypeEnum fromValue(String text) {
      for (AppTypeEnum b : AppTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<AppTypeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final AppTypeEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public AppTypeEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return AppTypeEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("app-type")
  private AppTypeEnum appType = null;

  @SerializedName("device-id")
  private String deviceId = null;

  @SerializedName("dad-id")
  private String dadId = null;

  @SerializedName("is-submit")
  private Boolean isSubmit = null;

  public QueryDeviceConfigurationReq appId(String appId) {
    this.appId = appId;
    return this;
  }

   /**
   * Temporary application ID.
   * @return appId
  **/
  @ApiModelProperty(required = true, value = "Temporary application ID.")
  public String getAppId() {
    return appId;
  }

  public void setAppId(String appId) {
    this.appId = appId;
  }

  public QueryDeviceConfigurationReq appType(AppTypeEnum appType) {
    this.appType = appType;
    return this;
  }

   /**
   * Application object, device; network.
   * @return appType
  **/
  @ApiModelProperty(required = true, value = "Application object, device; network.")
  public AppTypeEnum getAppType() {
    return appType;
  }

  public void setAppType(AppTypeEnum appType) {
    this.appType = appType;
  }

  public QueryDeviceConfigurationReq deviceId(String deviceId) {
    this.deviceId = deviceId;
    return this;
  }

   /**
   * Filter criteria, device ID.
   * @return deviceId
  **/
  @ApiModelProperty(value = "Filter criteria, device ID.")
  public String getDeviceId() {
    return deviceId;
  }

  public void setDeviceId(String deviceId) {
    this.deviceId = deviceId;
  }

  public QueryDeviceConfigurationReq dadId(String dadId) {
    this.dadId = dadId;
    return this;
  }

   /**
   * Filter criteria, driver ID.
   * @return dadId
  **/
  @ApiModelProperty(value = "Filter criteria, driver ID.")
  public String getDadId() {
    return dadId;
  }

  public void setDadId(String dadId) {
    this.dadId = dadId;
  }

  public QueryDeviceConfigurationReq isSubmit(Boolean isSubmit) {
    this.isSubmit = isSubmit;
    return this;
  }

   /**
   * Whether to submit to a device.
   * @return isSubmit
  **/
  @ApiModelProperty(required = true, value = "Whether to submit to a device.")
  public Boolean isIsSubmit() {
    return isSubmit;
  }

  public void setIsSubmit(Boolean isSubmit) {
    this.isSubmit = isSubmit;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    QueryDeviceConfigurationReq queryDeviceConfigurationReq = (QueryDeviceConfigurationReq) o;
    return Objects.equals(this.appId, queryDeviceConfigurationReq.appId) &&
        Objects.equals(this.appType, queryDeviceConfigurationReq.appType) &&
        Objects.equals(this.deviceId, queryDeviceConfigurationReq.deviceId) &&
        Objects.equals(this.dadId, queryDeviceConfigurationReq.dadId) &&
        Objects.equals(this.isSubmit, queryDeviceConfigurationReq.isSubmit);
  }

  @Override
  public int hashCode() {
    return Objects.hash(appId, appType, deviceId, dadId, isSubmit);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class QueryDeviceConfigurationReq {\n");
    
    sb.append("    appId: ").append(toIndentedString(appId)).append("\n");
    sb.append("    appType: ").append(toIndentedString(appType)).append("\n");
    sb.append("    deviceId: ").append(toIndentedString(deviceId)).append("\n");
    sb.append("    dadId: ").append(toIndentedString(dadId)).append("\n");
    sb.append("    isSubmit: ").append(toIndentedString(isSubmit)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

