/*
 * Application Templates
 * · Create an Application Template Instance · Update an Application Template · Query a Template in Use · Query a Template Group in Use · Query Parameters in Use · Submit an Application Template · Cancel an Application Template · Query Available Templates · Query Available Template Groups · Query Driver ID Details · Preview the Device List · Query Configurations Based on a Device · Query Parameters Based on a Device · Modify Parameters Based on a Device · Query NE Task Overview · Query NE Task Details 
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import com.huawei.aoc.api.model.FilterMaps;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * QueryNETaskOverviewReq
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-12-28T20:43:49.954+08:00")
public class QueryNETaskOverviewReq {
  @SerializedName("filter-maps")
  private List<FilterMaps> filterMaps = null;

  /**
   * Sorting field.
   */
  @JsonAdapter(SortFieldEnum.Adapter.class)
  public enum SortFieldEnum {
    STARTTIME("STARTTIME"),
    
    ENDTIME("ENDTIME");

    private String value;

    SortFieldEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static SortFieldEnum fromValue(String text) {
      for (SortFieldEnum b : SortFieldEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<SortFieldEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final SortFieldEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public SortFieldEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return SortFieldEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("sort-field")
  private SortFieldEnum sortField = null;

  /**
   * Sorting type, which can be ASC or DESC.
   */
  @JsonAdapter(SortModeEnum.Adapter.class)
  public enum SortModeEnum {
    ASC("ASC"),
    
    DESC("DESC");

    private String value;

    SortModeEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static SortModeEnum fromValue(String text) {
      for (SortModeEnum b : SortModeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<SortModeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final SortModeEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public SortModeEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return SortModeEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("sort-mode")
  private SortModeEnum sortMode = null;

  @SerializedName("offset")
  private Integer offset = 0;

  @SerializedName("limit")
  private Integer limit = 0;

  public QueryNETaskOverviewReq filterMaps(List<FilterMaps> filterMaps) {
    this.filterMaps = filterMaps;
    return this;
  }

  public QueryNETaskOverviewReq addFilterMapsItem(FilterMaps filterMapsItem) {
    if (this.filterMaps == null) {
      this.filterMaps = new ArrayList<FilterMaps>();
    }
    this.filterMaps.add(filterMapsItem);
    return this;
  }

   /**
   * Filter criteria.
   * @return filterMaps
  **/
  @ApiModelProperty(value = "Filter criteria.")
  public List<FilterMaps> getFilterMaps() {
    return filterMaps;
  }

  public void setFilterMaps(List<FilterMaps> filterMaps) {
    this.filterMaps = filterMaps;
  }

  public QueryNETaskOverviewReq sortField(SortFieldEnum sortField) {
    this.sortField = sortField;
    return this;
  }

   /**
   * Sorting field.
   * @return sortField
  **/
  @ApiModelProperty(value = "Sorting field.")
  public SortFieldEnum getSortField() {
    return sortField;
  }

  public void setSortField(SortFieldEnum sortField) {
    this.sortField = sortField;
  }

  public QueryNETaskOverviewReq sortMode(SortModeEnum sortMode) {
    this.sortMode = sortMode;
    return this;
  }

   /**
   * Sorting type, which can be ASC or DESC.
   * @return sortMode
  **/
  @ApiModelProperty(value = "Sorting type, which can be ASC or DESC.")
  public SortModeEnum getSortMode() {
    return sortMode;
  }

  public void setSortMode(SortModeEnum sortMode) {
    this.sortMode = sortMode;
  }

  public QueryNETaskOverviewReq offset(Integer offset) {
    this.offset = offset;
    return this;
  }

   /**
   * Page number.
   * @return offset
  **/
  @ApiModelProperty(value = "Page number.")
  public Integer getOffset() {
    return offset;
  }

  public void setOffset(Integer offset) {
    this.offset = offset;
  }

  public QueryNETaskOverviewReq limit(Integer limit) {
    this.limit = limit;
    return this;
  }

   /**
   * Number of records on each page.
   * @return limit
  **/
  @ApiModelProperty(value = "Number of records on each page.")
  public Integer getLimit() {
    return limit;
  }

  public void setLimit(Integer limit) {
    this.limit = limit;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    QueryNETaskOverviewReq queryNETaskOverviewReq = (QueryNETaskOverviewReq) o;
    return Objects.equals(this.filterMaps, queryNETaskOverviewReq.filterMaps) &&
        Objects.equals(this.sortField, queryNETaskOverviewReq.sortField) &&
        Objects.equals(this.sortMode, queryNETaskOverviewReq.sortMode) &&
        Objects.equals(this.offset, queryNETaskOverviewReq.offset) &&
        Objects.equals(this.limit, queryNETaskOverviewReq.limit);
  }

  @Override
  public int hashCode() {
    return Objects.hash(filterMaps, sortField, sortMode, offset, limit);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class QueryNETaskOverviewReq {\n");
    
    sb.append("    filterMaps: ").append(toIndentedString(filterMaps)).append("\n");
    sb.append("    sortField: ").append(toIndentedString(sortField)).append("\n");
    sb.append("    sortMode: ").append(toIndentedString(sortMode)).append("\n");
    sb.append("    offset: ").append(toIndentedString(offset)).append("\n");
    sb.append("    limit: ").append(toIndentedString(limit)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

