/*
 * Device RPC Operations and Data Query
 * APIs for device RPC operations and data query: · Device RPC Operations · Device Data Query 
 *
 * OpenAPI spec version: 1.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import com.huawei.aoc.api.model.RpcError;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * Result returned by a device.
 */
@ApiModel(description = "Result returned by a device.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-12-28T21:09:59.427+08:00")
public class RealDeviceCommonOutput {
  @SerializedName("replyOriginPkg")
  private String replyOriginPkg = null;

  /**
   * Packet processing result, which can be SUCCESS or FAILED.
   */
  @JsonAdapter(ResultEnum.Adapter.class)
  public enum ResultEnum {
    SUCCESS("SUCCESS"),
    
    FAILED("FAILED");

    private String value;

    ResultEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static ResultEnum fromValue(String text) {
      for (ResultEnum b : ResultEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<ResultEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final ResultEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public ResultEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return ResultEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("result")
  private ResultEnum result = null;

  @SerializedName("rpcError")
  private List<RpcError> rpcError = null;

  public RealDeviceCommonOutput replyOriginPkg(String replyOriginPkg) {
    this.replyOriginPkg = replyOriginPkg;
    return this;
  }

   /**
   * Original packet returned by a device.
   * @return replyOriginPkg
  **/
  @ApiModelProperty(value = "Original packet returned by a device.")
  public String getReplyOriginPkg() {
    return replyOriginPkg;
  }

  public void setReplyOriginPkg(String replyOriginPkg) {
    this.replyOriginPkg = replyOriginPkg;
  }

  public RealDeviceCommonOutput result(ResultEnum result) {
    this.result = result;
    return this;
  }

   /**
   * Packet processing result, which can be SUCCESS or FAILED.
   * @return result
  **/
  @ApiModelProperty(value = "Packet processing result, which can be SUCCESS or FAILED.")
  public ResultEnum getResult() {
    return result;
  }

  public void setResult(ResultEnum result) {
    this.result = result;
  }

  public RealDeviceCommonOutput rpcError(List<RpcError> rpcError) {
    this.rpcError = rpcError;
    return this;
  }

  public RealDeviceCommonOutput addRpcErrorItem(RpcError rpcErrorItem) {
    if (this.rpcError == null) {
      this.rpcError = new ArrayList<RpcError>();
    }
    this.rpcError.add(rpcErrorItem);
    return this;
  }

   /**
   * Causes for packet processing failure.
   * @return rpcError
  **/
  @ApiModelProperty(value = "Causes for packet processing failure.")
  public List<RpcError> getRpcError() {
    return rpcError;
  }

  public void setRpcError(List<RpcError> rpcError) {
    this.rpcError = rpcError;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    RealDeviceCommonOutput realDeviceCommonOutput = (RealDeviceCommonOutput) o;
    return Objects.equals(this.replyOriginPkg, realDeviceCommonOutput.replyOriginPkg) &&
        Objects.equals(this.result, realDeviceCommonOutput.result) &&
        Objects.equals(this.rpcError, realDeviceCommonOutput.rpcError);
  }

  @Override
  public int hashCode() {
    return Objects.hash(replyOriginPkg, result, rpcError);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class RealDeviceCommonOutput {\n");
    
    sb.append("    replyOriginPkg: ").append(toIndentedString(replyOriginPkg)).append("\n");
    sb.append("    result: ").append(toIndentedString(result)).append("\n");
    sb.append("    rpcError: ").append(toIndentedString(rpcError)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

