/*
 * Device RPC Operations and Data Query
 * APIs for device RPC operations and data query: · Device RPC Operations · Device Data Query 
 *
 * OpenAPI spec version: 1.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import com.huawei.aoc.api.model.ExtentAttr;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * Input for device query.
 */
@ApiModel(description = "Input for device query.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-12-28T21:09:59.427+08:00")
public class RealDeviceQueryInput {
  @SerializedName("neId")
  private String neId = null;

  @SerializedName("path")
  private String path = null;

  /**
   * Type of the data to be queried. The value can be configuration or status.
   */
  @JsonAdapter(LogicDataStoreTypeEnum.Adapter.class)
  public enum LogicDataStoreTypeEnum {
    CONFIGURATION("CONFIGURATION"),
    
    OPERATIONAL("OPERATIONAL");

    private String value;

    LogicDataStoreTypeEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static LogicDataStoreTypeEnum fromValue(String text) {
      for (LogicDataStoreTypeEnum b : LogicDataStoreTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<LogicDataStoreTypeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final LogicDataStoreTypeEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public LogicDataStoreTypeEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return LogicDataStoreTypeEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("logicDataStoreType")
  private LogicDataStoreTypeEnum logicDataStoreType = null;

  @SerializedName("timeOut")
  private Integer timeOut = null;

  /**
   * Filtering type. Currently, only the subtree mode is supported.
   */
  @JsonAdapter(FilterTypeEnum.Adapter.class)
  public enum FilterTypeEnum {
    SUBTREE("SUBTREE");

    private String value;

    FilterTypeEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static FilterTypeEnum fromValue(String text) {
      for (FilterTypeEnum b : FilterTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<FilterTypeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final FilterTypeEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public FilterTypeEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return FilterTypeEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("filterType")
  private FilterTypeEnum filterType = null;

  @SerializedName("filterContext")
  private String filterContext = null;

  @SerializedName("extendattr")
  private List<ExtentAttr> extendattr = null;

  public RealDeviceQueryInput neId(String neId) {
    this.neId = neId;
    return this;
  }

   /**
   * Device ID.
   * @return neId
  **/
  @ApiModelProperty(value = "Device ID.")
  public String getNeId() {
    return neId;
  }

  public void setNeId(String neId) {
    this.neId = neId;
  }

  public RealDeviceQueryInput path(String path) {
    this.path = path;
    return this;
  }

   /**
   * URL for querying a device.
   * @return path
  **/
  @ApiModelProperty(value = "URL for querying a device.")
  public String getPath() {
    return path;
  }

  public void setPath(String path) {
    this.path = path;
  }

  public RealDeviceQueryInput logicDataStoreType(LogicDataStoreTypeEnum logicDataStoreType) {
    this.logicDataStoreType = logicDataStoreType;
    return this;
  }

   /**
   * Type of the data to be queried. The value can be configuration or status.
   * @return logicDataStoreType
  **/
  @ApiModelProperty(value = "Type of the data to be queried. The value can be configuration or status.")
  public LogicDataStoreTypeEnum getLogicDataStoreType() {
    return logicDataStoreType;
  }

  public void setLogicDataStoreType(LogicDataStoreTypeEnum logicDataStoreType) {
    this.logicDataStoreType = logicDataStoreType;
  }

  public RealDeviceQueryInput timeOut(Integer timeOut) {
    this.timeOut = timeOut;
    return this;
  }

   /**
   * Timeout interval of the device query response.
   * @return timeOut
  **/
  @ApiModelProperty(value = "Timeout interval of the device query response.")
  public Integer getTimeOut() {
    return timeOut;
  }

  public void setTimeOut(Integer timeOut) {
    this.timeOut = timeOut;
  }

  public RealDeviceQueryInput filterType(FilterTypeEnum filterType) {
    this.filterType = filterType;
    return this;
  }

   /**
   * Filtering type. Currently, only the subtree mode is supported.
   * @return filterType
  **/
  @ApiModelProperty(value = "Filtering type. Currently, only the subtree mode is supported.")
  public FilterTypeEnum getFilterType() {
    return filterType;
  }

  public void setFilterType(FilterTypeEnum filterType) {
    this.filterType = filterType;
  }

  public RealDeviceQueryInput filterContext(String filterContext) {
    this.filterContext = filterContext;
    return this;
  }

   /**
   * Parameter content of the filter. If the subtree mode is used, the parameter content must be at the same level as the last node of the path. For example, if the path is ifm/interfaces/interface, set subtree to &lt;interface&gt;...&lt;/interface&gt;.
   * @return filterContext
  **/
  @ApiModelProperty(value = "Parameter content of the filter. If the subtree mode is used, the parameter content must be at the same level as the last node of the path. For example, if the path is ifm/interfaces/interface, set subtree to <interface>...</interface>.")
  public String getFilterContext() {
    return filterContext;
  }

  public void setFilterContext(String filterContext) {
    this.filterContext = filterContext;
  }

  public RealDeviceQueryInput extendattr(List<ExtentAttr> extendattr) {
    this.extendattr = extendattr;
    return this;
  }

  public RealDeviceQueryInput addExtendattrItem(ExtentAttr extendattrItem) {
    if (this.extendattr == null) {
      this.extendattr = new ArrayList<ExtentAttr>();
    }
    this.extendattr.add(extendattrItem);
    return this;
  }

   /**
   * Extension parameter.
   * @return extendattr
  **/
  @ApiModelProperty(value = "Extension parameter.")
  public List<ExtentAttr> getExtendattr() {
    return extendattr;
  }

  public void setExtendattr(List<ExtentAttr> extendattr) {
    this.extendattr = extendattr;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    RealDeviceQueryInput realDeviceQueryInput = (RealDeviceQueryInput) o;
    return Objects.equals(this.neId, realDeviceQueryInput.neId) &&
        Objects.equals(this.path, realDeviceQueryInput.path) &&
        Objects.equals(this.logicDataStoreType, realDeviceQueryInput.logicDataStoreType) &&
        Objects.equals(this.timeOut, realDeviceQueryInput.timeOut) &&
        Objects.equals(this.filterType, realDeviceQueryInput.filterType) &&
        Objects.equals(this.filterContext, realDeviceQueryInput.filterContext) &&
        Objects.equals(this.extendattr, realDeviceQueryInput.extendattr);
  }

  @Override
  public int hashCode() {
    return Objects.hash(neId, path, logicDataStoreType, timeOut, filterType, filterContext, extendattr);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class RealDeviceQueryInput {\n");
    
    sb.append("    neId: ").append(toIndentedString(neId)).append("\n");
    sb.append("    path: ").append(toIndentedString(path)).append("\n");
    sb.append("    logicDataStoreType: ").append(toIndentedString(logicDataStoreType)).append("\n");
    sb.append("    timeOut: ").append(toIndentedString(timeOut)).append("\n");
    sb.append("    filterType: ").append(toIndentedString(filterType)).append("\n");
    sb.append("    filterContext: ").append(toIndentedString(filterContext)).append("\n");
    sb.append("    extendattr: ").append(toIndentedString(extendattr)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

