/*
 * Device RPC Operations and Data Query
 * APIs for device RPC operations and data query: · Device RPC Operations · Device Data Query 
 *
 * OpenAPI spec version: 1.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import com.huawei.aoc.api.model.ExtentAttr;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * RPC interface input.
 */
@ApiModel(description = "RPC interface input.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-12-28T21:09:59.427+08:00")
public class RealDeviceRpcInput {
  @SerializedName("neId")
  private String neId = null;

  @SerializedName("path")
  private String path = null;

  @SerializedName("rpcInput")
  private String rpcInput = null;

  @SerializedName("timeOut")
  private Integer timeOut = null;

  @SerializedName("extendattr")
  private List<ExtentAttr> extendattr = null;

  public RealDeviceRpcInput neId(String neId) {
    this.neId = neId;
    return this;
  }

   /**
   * Device ID.
   * @return neId
  **/
  @ApiModelProperty(value = "Device ID.")
  public String getNeId() {
    return neId;
  }

  public void setNeId(String neId) {
    this.neId = neId;
  }

  public RealDeviceRpcInput path(String path) {
    this.path = path;
    return this;
  }

   /**
   * URL corresponding to the device RPC.
   * @return path
  **/
  @ApiModelProperty(value = "URL corresponding to the device RPC.")
  public String getPath() {
    return path;
  }

  public void setPath(String path) {
    this.path = path;
  }

  public RealDeviceRpcInput rpcInput(String rpcInput) {
    this.rpcInput = rpcInput;
    return this;
  }

   /**
   * Input data of the device RPC, in XML format.
   * @return rpcInput
  **/
  @ApiModelProperty(value = "Input data of the device RPC, in XML format.")
  public String getRpcInput() {
    return rpcInput;
  }

  public void setRpcInput(String rpcInput) {
    this.rpcInput = rpcInput;
  }

  public RealDeviceRpcInput timeOut(Integer timeOut) {
    this.timeOut = timeOut;
    return this;
  }

   /**
   * Timeout interval of the device RPC response.
   * @return timeOut
  **/
  @ApiModelProperty(value = "Timeout interval of the device RPC response.")
  public Integer getTimeOut() {
    return timeOut;
  }

  public void setTimeOut(Integer timeOut) {
    this.timeOut = timeOut;
  }

  public RealDeviceRpcInput extendattr(List<ExtentAttr> extendattr) {
    this.extendattr = extendattr;
    return this;
  }

  public RealDeviceRpcInput addExtendattrItem(ExtentAttr extendattrItem) {
    if (this.extendattr == null) {
      this.extendattr = new ArrayList<ExtentAttr>();
    }
    this.extendattr.add(extendattrItem);
    return this;
  }

   /**
   * Extension parameter.
   * @return extendattr
  **/
  @ApiModelProperty(value = "Extension parameter.")
  public List<ExtentAttr> getExtendattr() {
    return extendattr;
  }

  public void setExtendattr(List<ExtentAttr> extendattr) {
    this.extendattr = extendattr;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    RealDeviceRpcInput realDeviceRpcInput = (RealDeviceRpcInput) o;
    return Objects.equals(this.neId, realDeviceRpcInput.neId) &&
        Objects.equals(this.path, realDeviceRpcInput.path) &&
        Objects.equals(this.rpcInput, realDeviceRpcInput.rpcInput) &&
        Objects.equals(this.timeOut, realDeviceRpcInput.timeOut) &&
        Objects.equals(this.extendattr, realDeviceRpcInput.extendattr);
  }

  @Override
  public int hashCode() {
    return Objects.hash(neId, path, rpcInput, timeOut, extendattr);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class RealDeviceRpcInput {\n");
    
    sb.append("    neId: ").append(toIndentedString(neId)).append("\n");
    sb.append("    path: ").append(toIndentedString(path)).append("\n");
    sb.append("    rpcInput: ").append(toIndentedString(rpcInput)).append("\n");
    sb.append("    timeOut: ").append(toIndentedString(timeOut)).append("\n");
    sb.append("    extendattr: ").append(toIndentedString(extendattr)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

