/*
 * Resource Management
 * Resource management APIs: · Create a Resource Pool · Apply for Resources · Release Resources · Release Resources Based on User Information · Query Resource Usage · Delete a Resource Pool 
 *
 * OpenAPI spec version: 1.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import com.huawei.aoc.api.model.SegmentUsageInfo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * ResourceUsageInfo
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-12-28T20:54:54.962+08:00")
public class ResourceUsageInfo {
  @SerializedName("used-count")
  private Long usedCount = null;

  @SerializedName("used-percent")
  private Integer usedPercent = null;

  @SerializedName("segment-usage-info")
  private List<SegmentUsageInfo> segmentUsageInfo = null;

  @SerializedName("url")
  private String url = null;

  @SerializedName("capacity")
  private Long capacity = null;

  public ResourceUsageInfo usedCount(Long usedCount) {
    this.usedCount = usedCount;
    return this;
  }

   /**
   * Number of used resources.
   * minimum: -9223372036854775808
   * maximum: -9223372036854775808
   * @return usedCount
  **/
  @ApiModelProperty(value = "Number of used resources.")
  public Long getUsedCount() {
    return usedCount;
  }

  public void setUsedCount(Long usedCount) {
    this.usedCount = usedCount;
  }

  public ResourceUsageInfo usedPercent(Integer usedPercent) {
    this.usedPercent = usedPercent;
    return this;
  }

   /**
   * Percentage of used resources in the resource pool.
   * minimum: 0
   * maximum: 100
   * @return usedPercent
  **/
  @ApiModelProperty(value = "Percentage of used resources in the resource pool.")
  public Integer getUsedPercent() {
    return usedPercent;
  }

  public void setUsedPercent(Integer usedPercent) {
    this.usedPercent = usedPercent;
  }

  public ResourceUsageInfo segmentUsageInfo(List<SegmentUsageInfo> segmentUsageInfo) {
    this.segmentUsageInfo = segmentUsageInfo;
    return this;
  }

  public ResourceUsageInfo addSegmentUsageInfoItem(SegmentUsageInfo segmentUsageInfoItem) {
    if (this.segmentUsageInfo == null) {
      this.segmentUsageInfo = new ArrayList<SegmentUsageInfo>();
    }
    this.segmentUsageInfo.add(segmentUsageInfoItem);
    return this;
  }

   /**
   * Get segmentUsageInfo
   * @return segmentUsageInfo
  **/
  @ApiModelProperty(value = "")
  public List<SegmentUsageInfo> getSegmentUsageInfo() {
    return segmentUsageInfo;
  }

  public void setSegmentUsageInfo(List<SegmentUsageInfo> segmentUsageInfo) {
    this.segmentUsageInfo = segmentUsageInfo;
  }

  public ResourceUsageInfo url(String url) {
    this.url = url;
    return this;
  }

   /**
   * URL.
   * @return url
  **/
  @ApiModelProperty(value = "URL.")
  public String getUrl() {
    return url;
  }

  public void setUrl(String url) {
    this.url = url;
  }

  public ResourceUsageInfo capacity(Long capacity) {
    this.capacity = capacity;
    return this;
  }

   /**
   * Resource pool capacity.
   * minimum: -9223372036854775808
   * maximum: -9223372036854775808
   * @return capacity
  **/
  @ApiModelProperty(value = "Resource pool capacity.")
  public Long getCapacity() {
    return capacity;
  }

  public void setCapacity(Long capacity) {
    this.capacity = capacity;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ResourceUsageInfo resourceUsageInfo = (ResourceUsageInfo) o;
    return Objects.equals(this.usedCount, resourceUsageInfo.usedCount) &&
        Objects.equals(this.usedPercent, resourceUsageInfo.usedPercent) &&
        Objects.equals(this.segmentUsageInfo, resourceUsageInfo.segmentUsageInfo) &&
        Objects.equals(this.url, resourceUsageInfo.url) &&
        Objects.equals(this.capacity, resourceUsageInfo.capacity);
  }

  @Override
  public int hashCode() {
    return Objects.hash(usedCount, usedPercent, segmentUsageInfo, url, capacity);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ResourceUsageInfo {\n");
    
    sb.append("    usedCount: ").append(toIndentedString(usedCount)).append("\n");
    sb.append("    usedPercent: ").append(toIndentedString(usedPercent)).append("\n");
    sb.append("    segmentUsageInfo: ").append(toIndentedString(segmentUsageInfo)).append("\n");
    sb.append("    url: ").append(toIndentedString(url)).append("\n");
    sb.append("    capacity: ").append(toIndentedString(capacity)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

