/*
 * Device RPC Operations and Data Query
 * APIs for device RPC operations and data query: · Device RPC Operations · Device Data Query 
 *
 * OpenAPI spec version: 1.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * Error message.
 */
@ApiModel(description = "Error message.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-12-28T21:09:59.427+08:00")
public class RpcError {
  @SerializedName("tag")
  private String tag = null;

  @SerializedName("applicationTag")
  private String applicationTag = null;

  @SerializedName("message")
  private String message = null;

  @SerializedName("info")
  private String info = null;

  /**
   * Common rpcError field returned by a device.
   */
  @JsonAdapter(ErrorTypeEnum.Adapter.class)
  public enum ErrorTypeEnum {
    TRANSPORT("TRANSPORT"),
    
    RPC("RPC"),
    
    PROTOCOL("PROTOCOL"),
    
    APPLICATION("APPLICATION");

    private String value;

    ErrorTypeEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static ErrorTypeEnum fromValue(String text) {
      for (ErrorTypeEnum b : ErrorTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<ErrorTypeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final ErrorTypeEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public ErrorTypeEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return ErrorTypeEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("errorType")
  private ErrorTypeEnum errorType = null;

  @SerializedName("errorCode")
  private String errorCode = null;

  @SerializedName("errorStatus")
  private String errorStatus = null;

  /**
   * Common rpcError field returned by a device.
   */
  @JsonAdapter(ErrorSeverityEnum.Adapter.class)
  public enum ErrorSeverityEnum {
    ERROR("ERROR"),
    
    WARNING("WARNING");

    private String value;

    ErrorSeverityEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static ErrorSeverityEnum fromValue(String text) {
      for (ErrorSeverityEnum b : ErrorSeverityEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<ErrorSeverityEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final ErrorSeverityEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public ErrorSeverityEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return ErrorSeverityEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("errorSeverity")
  private ErrorSeverityEnum errorSeverity = null;

  @SerializedName("paras")
  private List<String> paras = null;

  @SerializedName("errorPath")
  private String errorPath = null;

  public RpcError tag(String tag) {
    this.tag = tag;
    return this;
  }

   /**
   * Common rpcError field returned by a device.
   * @return tag
  **/
  @ApiModelProperty(value = "Common rpcError field returned by a device.")
  public String getTag() {
    return tag;
  }

  public void setTag(String tag) {
    this.tag = tag;
  }

  public RpcError applicationTag(String applicationTag) {
    this.applicationTag = applicationTag;
    return this;
  }

   /**
   * Common rpcError field returned by a device.
   * @return applicationTag
  **/
  @ApiModelProperty(value = "Common rpcError field returned by a device.")
  public String getApplicationTag() {
    return applicationTag;
  }

  public void setApplicationTag(String applicationTag) {
    this.applicationTag = applicationTag;
  }

  public RpcError message(String message) {
    this.message = message;
    return this;
  }

   /**
   * Common rpcError field returned by a device.
   * @return message
  **/
  @ApiModelProperty(value = "Common rpcError field returned by a device.")
  public String getMessage() {
    return message;
  }

  public void setMessage(String message) {
    this.message = message;
  }

  public RpcError info(String info) {
    this.info = info;
    return this;
  }

   /**
   * Common rpcError field returned by a device.
   * @return info
  **/
  @ApiModelProperty(value = "Common rpcError field returned by a device.")
  public String getInfo() {
    return info;
  }

  public void setInfo(String info) {
    this.info = info;
  }

  public RpcError errorType(ErrorTypeEnum errorType) {
    this.errorType = errorType;
    return this;
  }

   /**
   * Common rpcError field returned by a device.
   * @return errorType
  **/
  @ApiModelProperty(value = "Common rpcError field returned by a device.")
  public ErrorTypeEnum getErrorType() {
    return errorType;
  }

  public void setErrorType(ErrorTypeEnum errorType) {
    this.errorType = errorType;
  }

  public RpcError errorCode(String errorCode) {
    this.errorCode = errorCode;
    return this;
  }

   /**
   * Common rpcError field returned by a device.
   * @return errorCode
  **/
  @ApiModelProperty(value = "Common rpcError field returned by a device.")
  public String getErrorCode() {
    return errorCode;
  }

  public void setErrorCode(String errorCode) {
    this.errorCode = errorCode;
  }

  public RpcError errorStatus(String errorStatus) {
    this.errorStatus = errorStatus;
    return this;
  }

   /**
   * Common rpcError field returned by a device.
   * @return errorStatus
  **/
  @ApiModelProperty(value = "Common rpcError field returned by a device.")
  public String getErrorStatus() {
    return errorStatus;
  }

  public void setErrorStatus(String errorStatus) {
    this.errorStatus = errorStatus;
  }

  public RpcError errorSeverity(ErrorSeverityEnum errorSeverity) {
    this.errorSeverity = errorSeverity;
    return this;
  }

   /**
   * Common rpcError field returned by a device.
   * @return errorSeverity
  **/
  @ApiModelProperty(value = "Common rpcError field returned by a device.")
  public ErrorSeverityEnum getErrorSeverity() {
    return errorSeverity;
  }

  public void setErrorSeverity(ErrorSeverityEnum errorSeverity) {
    this.errorSeverity = errorSeverity;
  }

  public RpcError paras(List<String> paras) {
    this.paras = paras;
    return this;
  }

  public RpcError addParasItem(String parasItem) {
    if (this.paras == null) {
      this.paras = new ArrayList<String>();
    }
    this.paras.add(parasItem);
    return this;
  }

   /**
   * List of error parameters.
   * @return paras
  **/
  @ApiModelProperty(value = "List of error parameters.")
  public List<String> getParas() {
    return paras;
  }

  public void setParas(List<String> paras) {
    this.paras = paras;
  }

  public RpcError errorPath(String errorPath) {
    this.errorPath = errorPath;
    return this;
  }

   /**
   * Common rpcError field returned by a device.
   * @return errorPath
  **/
  @ApiModelProperty(value = "Common rpcError field returned by a device.")
  public String getErrorPath() {
    return errorPath;
  }

  public void setErrorPath(String errorPath) {
    this.errorPath = errorPath;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    RpcError rpcError = (RpcError) o;
    return Objects.equals(this.tag, rpcError.tag) &&
        Objects.equals(this.applicationTag, rpcError.applicationTag) &&
        Objects.equals(this.message, rpcError.message) &&
        Objects.equals(this.info, rpcError.info) &&
        Objects.equals(this.errorType, rpcError.errorType) &&
        Objects.equals(this.errorCode, rpcError.errorCode) &&
        Objects.equals(this.errorStatus, rpcError.errorStatus) &&
        Objects.equals(this.errorSeverity, rpcError.errorSeverity) &&
        Objects.equals(this.paras, rpcError.paras) &&
        Objects.equals(this.errorPath, rpcError.errorPath);
  }

  @Override
  public int hashCode() {
    return Objects.hash(tag, applicationTag, message, info, errorType, errorCode, errorStatus, errorSeverity, paras, errorPath);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class RpcError {\n");
    
    sb.append("    tag: ").append(toIndentedString(tag)).append("\n");
    sb.append("    applicationTag: ").append(toIndentedString(applicationTag)).append("\n");
    sb.append("    message: ").append(toIndentedString(message)).append("\n");
    sb.append("    info: ").append(toIndentedString(info)).append("\n");
    sb.append("    errorType: ").append(toIndentedString(errorType)).append("\n");
    sb.append("    errorCode: ").append(toIndentedString(errorCode)).append("\n");
    sb.append("    errorStatus: ").append(toIndentedString(errorStatus)).append("\n");
    sb.append("    errorSeverity: ").append(toIndentedString(errorSeverity)).append("\n");
    sb.append("    paras: ").append(toIndentedString(paras)).append("\n");
    sb.append("    errorPath: ").append(toIndentedString(errorPath)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

