/*
 * Resource Management
 * Resource management APIs: · Create a Resource Pool · Apply for Resources · Release Resources · Release Resources Based on User Information · Query Resource Usage · Delete a Resource Pool 
 *
 * OpenAPI spec version: 1.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * SegmentUsageInfo
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-12-28T20:54:54.962+08:00")
public class SegmentUsageInfo {
  @SerializedName("segment-used-percent")
  private Integer segmentUsedPercent = null;

  @SerializedName("pool-end")
  private Long poolEnd = null;

  @SerializedName("segment-used-count")
  private Long segmentUsedCount = null;

  @SerializedName("pool-begin")
  private Long poolBegin = null;

  public SegmentUsageInfo segmentUsedPercent(Integer segmentUsedPercent) {
    this.segmentUsedPercent = segmentUsedPercent;
    return this;
  }

   /**
   * Percentage of used resources in the resource pool.
   * minimum: 0
   * maximum: 100
   * @return segmentUsedPercent
  **/
  @ApiModelProperty(value = "Percentage of used resources in the resource pool.")
  public Integer getSegmentUsedPercent() {
    return segmentUsedPercent;
  }

  public void setSegmentUsedPercent(Integer segmentUsedPercent) {
    this.segmentUsedPercent = segmentUsedPercent;
  }

  public SegmentUsageInfo poolEnd(Long poolEnd) {
    this.poolEnd = poolEnd;
    return this;
  }

   /**
   * End position of a resource pool.
   * minimum: -9223372036854775808
   * maximum: -9223372036854775808
   * @return poolEnd
  **/
  @ApiModelProperty(value = "End position of a resource pool.")
  public Long getPoolEnd() {
    return poolEnd;
  }

  public void setPoolEnd(Long poolEnd) {
    this.poolEnd = poolEnd;
  }

  public SegmentUsageInfo segmentUsedCount(Long segmentUsedCount) {
    this.segmentUsedCount = segmentUsedCount;
    return this;
  }

   /**
   * Number of used resources.
   * minimum: -9223372036854775808
   * maximum: -9223372036854775808
   * @return segmentUsedCount
  **/
  @ApiModelProperty(value = "Number of used resources.")
  public Long getSegmentUsedCount() {
    return segmentUsedCount;
  }

  public void setSegmentUsedCount(Long segmentUsedCount) {
    this.segmentUsedCount = segmentUsedCount;
  }

  public SegmentUsageInfo poolBegin(Long poolBegin) {
    this.poolBegin = poolBegin;
    return this;
  }

   /**
   * Start position of a resource pool.
   * minimum: -9223372036854775808
   * maximum: -9223372036854775808
   * @return poolBegin
  **/
  @ApiModelProperty(value = "Start position of a resource pool.")
  public Long getPoolBegin() {
    return poolBegin;
  }

  public void setPoolBegin(Long poolBegin) {
    this.poolBegin = poolBegin;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SegmentUsageInfo segmentUsageInfo = (SegmentUsageInfo) o;
    return Objects.equals(this.segmentUsedPercent, segmentUsageInfo.segmentUsedPercent) &&
        Objects.equals(this.poolEnd, segmentUsageInfo.poolEnd) &&
        Objects.equals(this.segmentUsedCount, segmentUsageInfo.segmentUsedCount) &&
        Objects.equals(this.poolBegin, segmentUsageInfo.poolBegin);
  }

  @Override
  public int hashCode() {
    return Objects.hash(segmentUsedPercent, poolEnd, segmentUsedCount, poolBegin);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SegmentUsageInfo {\n");
    
    sb.append("    segmentUsedPercent: ").append(toIndentedString(segmentUsedPercent)).append("\n");
    sb.append("    poolEnd: ").append(toIndentedString(poolEnd)).append("\n");
    sb.append("    segmentUsedCount: ").append(toIndentedString(segmentUsedCount)).append("\n");
    sb.append("    poolBegin: ").append(toIndentedString(poolBegin)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

