/*
 * Application Templates
 * · Create an Application Template Instance · Update an Application Template · Query a Template in Use · Query a Template Group in Use · Query Parameters in Use · Submit an Application Template · Cancel an Application Template · Query Available Templates · Query Available Template Groups · Query Driver ID Details · Preview the Device List · Query Configurations Based on a Device · Query Parameters Based on a Device · Modify Parameters Based on a Device · Query NE Task Overview · Query NE Task Details 
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * SubmitApplicationTemplateReq
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-12-28T20:43:49.954+08:00")
public class SubmitApplicationTemplateReq {
  @SerializedName("app-id")
  private String appId = null;

  @SerializedName("transaction-id")
  private String transactionId = null;

  @SerializedName("userMode")
  private Boolean userMode = null;

  /**
   * Submission mode, To devices; To NCE
   */
  @JsonAdapter(SubmitEnum.Adapter.class)
  public enum SubmitEnum {
    DEVICE("submit-to-device"),
    
    CDB("submit-to-cdb");

    private String value;

    SubmitEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static SubmitEnum fromValue(String text) {
      for (SubmitEnum b : SubmitEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<SubmitEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final SubmitEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public SubmitEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return SubmitEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("submit")
  private SubmitEnum submit = null;

  public SubmitApplicationTemplateReq appId(String appId) {
    this.appId = appId;
    return this;
  }

   /**
   * Temporary application ID.
   * @return appId
  **/
  @ApiModelProperty(required = true, value = "Temporary application ID.")
  public String getAppId() {
    return appId;
  }

  public void setAppId(String appId) {
    this.appId = appId;
  }

  public SubmitApplicationTemplateReq transactionId(String transactionId) {
    this.transactionId = transactionId;
    return this;
  }

   /**
   * Transaction ID.
   * @return transactionId
  **/
  @ApiModelProperty(required = true, value = "Transaction ID.")
  public String getTransactionId() {
    return transactionId;
  }

  public void setTransactionId(String transactionId) {
    this.transactionId = transactionId;
  }

  public SubmitApplicationTemplateReq userMode(Boolean userMode) {
    this.userMode = userMode;
    return this;
  }

   /**
   * Whether the user mode is used.
   * @return userMode
  **/
  @ApiModelProperty(required = true, value = "Whether the user mode is used.")
  public Boolean isUserMode() {
    return userMode;
  }

  public void setUserMode(Boolean userMode) {
    this.userMode = userMode;
  }

  public SubmitApplicationTemplateReq submit(SubmitEnum submit) {
    this.submit = submit;
    return this;
  }

   /**
   * Submission mode, To devices; To NCE
   * @return submit
  **/
  @ApiModelProperty(required = true, value = "Submission mode, To devices; To NCE")
  public SubmitEnum getSubmit() {
    return submit;
  }

  public void setSubmit(SubmitEnum submit) {
    this.submit = submit;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SubmitApplicationTemplateReq submitApplicationTemplateReq = (SubmitApplicationTemplateReq) o;
    return Objects.equals(this.appId, submitApplicationTemplateReq.appId) &&
        Objects.equals(this.transactionId, submitApplicationTemplateReq.transactionId) &&
        Objects.equals(this.userMode, submitApplicationTemplateReq.userMode) &&
        Objects.equals(this.submit, submitApplicationTemplateReq.submit);
  }

  @Override
  public int hashCode() {
    return Objects.hash(appId, transactionId, userMode, submit);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SubmitApplicationTemplateReq {\n");
    
    sb.append("    appId: ").append(toIndentedString(appId)).append("\n");
    sb.append("    transactionId: ").append(toIndentedString(transactionId)).append("\n");
    sb.append("    userMode: ").append(toIndentedString(userMode)).append("\n");
    sb.append("    submit: ").append(toIndentedString(submit)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

