/*
 * Application Templates
 * · Create an Application Template Instance · Update an Application Template · Query a Template in Use · Query a Template Group in Use · Query Parameters in Use · Submit an Application Template · Cancel an Application Template · Query Available Templates · Query Available Template Groups · Query Driver ID Details · Preview the Device List · Query Configurations Based on a Device · Query Parameters Based on a Device · Modify Parameters Based on a Device · Query NE Task Overview · Query NE Task Details 
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * TaskDetailList
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-12-28T20:43:49.954+08:00")
public class TaskDetailList {
  @SerializedName("id")
  private String id = null;

  @SerializedName("type")
  private Integer type = null;

  /**
   * NE task status.
   */
  @JsonAdapter(StateEnum.Adapter.class)
  public enum StateEnum {
    IDLE("IDLE"),
    
    EXECUTING("EXECUTING"),
    
    SUCCESS("SUCCESS"),
    
    FAILUR("FAILUR");

    private String value;

    StateEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static StateEnum fromValue(String text) {
      for (StateEnum b : StateEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<StateEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final StateEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public StateEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return StateEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("state")
  private StateEnum state = null;

  @SerializedName("start-time")
  private String startTime = null;

  @SerializedName("end-time")
  private String endTime = null;

  @SerializedName("task-result")
  private String taskResult = null;

  @SerializedName("device-name")
  private String deviceName = null;

  @SerializedName("device-ip")
  private String deviceIp = null;

  public TaskDetailList id(String id) {
    this.id = id;
    return this;
  }

   /**
   * Task ID.
   * @return id
  **/
  @ApiModelProperty(value = "Task ID.")
  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public TaskDetailList type(Integer type) {
    this.type = type;
    return this;
  }

   /**
   * Total number of NE tasks.
   * @return type
  **/
  @ApiModelProperty(value = "Total number of NE tasks.")
  public Integer getType() {
    return type;
  }

  public void setType(Integer type) {
    this.type = type;
  }

  public TaskDetailList state(StateEnum state) {
    this.state = state;
    return this;
  }

   /**
   * NE task status.
   * @return state
  **/
  @ApiModelProperty(value = "NE task status.")
  public StateEnum getState() {
    return state;
  }

  public void setState(StateEnum state) {
    this.state = state;
  }

  public TaskDetailList startTime(String startTime) {
    this.startTime = startTime;
    return this;
  }

   /**
   * Time when an NE task is created.
   * @return startTime
  **/
  @ApiModelProperty(value = "Time when an NE task is created.")
  public String getStartTime() {
    return startTime;
  }

  public void setStartTime(String startTime) {
    this.startTime = startTime;
  }

  public TaskDetailList endTime(String endTime) {
    this.endTime = endTime;
    return this;
  }

   /**
   * Time when an NE task is ended.
   * @return endTime
  **/
  @ApiModelProperty(value = "Time when an NE task is ended.")
  public String getEndTime() {
    return endTime;
  }

  public void setEndTime(String endTime) {
    this.endTime = endTime;
  }

  public TaskDetailList taskResult(String taskResult) {
    this.taskResult = taskResult;
    return this;
  }

   /**
   * NE task execution result.
   * @return taskResult
  **/
  @ApiModelProperty(value = "NE task execution result.")
  public String getTaskResult() {
    return taskResult;
  }

  public void setTaskResult(String taskResult) {
    this.taskResult = taskResult;
  }

  public TaskDetailList deviceName(String deviceName) {
    this.deviceName = deviceName;
    return this;
  }

   /**
   * Device name.
   * @return deviceName
  **/
  @ApiModelProperty(value = "Device name.")
  public String getDeviceName() {
    return deviceName;
  }

  public void setDeviceName(String deviceName) {
    this.deviceName = deviceName;
  }

  public TaskDetailList deviceIp(String deviceIp) {
    this.deviceIp = deviceIp;
    return this;
  }

   /**
   * Device IP address.
   * @return deviceIp
  **/
  @ApiModelProperty(value = "Device IP address.")
  public String getDeviceIp() {
    return deviceIp;
  }

  public void setDeviceIp(String deviceIp) {
    this.deviceIp = deviceIp;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    TaskDetailList taskDetailList = (TaskDetailList) o;
    return Objects.equals(this.id, taskDetailList.id) &&
        Objects.equals(this.type, taskDetailList.type) &&
        Objects.equals(this.state, taskDetailList.state) &&
        Objects.equals(this.startTime, taskDetailList.startTime) &&
        Objects.equals(this.endTime, taskDetailList.endTime) &&
        Objects.equals(this.taskResult, taskDetailList.taskResult) &&
        Objects.equals(this.deviceName, taskDetailList.deviceName) &&
        Objects.equals(this.deviceIp, taskDetailList.deviceIp);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, type, state, startTime, endTime, taskResult, deviceName, deviceIp);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class TaskDetailList {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    state: ").append(toIndentedString(state)).append("\n");
    sb.append("    startTime: ").append(toIndentedString(startTime)).append("\n");
    sb.append("    endTime: ").append(toIndentedString(endTime)).append("\n");
    sb.append("    taskResult: ").append(toIndentedString(taskResult)).append("\n");
    sb.append("    deviceName: ").append(toIndentedString(deviceName)).append("\n");
    sb.append("    deviceIp: ").append(toIndentedString(deviceIp)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

