/*
 * Template Management
 * APIs for adding, deleting, querying, and modifying templates
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import com.huawei.aoc.api.model.ParameterInfo;
import com.huawei.aoc.api.model.Template;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * Template 4.
 */
@ApiModel(description = "Template 4.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-12-28T20:55:37.021+08:00")
public class Template4 {
  @SerializedName("template-name")
  private String templateName = null;

  @SerializedName("template-identifier")
  private String templateIdentifier = null;

  @SerializedName("template-description")
  private String templateDescription = null;

  @SerializedName("template-context")
  private String templateContext = null;

  /**
   * Template type.
   */
  @JsonAdapter(TemplateTypeEnum.Adapter.class)
  public enum TemplateTypeEnum {
    DEVICE_TEMPLATE("DEVICE-TEMPLATE"),
    
    SERVICE_TEMPLATE("SERVICE-TEMPLATE");

    private String value;

    TemplateTypeEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static TemplateTypeEnum fromValue(String text) {
      for (TemplateTypeEnum b : TemplateTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<TemplateTypeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final TemplateTypeEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public TemplateTypeEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return TemplateTypeEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("template-type")
  private TemplateTypeEnum templateType = null;

  /**
   * Template attributes.
   */
  @JsonAdapter(TemplatePropertyEnum.Adapter.class)
  public enum TemplatePropertyEnum {
    DEFAULT_TEMPLATE("DEFAULT-TEMPLATE"),
    
    CUSTOM_TEMPLATE("CUSTOM-TEMPLATE");

    private String value;

    TemplatePropertyEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static TemplatePropertyEnum fromValue(String text) {
      for (TemplatePropertyEnum b : TemplatePropertyEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<TemplatePropertyEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final TemplatePropertyEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public TemplatePropertyEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return TemplatePropertyEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("template-property")
  private TemplatePropertyEnum templateProperty = null;

  @SerializedName("parameter-info")
  private List<ParameterInfo> parameterInfo = new ArrayList<ParameterInfo>();

  @SerializedName("template-version")
  private String templateVersion = null;

  public Template4 templateName(String templateName) {
    this.templateName = templateName;
    return this;
  }

   /**
   * Template name, which can contain digits, letters, and one or more of the following special characters, hyphen (-), underscore (_), and at sign (@). The value cannot start with a digit.
   * @return templateName
  **/
  @ApiModelProperty(required = true, value = "Template name, which can contain digits, letters, and one or more of the following special characters, hyphen (-), underscore (_), and at sign (@). The value cannot start with a digit.")
  public String getTemplateName() {
    return templateName;
  }

  public void setTemplateName(String templateName) {
    this.templateName = templateName;
  }

  public Template4 templateIdentifier(String templateIdentifier) {
    this.templateIdentifier = templateIdentifier;
    return this;
  }

   /**
   * Template driver ID.
   * @return templateIdentifier
  **/
  @ApiModelProperty(value = "Template driver ID.")
  public String getTemplateIdentifier() {
    return templateIdentifier;
  }

  public void setTemplateIdentifier(String templateIdentifier) {
    this.templateIdentifier = templateIdentifier;
  }

  public Template4 templateDescription(String templateDescription) {
    this.templateDescription = templateDescription;
    return this;
  }

   /**
   * Template description.
   * @return templateDescription
  **/
  @ApiModelProperty(value = "Template description.")
  public String getTemplateDescription() {
    return templateDescription;
  }

  public void setTemplateDescription(String templateDescription) {
    this.templateDescription = templateDescription;
  }

  public Template4 templateContext(String templateContext) {
    this.templateContext = templateContext;
    return this;
  }

   /**
   * Template content.
   * @return templateContext
  **/
  @ApiModelProperty(required = true, value = "Template content.")
  public String getTemplateContext() {
    return templateContext;
  }

  public void setTemplateContext(String templateContext) {
    this.templateContext = templateContext;
  }

  public Template4 templateType(TemplateTypeEnum templateType) {
    this.templateType = templateType;
    return this;
  }

   /**
   * Template type.
   * @return templateType
  **/
  @ApiModelProperty(required = true, value = "Template type.")
  public TemplateTypeEnum getTemplateType() {
    return templateType;
  }

  public void setTemplateType(TemplateTypeEnum templateType) {
    this.templateType = templateType;
  }

  public Template4 templateProperty(TemplatePropertyEnum templateProperty) {
    this.templateProperty = templateProperty;
    return this;
  }

   /**
   * Template attributes.
   * @return templateProperty
  **/
  @ApiModelProperty(value = "Template attributes.")
  public TemplatePropertyEnum getTemplateProperty() {
    return templateProperty;
  }

  public void setTemplateProperty(TemplatePropertyEnum templateProperty) {
    this.templateProperty = templateProperty;
  }

  public Template4 parameterInfo(List<ParameterInfo> parameterInfo) {
    this.parameterInfo = parameterInfo;
    return this;
  }

  public Template4 addParameterInfoItem(ParameterInfo parameterInfoItem) {
    this.parameterInfo.add(parameterInfoItem);
    return this;
  }

   /**
   * Parameter object.
   * @return parameterInfo
  **/
  @ApiModelProperty(required = true, value = "Parameter object.")
  public List<ParameterInfo> getParameterInfo() {
    return parameterInfo;
  }

  public void setParameterInfo(List<ParameterInfo> parameterInfo) {
    this.parameterInfo = parameterInfo;
  }

  public Template4 templateVersion(String templateVersion) {
    this.templateVersion = templateVersion;
    return this;
  }

   /**
   * Template version. The default value is 0. The version number must be later than the previous version number each time the template is updated.
   * @return templateVersion
  **/
  @ApiModelProperty(value = "Template version. The default value is 0. The version number must be later than the previous version number each time the template is updated.")
  public String getTemplateVersion() {
    return templateVersion;
  }

  public void setTemplateVersion(String templateVersion) {
    this.templateVersion = templateVersion;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Template4 template4 = (Template4) o;
    return Objects.equals(this.templateName, template4.templateName) &&
        Objects.equals(this.templateIdentifier, template4.templateIdentifier) &&
        Objects.equals(this.templateDescription, template4.templateDescription) &&
        Objects.equals(this.templateContext, template4.templateContext) &&
        Objects.equals(this.templateType, template4.templateType) &&
        Objects.equals(this.templateProperty, template4.templateProperty) &&
        Objects.equals(this.parameterInfo, template4.parameterInfo) &&
        Objects.equals(this.templateVersion, template4.templateVersion);
  }

  @Override
  public int hashCode() {
    return Objects.hash(templateName, templateIdentifier, templateDescription, templateContext, templateType, templateProperty, parameterInfo, templateVersion);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Template4 {\n");
    
    sb.append("    templateName: ").append(toIndentedString(templateName)).append("\n");
    sb.append("    templateIdentifier: ").append(toIndentedString(templateIdentifier)).append("\n");
    sb.append("    templateDescription: ").append(toIndentedString(templateDescription)).append("\n");
    sb.append("    templateContext: ").append(toIndentedString(templateContext)).append("\n");
    sb.append("    templateType: ").append(toIndentedString(templateType)).append("\n");
    sb.append("    templateProperty: ").append(toIndentedString(templateProperty)).append("\n");
    sb.append("    parameterInfo: ").append(toIndentedString(parameterInfo)).append("\n");
    sb.append("    templateVersion: ").append(toIndentedString(templateVersion)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

