/*
 * Application Templates
 * · Create an Application Template Instance · Update an Application Template · Query a Template in Use · Query a Template Group in Use · Query Parameters in Use · Submit an Application Template · Cancel an Application Template · Query Available Templates · Query Available Template Groups · Query Driver ID Details · Preview the Device List · Query Configurations Based on a Device · Query Parameters Based on a Device · Modify Parameters Based on a Device · Query NE Task Overview · Query NE Task Details 
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import com.huawei.aoc.api.model.MemberParameters;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * UpdateTemplateApplicationReq
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-12-28T20:43:49.954+08:00")
public class UpdateTemplateApplicationReq {
  @SerializedName("app-id")
  private String appId = null;

  /**
   * Operation type for application data, which can be Create, Modify, or Delete.
   */
  @JsonAdapter(OperTypeEnum.Adapter.class)
  public enum OperTypeEnum {
    ADD("ADD"),
    
    UPDATE("UPDATE"),
    
    REMOVE("REMOVE");

    private String value;

    OperTypeEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static OperTypeEnum fromValue(String text) {
      for (OperTypeEnum b : OperTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<OperTypeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final OperTypeEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public OperTypeEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return OperTypeEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("oper-type")
  private OperTypeEnum operType = null;

  /**
   * Application data type, which can be Template, Template group, or Parameter.
   */
  @JsonAdapter(MemberTypeEnum.Adapter.class)
  public enum MemberTypeEnum {
    TEMPLATE("TEMPLATE"),
    
    TEMPLATEGROUP("TEMPLATEGROUP"),
    
    PARAMETER("PARAMETER");

    private String value;

    MemberTypeEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static MemberTypeEnum fromValue(String text) {
      for (MemberTypeEnum b : MemberTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<MemberTypeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final MemberTypeEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public MemberTypeEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return MemberTypeEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("member-type")
  private MemberTypeEnum memberType = null;

  @SerializedName("member")
  private List<MemberParameters> member = new ArrayList<MemberParameters>();

  public UpdateTemplateApplicationReq appId(String appId) {
    this.appId = appId;
    return this;
  }

   /**
   * Temporary application ID.
   * @return appId
  **/
  @ApiModelProperty(required = true, value = "Temporary application ID.")
  public String getAppId() {
    return appId;
  }

  public void setAppId(String appId) {
    this.appId = appId;
  }

  public UpdateTemplateApplicationReq operType(OperTypeEnum operType) {
    this.operType = operType;
    return this;
  }

   /**
   * Operation type for application data, which can be Create, Modify, or Delete.
   * @return operType
  **/
  @ApiModelProperty(required = true, value = "Operation type for application data, which can be Create, Modify, or Delete.")
  public OperTypeEnum getOperType() {
    return operType;
  }

  public void setOperType(OperTypeEnum operType) {
    this.operType = operType;
  }

  public UpdateTemplateApplicationReq memberType(MemberTypeEnum memberType) {
    this.memberType = memberType;
    return this;
  }

   /**
   * Application data type, which can be Template, Template group, or Parameter.
   * @return memberType
  **/
  @ApiModelProperty(required = true, value = "Application data type, which can be Template, Template group, or Parameter.")
  public MemberTypeEnum getMemberType() {
    return memberType;
  }

  public void setMemberType(MemberTypeEnum memberType) {
    this.memberType = memberType;
  }

  public UpdateTemplateApplicationReq member(List<MemberParameters> member) {
    this.member = member;
    return this;
  }

  public UpdateTemplateApplicationReq addMemberItem(MemberParameters memberItem) {
    this.member.add(memberItem);
    return this;
  }

   /**
   * Application data list.
   * @return member
  **/
  @ApiModelProperty(required = true, value = "Application data list.")
  public List<MemberParameters> getMember() {
    return member;
  }

  public void setMember(List<MemberParameters> member) {
    this.member = member;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    UpdateTemplateApplicationReq updateTemplateApplicationReq = (UpdateTemplateApplicationReq) o;
    return Objects.equals(this.appId, updateTemplateApplicationReq.appId) &&
        Objects.equals(this.operType, updateTemplateApplicationReq.operType) &&
        Objects.equals(this.memberType, updateTemplateApplicationReq.memberType) &&
        Objects.equals(this.member, updateTemplateApplicationReq.member);
  }

  @Override
  public int hashCode() {
    return Objects.hash(appId, operType, memberType, member);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class UpdateTemplateApplicationReq {\n");
    
    sb.append("    appId: ").append(toIndentedString(appId)).append("\n");
    sb.append("    operType: ").append(toIndentedString(operType)).append("\n");
    sb.append("    memberType: ").append(toIndentedString(memberType)).append("\n");
    sb.append("    member: ").append(toIndentedString(member)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

