/*
 * Device RPC Operations and Data Query
 * APIs for device RPC operations and data query: · Device RPC Operations · Device Data Query 
 *
 * OpenAPI spec version: 1.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.service;

import com.huawei.aoc.api.ApiCallback;
import com.huawei.aoc.api.ApiClient;
import com.huawei.aoc.api.ApiException;
import com.huawei.aoc.api.ApiResponse;
import com.huawei.aoc.api.Configuration;
import com.huawei.aoc.api.Pair;
import com.huawei.aoc.api.ProgressRequestBody;
import com.huawei.aoc.api.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import com.huawei.aoc.api.model.RealDeviceQueryInput;
import com.huawei.aoc.api.model.RealDeviceQueryOutPut;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class AocUniRealDeviceQueryApi {
    private ApiClient apiClient;

    public AocUniRealDeviceQueryApi() {
        this(Configuration.getDefaultApiClient());
    }

    public AocUniRealDeviceQueryApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for realDeviceQuery
     * @param input  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call realDeviceQueryCall(RealDeviceQueryInput input, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = input;

        // create path and map variables
        String localVarPath = "/rest/aocecs/v1/realDeviceQuery";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call realDeviceQueryValidateBeforeCall(RealDeviceQueryInput input, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'input' is set
        if (input == null) {
            throw new ApiException("Missing the required parameter 'input' when calling realDeviceQuery(Async)");
        }
        

        com.squareup.okhttp.Call call = realDeviceQueryCall(input, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Send a Query Request to a Southbound Device
     * ## Typical Scenario ##   An API for querying device configuration and status data, including filter criteria, needs to be provided.  ## Function ##   Send a query request to a southbound device.  ## Constraint ##   1. The southbound device is running properly.   2. The controller is running properly. 
     * @param input  (required)
     * @return RealDeviceQueryOutPut
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public RealDeviceQueryOutPut realDeviceQuery(RealDeviceQueryInput input) throws ApiException {
        ApiResponse<RealDeviceQueryOutPut> resp = realDeviceQueryWithHttpInfo(input);
        return resp.getData();
    }

    /**
     * Send a Query Request to a Southbound Device
     * ## Typical Scenario ##   An API for querying device configuration and status data, including filter criteria, needs to be provided.  ## Function ##   Send a query request to a southbound device.  ## Constraint ##   1. The southbound device is running properly.   2. The controller is running properly. 
     * @param input  (required)
     * @return ApiResponse&lt;RealDeviceQueryOutPut&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<RealDeviceQueryOutPut> realDeviceQueryWithHttpInfo(RealDeviceQueryInput input) throws ApiException {
        com.squareup.okhttp.Call call = realDeviceQueryValidateBeforeCall(input, null, null);
        Type localVarReturnType = new TypeToken<RealDeviceQueryOutPut>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Send a Query Request to a Southbound Device (asynchronously)
     * ## Typical Scenario ##   An API for querying device configuration and status data, including filter criteria, needs to be provided.  ## Function ##   Send a query request to a southbound device.  ## Constraint ##   1. The southbound device is running properly.   2. The controller is running properly. 
     * @param input  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call realDeviceQueryAsync(RealDeviceQueryInput input, final ApiCallback<RealDeviceQueryOutPut> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = realDeviceQueryValidateBeforeCall(input, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<RealDeviceQueryOutPut>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
