/*
 * Device RPC Operations and Data Query
 * APIs for device RPC operations and data query: · Device RPC Operations · Device Data Query 
 *
 * OpenAPI spec version: 1.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.service;

import com.huawei.aoc.api.ApiCallback;
import com.huawei.aoc.api.ApiClient;
import com.huawei.aoc.api.ApiException;
import com.huawei.aoc.api.ApiResponse;
import com.huawei.aoc.api.Configuration;
import com.huawei.aoc.api.Pair;
import com.huawei.aoc.api.ProgressRequestBody;
import com.huawei.aoc.api.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import com.huawei.aoc.api.model.RealDeviceRpcInput;
import com.huawei.aoc.api.model.RealDeviceRpcOutPut;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class AocUniRealDeviceRpcApi {
    private ApiClient apiClient;

    public AocUniRealDeviceRpcApi() {
        this(Configuration.getDefaultApiClient());
    }

    public AocUniRealDeviceRpcApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for realDeviceRpc
     * @param rpcInput  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call realDeviceRpcCall(RealDeviceRpcInput rpcInput, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = rpcInput;

        // create path and map variables
        String localVarPath = "/rest/aocecs/v1/realDeviceRpc";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call realDeviceRpcValidateBeforeCall(RealDeviceRpcInput rpcInput, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'rpcInput' is set
        if (rpcInput == null) {
            throw new ApiException("Missing the required parameter 'rpcInput' when calling realDeviceRpc(Async)");
        }
        

        com.squareup.okhttp.Call call = realDeviceRpcCall(rpcInput, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Device RPC Operations
     * ## Typical Scenario ##  A common RPC API for interacting with devices in the southbound direction needs to be provided. ## Function ##  Send RPC commands to southbound devices. ## Constraint ##  1. The southbound device is running properly.  2. The controller is running properly. 
     * @param rpcInput  (required)
     * @return RealDeviceRpcOutPut
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public RealDeviceRpcOutPut realDeviceRpc(RealDeviceRpcInput rpcInput) throws ApiException {
        ApiResponse<RealDeviceRpcOutPut> resp = realDeviceRpcWithHttpInfo(rpcInput);
        return resp.getData();
    }

    /**
     * Device RPC Operations
     * ## Typical Scenario ##  A common RPC API for interacting with devices in the southbound direction needs to be provided. ## Function ##  Send RPC commands to southbound devices. ## Constraint ##  1. The southbound device is running properly.  2. The controller is running properly. 
     * @param rpcInput  (required)
     * @return ApiResponse&lt;RealDeviceRpcOutPut&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<RealDeviceRpcOutPut> realDeviceRpcWithHttpInfo(RealDeviceRpcInput rpcInput) throws ApiException {
        com.squareup.okhttp.Call call = realDeviceRpcValidateBeforeCall(rpcInput, null, null);
        Type localVarReturnType = new TypeToken<RealDeviceRpcOutPut>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Device RPC Operations (asynchronously)
     * ## Typical Scenario ##  A common RPC API for interacting with devices in the southbound direction needs to be provided. ## Function ##  Send RPC commands to southbound devices. ## Constraint ##  1. The southbound device is running properly.  2. The controller is running properly. 
     * @param rpcInput  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call realDeviceRpcAsync(RealDeviceRpcInput rpcInput, final ApiCallback<RealDeviceRpcOutPut> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = realDeviceRpcValidateBeforeCall(rpcInput, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<RealDeviceRpcOutPut>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
