/*
 * Parameter Set Management
 * Create a Parameter Set Delete a Parameter Set Query a Parameter Set Add Parameters to a Parameter Set Delete Parameters from a Parameter Set Update Parameters in a Parameter Set
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.service;

import com.huawei.aoc.api.ApiCallback;
import com.huawei.aoc.api.ApiClient;
import com.huawei.aoc.api.ApiException;
import com.huawei.aoc.api.ApiResponse;
import com.huawei.aoc.api.Configuration;
import com.huawei.aoc.api.Pair;
import com.huawei.aoc.api.ProgressRequestBody;
import com.huawei.aoc.api.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;



import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class DeleteParameterSetApi {
    private ApiClient apiClient;

    public DeleteParameterSetApi() {
        this(Configuration.getDefaultApiClient());
    }

    public DeleteParameterSetApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for deleteTemplateParameter
     * @param parameterSetName Name of an existing parameter set to be deleted, which can contain digits, letters, and one or more of the following special characters, hyphen (-), underscore (_), and at sign (@). The value cannot start with a digit. (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call deleteTemplateParameterCall(String parameterSetName, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/restconf/data/huawei-ac-config-template-parameter-north:template-parameter/parameter-set/{parameter-set-name}"
            .replaceAll("\\{" + "parameter-set-name" + "\\}", apiClient.escapeString(parameterSetName.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call deleteTemplateParameterValidateBeforeCall(String parameterSetName, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'parameterSetName' is set
        if (parameterSetName == null) {
            throw new ApiException("Missing the required parameter 'parameterSetName' when calling deleteTemplateParameter(Async)");
        }
        

        com.squareup.okhttp.Call call = deleteTemplateParameterCall(parameterSetName, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Delete a Parameter Set
     * ## Typical Scenario ##   An existing parameter set needs to be deleted. ## Function ##   Delete a parameter set based on the entered parameter set name. ## Constraint ##   This is a northbound API. The request header must contain the northbound token obtained in advance. The parameter set to be deleted must exist. 
     * @param parameterSetName Name of an existing parameter set to be deleted, which can contain digits, letters, and one or more of the following special characters, hyphen (-), underscore (_), and at sign (@). The value cannot start with a digit. (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void deleteTemplateParameter(String parameterSetName) throws ApiException {
        deleteTemplateParameterWithHttpInfo(parameterSetName);
    }

    /**
     * Delete a Parameter Set
     * ## Typical Scenario ##   An existing parameter set needs to be deleted. ## Function ##   Delete a parameter set based on the entered parameter set name. ## Constraint ##   This is a northbound API. The request header must contain the northbound token obtained in advance. The parameter set to be deleted must exist. 
     * @param parameterSetName Name of an existing parameter set to be deleted, which can contain digits, letters, and one or more of the following special characters, hyphen (-), underscore (_), and at sign (@). The value cannot start with a digit. (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> deleteTemplateParameterWithHttpInfo(String parameterSetName) throws ApiException {
        com.squareup.okhttp.Call call = deleteTemplateParameterValidateBeforeCall(parameterSetName, null, null);
        return apiClient.execute(call);
    }

    /**
     * Delete a Parameter Set (asynchronously)
     * ## Typical Scenario ##   An existing parameter set needs to be deleted. ## Function ##   Delete a parameter set based on the entered parameter set name. ## Constraint ##   This is a northbound API. The request header must contain the northbound token obtained in advance. The parameter set to be deleted must exist. 
     * @param parameterSetName Name of an existing parameter set to be deleted, which can contain digits, letters, and one or more of the following special characters, hyphen (-), underscore (_), and at sign (@). The value cannot start with a digit. (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call deleteTemplateParameterAsync(String parameterSetName, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = deleteTemplateParameterValidateBeforeCall(parameterSetName, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
}
