/*
 * Device Group Management
 * Device group management APIs: · Create a Device Group · Delete a Device Group · Query All Device Groups · Query a Device Group · Add a Device or Sub Device Group to a Device Group · Delete a Device from a Device Group · Delete a Sub Device Group from a Device Group 
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.service;

import com.huawei.aoc.api.ApiCallback;
import com.huawei.aoc.api.ApiClient;
import com.huawei.aoc.api.ApiException;
import com.huawei.aoc.api.ApiResponse;
import com.huawei.aoc.api.Configuration;
import com.huawei.aoc.api.Pair;
import com.huawei.aoc.api.ProgressRequestBody;
import com.huawei.aoc.api.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;



import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class DeviceGroupDeleteSubDeviceGroupApi {
    private ApiClient apiClient;

    public DeviceGroupDeleteSubDeviceGroupApi() {
        this(Configuration.getDefaultApiClient());
    }

    public DeviceGroupDeleteSubDeviceGroupApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for deviceGroupDeleteSubDeviceGroup
     * @param deviceGroupName Name of a device group, which can contain digits, letters, and one or more of the following special characters, hyphen (-), underscore (_), and at sign (@). The value cannot start with a digit. (required)
     * @param deviceChildGroupName Name of a sub device group, which can contain digits, letters, and one or more of the following special characters, hyphen (-), underscore (_), and at sign (@). The value cannot start with a digit. (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call deviceGroupDeleteSubDeviceGroupCall(String deviceGroupName, String deviceChildGroupName, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/restconf/data/device-shell-group-northbound:device-shell-group/device-group/{device-group-name}/device-child-group-names/{device-child-group-name}"
            .replaceAll("\\{" + "device-group-name" + "\\}", apiClient.escapeString(deviceGroupName.toString()))
            .replaceAll("\\{" + "device-child-group-name" + "\\}", apiClient.escapeString(deviceChildGroupName.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call deviceGroupDeleteSubDeviceGroupValidateBeforeCall(String deviceGroupName, String deviceChildGroupName, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'deviceGroupName' is set
        if (deviceGroupName == null) {
            throw new ApiException("Missing the required parameter 'deviceGroupName' when calling deviceGroupDeleteSubDeviceGroup(Async)");
        }
        
        // verify the required parameter 'deviceChildGroupName' is set
        if (deviceChildGroupName == null) {
            throw new ApiException("Missing the required parameter 'deviceChildGroupName' when calling deviceGroupDeleteSubDeviceGroup(Async)");
        }
        

        com.squareup.okhttp.Call call = deviceGroupDeleteSubDeviceGroupCall(deviceGroupName, deviceChildGroupName, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Delete a Sub Device Group from a Device Group
     * ## Typical Scenario ##  A sub device group needs to be deleted from a device group. ## Function ##  Delete a specified sub device group from a specified device group. ## Constraint ##  This is a northbound API. The request header must contain the northbound token obtained in advance. The device group and sub device group must exist. 
     * @param deviceGroupName Name of a device group, which can contain digits, letters, and one or more of the following special characters, hyphen (-), underscore (_), and at sign (@). The value cannot start with a digit. (required)
     * @param deviceChildGroupName Name of a sub device group, which can contain digits, letters, and one or more of the following special characters, hyphen (-), underscore (_), and at sign (@). The value cannot start with a digit. (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void deviceGroupDeleteSubDeviceGroup(String deviceGroupName, String deviceChildGroupName) throws ApiException {
        deviceGroupDeleteSubDeviceGroupWithHttpInfo(deviceGroupName, deviceChildGroupName);
    }

    /**
     * Delete a Sub Device Group from a Device Group
     * ## Typical Scenario ##  A sub device group needs to be deleted from a device group. ## Function ##  Delete a specified sub device group from a specified device group. ## Constraint ##  This is a northbound API. The request header must contain the northbound token obtained in advance. The device group and sub device group must exist. 
     * @param deviceGroupName Name of a device group, which can contain digits, letters, and one or more of the following special characters, hyphen (-), underscore (_), and at sign (@). The value cannot start with a digit. (required)
     * @param deviceChildGroupName Name of a sub device group, which can contain digits, letters, and one or more of the following special characters, hyphen (-), underscore (_), and at sign (@). The value cannot start with a digit. (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> deviceGroupDeleteSubDeviceGroupWithHttpInfo(String deviceGroupName, String deviceChildGroupName) throws ApiException {
        com.squareup.okhttp.Call call = deviceGroupDeleteSubDeviceGroupValidateBeforeCall(deviceGroupName, deviceChildGroupName, null, null);
        return apiClient.execute(call);
    }

    /**
     * Delete a Sub Device Group from a Device Group (asynchronously)
     * ## Typical Scenario ##  A sub device group needs to be deleted from a device group. ## Function ##  Delete a specified sub device group from a specified device group. ## Constraint ##  This is a northbound API. The request header must contain the northbound token obtained in advance. The device group and sub device group must exist. 
     * @param deviceGroupName Name of a device group, which can contain digits, letters, and one or more of the following special characters, hyphen (-), underscore (_), and at sign (@). The value cannot start with a digit. (required)
     * @param deviceChildGroupName Name of a sub device group, which can contain digits, letters, and one or more of the following special characters, hyphen (-), underscore (_), and at sign (@). The value cannot start with a digit. (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call deviceGroupDeleteSubDeviceGroupAsync(String deviceGroupName, String deviceChildGroupName, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = deviceGroupDeleteSubDeviceGroupValidateBeforeCall(deviceGroupName, deviceChildGroupName, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
}
