/*
 * Distributed Transaction Status Management APIs
 * Distributed transaction status management APIs: 1. Query a Transaction 2. Delete a Transaction 3. Retry a Transaction 4. Query Transaction Tracks 
 *
 * OpenAPI spec version: v1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.service;

import com.huawei.aoc.api.ApiCallback;
import com.huawei.aoc.api.ApiClient;
import com.huawei.aoc.api.ApiException;
import com.huawei.aoc.api.ApiResponse;
import com.huawei.aoc.api.Configuration;
import com.huawei.aoc.api.Pair;
import com.huawei.aoc.api.ProgressRequestBody;
import com.huawei.aoc.api.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import com.huawei.aoc.api.model.ConditionDataDto;
import com.huawei.aoc.api.model.DTPInfosDto;
import com.huawei.aoc.api.model.DTPLogsDto;
import com.huawei.aoc.api.model.DTPOperDto;
import com.huawei.aoc.api.model.DTPOperResultDto;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class DtpServerApi {
    private ApiClient apiClient;

    public DtpServerApi() {
        this(Configuration.getDefaultApiClient());
    }

    public DtpServerApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for currentDtDelete
     * @param dtpOper Condition for deleting transactions. (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call currentDtDeleteCall(DTPOperDto dtpOper, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = dtpOper;

        // create path and map variables
        String localVarPath = "/rest/dtpServer/v1/northbound/currentDtDelete";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call currentDtDeleteValidateBeforeCall(DTPOperDto dtpOper, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'dtpOper' is set
        if (dtpOper == null) {
            throw new ApiException("Missing the required parameter 'dtpOper' when calling currentDtDelete(Async)");
        }
        

        com.squareup.okhttp.Call call = currentDtDeleteCall(dtpOper, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Delete a Transaction
     * ## Scenario ##   Distributed transactions need to be deleted when the number of distributed transactions exceeds the upper limit or an exception occurs. ## Function ##   Delete specified transactions. ## Constraint ##   None 
     * @param dtpOper Condition for deleting transactions. (required)
     * @return DTPOperResultDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public DTPOperResultDto currentDtDelete(DTPOperDto dtpOper) throws ApiException {
        ApiResponse<DTPOperResultDto> resp = currentDtDeleteWithHttpInfo(dtpOper);
        return resp.getData();
    }

    /**
     * Delete a Transaction
     * ## Scenario ##   Distributed transactions need to be deleted when the number of distributed transactions exceeds the upper limit or an exception occurs. ## Function ##   Delete specified transactions. ## Constraint ##   None 
     * @param dtpOper Condition for deleting transactions. (required)
     * @return ApiResponse&lt;DTPOperResultDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<DTPOperResultDto> currentDtDeleteWithHttpInfo(DTPOperDto dtpOper) throws ApiException {
        com.squareup.okhttp.Call call = currentDtDeleteValidateBeforeCall(dtpOper, null, null);
        Type localVarReturnType = new TypeToken<DTPOperResultDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Delete a Transaction (asynchronously)
     * ## Scenario ##   Distributed transactions need to be deleted when the number of distributed transactions exceeds the upper limit or an exception occurs. ## Function ##   Delete specified transactions. ## Constraint ##   None 
     * @param dtpOper Condition for deleting transactions. (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call currentDtDeleteAsync(DTPOperDto dtpOper, final ApiCallback<DTPOperResultDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = currentDtDeleteValidateBeforeCall(dtpOper, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<DTPOperResultDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for currentDtQuery
     * @param conditionData Condition for querying transactions. (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call currentDtQueryCall(ConditionDataDto conditionData, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = conditionData;

        // create path and map variables
        String localVarPath = "/rest/dtpServer/v1/northbound/currentDtQuery";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call currentDtQueryValidateBeforeCall(ConditionDataDto conditionData, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'conditionData' is set
        if (conditionData == null) {
            throw new ApiException("Missing the required parameter 'conditionData' when calling currentDtQuery(Async)");
        }
        

        com.squareup.okhttp.Call call = currentDtQueryCall(conditionData, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Query a Transaction
     * ## Scenario ##   The distributed transaction information needs to be queried to obtain the transaction initiator instance, transaction status, and transaction creation and completion time. ## Function ##   Query transaction information based on the transaction ID or initiator microservice. ## Constraint ##   None 
     * @param conditionData Condition for querying transactions. (required)
     * @return DTPInfosDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public DTPInfosDto currentDtQuery(ConditionDataDto conditionData) throws ApiException {
        ApiResponse<DTPInfosDto> resp = currentDtQueryWithHttpInfo(conditionData);
        return resp.getData();
    }

    /**
     * Query a Transaction
     * ## Scenario ##   The distributed transaction information needs to be queried to obtain the transaction initiator instance, transaction status, and transaction creation and completion time. ## Function ##   Query transaction information based on the transaction ID or initiator microservice. ## Constraint ##   None 
     * @param conditionData Condition for querying transactions. (required)
     * @return ApiResponse&lt;DTPInfosDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<DTPInfosDto> currentDtQueryWithHttpInfo(ConditionDataDto conditionData) throws ApiException {
        com.squareup.okhttp.Call call = currentDtQueryValidateBeforeCall(conditionData, null, null);
        Type localVarReturnType = new TypeToken<DTPInfosDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Query a Transaction (asynchronously)
     * ## Scenario ##   The distributed transaction information needs to be queried to obtain the transaction initiator instance, transaction status, and transaction creation and completion time. ## Function ##   Query transaction information based on the transaction ID or initiator microservice. ## Constraint ##   None 
     * @param conditionData Condition for querying transactions. (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call currentDtQueryAsync(ConditionDataDto conditionData, final ApiCallback<DTPInfosDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = currentDtQueryValidateBeforeCall(conditionData, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<DTPInfosDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for currentDtRetry
     * @param dtpOper Condition for retrying transactions. (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call currentDtRetryCall(DTPOperDto dtpOper, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = dtpOper;

        // create path and map variables
        String localVarPath = "/rest/dtpServer/v1/northbound/currentDtRetry";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call currentDtRetryValidateBeforeCall(DTPOperDto dtpOper, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'dtpOper' is set
        if (dtpOper == null) {
            throw new ApiException("Missing the required parameter 'dtpOper' when calling currentDtRetry(Async)");
        }
        

        com.squareup.okhttp.Call call = currentDtRetryCall(dtpOper, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Retry a Transaction
     * ## Scenario ##   A distributed transaction needs to be retried when an exception occurs during the transaction execution. ## Function ##   Retry a specified abnormal transaction. ## Constraint ##   None 
     * @param dtpOper Condition for retrying transactions. (required)
     * @return DTPOperResultDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public DTPOperResultDto currentDtRetry(DTPOperDto dtpOper) throws ApiException {
        ApiResponse<DTPOperResultDto> resp = currentDtRetryWithHttpInfo(dtpOper);
        return resp.getData();
    }

    /**
     * Retry a Transaction
     * ## Scenario ##   A distributed transaction needs to be retried when an exception occurs during the transaction execution. ## Function ##   Retry a specified abnormal transaction. ## Constraint ##   None 
     * @param dtpOper Condition for retrying transactions. (required)
     * @return ApiResponse&lt;DTPOperResultDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<DTPOperResultDto> currentDtRetryWithHttpInfo(DTPOperDto dtpOper) throws ApiException {
        com.squareup.okhttp.Call call = currentDtRetryValidateBeforeCall(dtpOper, null, null);
        Type localVarReturnType = new TypeToken<DTPOperResultDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Retry a Transaction (asynchronously)
     * ## Scenario ##   A distributed transaction needs to be retried when an exception occurs during the transaction execution. ## Function ##   Retry a specified abnormal transaction. ## Constraint ##   None 
     * @param dtpOper Condition for retrying transactions. (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call currentDtRetryAsync(DTPOperDto dtpOper, final ApiCallback<DTPOperResultDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = currentDtRetryValidateBeforeCall(dtpOper, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<DTPOperResultDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for dtTrackQuery
     * @param conditionData Condition for querying transaction tracks. (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call dtTrackQueryCall(ConditionDataDto conditionData, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = conditionData;

        // create path and map variables
        String localVarPath = "/rest/dtpServer/v1/northbound/dtTrackQuery";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call dtTrackQueryValidateBeforeCall(ConditionDataDto conditionData, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'conditionData' is set
        if (conditionData == null) {
            throw new ApiException("Missing the required parameter 'conditionData' when calling dtTrackQuery(Async)");
        }
        

        com.squareup.okhttp.Call call = dtTrackQueryCall(conditionData, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Query Transaction Tracks
     * ## Scenario ##   Tracks during the execution of a specific transaction need to be queried. ## Function ##   Query the details, execution time, and initiator of a distributed transaction in each phase based on the transaction ID and event. ## Constraint ##   None 
     * @param conditionData Condition for querying transaction tracks. (required)
     * @return DTPLogsDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public DTPLogsDto dtTrackQuery(ConditionDataDto conditionData) throws ApiException {
        ApiResponse<DTPLogsDto> resp = dtTrackQueryWithHttpInfo(conditionData);
        return resp.getData();
    }

    /**
     * Query Transaction Tracks
     * ## Scenario ##   Tracks during the execution of a specific transaction need to be queried. ## Function ##   Query the details, execution time, and initiator of a distributed transaction in each phase based on the transaction ID and event. ## Constraint ##   None 
     * @param conditionData Condition for querying transaction tracks. (required)
     * @return ApiResponse&lt;DTPLogsDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<DTPLogsDto> dtTrackQueryWithHttpInfo(ConditionDataDto conditionData) throws ApiException {
        com.squareup.okhttp.Call call = dtTrackQueryValidateBeforeCall(conditionData, null, null);
        Type localVarReturnType = new TypeToken<DTPLogsDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Query Transaction Tracks (asynchronously)
     * ## Scenario ##   Tracks during the execution of a specific transaction need to be queried. ## Function ##   Query the details, execution time, and initiator of a distributed transaction in each phase based on the transaction ID and event. ## Constraint ##   None 
     * @param conditionData Condition for querying transaction tracks. (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call dtTrackQueryAsync(ConditionDataDto conditionData, final ApiCallback<DTPLogsDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = dtTrackQueryValidateBeforeCall(conditionData, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<DTPLogsDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
