/*
 * Device Configuration History
 * Device configuration history APIs: · Query Device Configuration History · Query Details About Historical Device Configuration Records · Query Configuration Records · Export Historical Configuration Records · Query the Progress of Exporting Configuration Records · Download Exported Configuration Records · Save Southbound Device Configurations 
 *
 * OpenAPI spec version: 1.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.service;

import com.huawei.aoc.api.ApiCallback;
import com.huawei.aoc.api.ApiClient;
import com.huawei.aoc.api.ApiException;
import com.huawei.aoc.api.ApiResponse;
import com.huawei.aoc.api.Configuration;
import com.huawei.aoc.api.Pair;
import com.huawei.aoc.api.ProgressRequestBody;
import com.huawei.aoc.api.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;



import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class HiscmdExportboundApi {
    private ApiClient apiClient;

    public HiscmdExportboundApi() {
        this(Configuration.getDefaultApiClient());
    }

    public HiscmdExportboundApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for getExportFile
     * @param filename  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getExportFileCall(String filename, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/hiscmd/ecs/export/gather/{filename}"
            .replaceAll("\\{" + "filename" + "\\}", apiClient.escapeString(filename.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getExportFileValidateBeforeCall(String filename, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'filename' is set
        if (filename == null) {
            throw new ApiException("Missing the required parameter 'filename' when calling getExportFile(Async)");
        }
        

        com.squareup.okhttp.Call call = getExportFileCall(filename, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Download Exported Configuration Records
     * ## Typical Scenario ##   When the process of exporting configuration records reaches 100%, the file in which the exported configuration records are compressed needs to be downloaded to a local directory. ## Function ##   Download the exported configuration record file. ## Constraint ##   The controller is running properly. 
     * @param filename  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void getExportFile(String filename) throws ApiException {
        getExportFileWithHttpInfo(filename);
    }

    /**
     * Download Exported Configuration Records
     * ## Typical Scenario ##   When the process of exporting configuration records reaches 100%, the file in which the exported configuration records are compressed needs to be downloaded to a local directory. ## Function ##   Download the exported configuration record file. ## Constraint ##   The controller is running properly. 
     * @param filename  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> getExportFileWithHttpInfo(String filename) throws ApiException {
        com.squareup.okhttp.Call call = getExportFileValidateBeforeCall(filename, null, null);
        return apiClient.execute(call);
    }

    /**
     * Download Exported Configuration Records (asynchronously)
     * ## Typical Scenario ##   When the process of exporting configuration records reaches 100%, the file in which the exported configuration records are compressed needs to be downloaded to a local directory. ## Function ##   Download the exported configuration record file. ## Constraint ##   The controller is running properly. 
     * @param filename  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getExportFileAsync(String filename, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getExportFileValidateBeforeCall(filename, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
}
