/*
 * Device Configuration History
 * Device configuration history APIs: · Query Device Configuration History · Query Details About Historical Device Configuration Records · Query Configuration Records · Export Historical Configuration Records · Query the Progress of Exporting Configuration Records · Download Exported Configuration Records · Save Southbound Device Configurations 
 *
 * OpenAPI spec version: 1.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.service;

import com.huawei.aoc.api.ApiCallback;
import com.huawei.aoc.api.ApiClient;
import com.huawei.aoc.api.ApiException;
import com.huawei.aoc.api.ApiResponse;
import com.huawei.aoc.api.Configuration;
import com.huawei.aoc.api.Pair;
import com.huawei.aoc.api.ProgressRequestBody;
import com.huawei.aoc.api.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import com.huawei.aoc.api.model.ExportHiscmdInput;
import com.huawei.aoc.api.model.ExportHiscmdOutput;
import com.huawei.aoc.api.model.GetAllHiscmdInput;
import com.huawei.aoc.api.model.GetAllHiscmdOutput;
import com.huawei.aoc.api.model.GetBriefHiscmdInput;
import com.huawei.aoc.api.model.GetBriefHiscmdOutput;
import com.huawei.aoc.api.model.GetFpHiscmdInput;
import com.huawei.aoc.api.model.GetFpHiscmdOutput;
import com.huawei.aoc.api.model.QueryExportHiscmdOutput;
import com.huawei.aoc.api.model.QueryExportHiscmdStatusInput;
import com.huawei.aoc.api.model.SaveFpInput;
import com.huawei.aoc.api.model.SaveFpOutput;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class HuaweiAcIuiHiscmdServiceApi {
    private ApiClient apiClient;

    public HuaweiAcIuiHiscmdServiceApi() {
        this(Configuration.getDefaultApiClient());
    }

    public HuaweiAcIuiHiscmdServiceApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for exportHiscmd
     * @param iuiHiscmd  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call exportHiscmdCall(ExportHiscmdInput iuiHiscmd, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = iuiHiscmd;

        // create path and map variables
        String localVarPath = "/restconf/operations/huawei-ac-iui-hiscmd:export-hiscmd";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call exportHiscmdValidateBeforeCall(ExportHiscmdInput iuiHiscmd, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'iuiHiscmd' is set
        if (iuiHiscmd == null) {
            throw new ApiException("Missing the required parameter 'iuiHiscmd' when calling exportHiscmd(Async)");
        }
        

        com.squareup.okhttp.Call call = exportHiscmdCall(iuiHiscmd, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Export Historical Configuration Records
     * ## Typical Scenario ##   Historical configuration records need to be exported so that they can be checked offline. ## Function ##   Export Historical Configuration Records ## Constraint ##   The controller is running properly. 
     * @param iuiHiscmd  (required)
     * @return ExportHiscmdOutput
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ExportHiscmdOutput exportHiscmd(ExportHiscmdInput iuiHiscmd) throws ApiException {
        ApiResponse<ExportHiscmdOutput> resp = exportHiscmdWithHttpInfo(iuiHiscmd);
        return resp.getData();
    }

    /**
     * Export Historical Configuration Records
     * ## Typical Scenario ##   Historical configuration records need to be exported so that they can be checked offline. ## Function ##   Export Historical Configuration Records ## Constraint ##   The controller is running properly. 
     * @param iuiHiscmd  (required)
     * @return ApiResponse&lt;ExportHiscmdOutput&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ExportHiscmdOutput> exportHiscmdWithHttpInfo(ExportHiscmdInput iuiHiscmd) throws ApiException {
        com.squareup.okhttp.Call call = exportHiscmdValidateBeforeCall(iuiHiscmd, null, null);
        Type localVarReturnType = new TypeToken<ExportHiscmdOutput>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Export Historical Configuration Records (asynchronously)
     * ## Typical Scenario ##   Historical configuration records need to be exported so that they can be checked offline. ## Function ##   Export Historical Configuration Records ## Constraint ##   The controller is running properly. 
     * @param iuiHiscmd  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call exportHiscmdAsync(ExportHiscmdInput iuiHiscmd, final ApiCallback<ExportHiscmdOutput> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = exportHiscmdValidateBeforeCall(iuiHiscmd, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ExportHiscmdOutput>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getAllHiscmd
     * @param iuiHiscmd  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getAllHiscmdCall(GetAllHiscmdInput iuiHiscmd, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = iuiHiscmd;

        // create path and map variables
        String localVarPath = "/restconf/operations/huawei-ac-iui-hiscmd:get-all-hiscmd";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getAllHiscmdValidateBeforeCall(GetAllHiscmdInput iuiHiscmd, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'iuiHiscmd' is set
        if (iuiHiscmd == null) {
            throw new ApiException("Missing the required parameter 'iuiHiscmd' when calling getAllHiscmd(Async)");
        }
        

        com.squareup.okhttp.Call call = getAllHiscmdCall(iuiHiscmd, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Query Device Configuration History
     * ## Typical Scenario ##   During routine maintenance, information about the delivered device configurations and record time needs to be queried. ## Function ##   Query information about the delivered device configurations. ## Constraint ## The controller is running properly. 
     * @param iuiHiscmd  (required)
     * @return GetAllHiscmdOutput
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public GetAllHiscmdOutput getAllHiscmd(GetAllHiscmdInput iuiHiscmd) throws ApiException {
        ApiResponse<GetAllHiscmdOutput> resp = getAllHiscmdWithHttpInfo(iuiHiscmd);
        return resp.getData();
    }

    /**
     * Query Device Configuration History
     * ## Typical Scenario ##   During routine maintenance, information about the delivered device configurations and record time needs to be queried. ## Function ##   Query information about the delivered device configurations. ## Constraint ## The controller is running properly. 
     * @param iuiHiscmd  (required)
     * @return ApiResponse&lt;GetAllHiscmdOutput&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<GetAllHiscmdOutput> getAllHiscmdWithHttpInfo(GetAllHiscmdInput iuiHiscmd) throws ApiException {
        com.squareup.okhttp.Call call = getAllHiscmdValidateBeforeCall(iuiHiscmd, null, null);
        Type localVarReturnType = new TypeToken<GetAllHiscmdOutput>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Query Device Configuration History (asynchronously)
     * ## Typical Scenario ##   During routine maintenance, information about the delivered device configurations and record time needs to be queried. ## Function ##   Query information about the delivered device configurations. ## Constraint ## The controller is running properly. 
     * @param iuiHiscmd  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getAllHiscmdAsync(GetAllHiscmdInput iuiHiscmd, final ApiCallback<GetAllHiscmdOutput> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getAllHiscmdValidateBeforeCall(iuiHiscmd, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<GetAllHiscmdOutput>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getBriefHiscmd
     * @param iuiHiscmd  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getBriefHiscmdCall(GetBriefHiscmdInput iuiHiscmd, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = iuiHiscmd;

        // create path and map variables
        String localVarPath = "/restconf/operations/huawei-ac-iui-hiscmd:get-brief-hiscmd";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getBriefHiscmdValidateBeforeCall(GetBriefHiscmdInput iuiHiscmd, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'iuiHiscmd' is set
        if (iuiHiscmd == null) {
            throw new ApiException("Missing the required parameter 'iuiHiscmd' when calling getBriefHiscmd(Async)");
        }
        

        com.squareup.okhttp.Call call = getBriefHiscmdCall(iuiHiscmd, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Query Configuration Records
     * ## Typical Scenario ##   Details about configurations delivered from the controller, including device information, configuration time, operation type, and delivered packets, need to be queried. ## Function ##   Query details about configurations delivered from the controller. ## Constraint ##   The controller is running properly. 
     * @param iuiHiscmd  (required)
     * @return GetBriefHiscmdOutput
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public GetBriefHiscmdOutput getBriefHiscmd(GetBriefHiscmdInput iuiHiscmd) throws ApiException {
        ApiResponse<GetBriefHiscmdOutput> resp = getBriefHiscmdWithHttpInfo(iuiHiscmd);
        return resp.getData();
    }

    /**
     * Query Configuration Records
     * ## Typical Scenario ##   Details about configurations delivered from the controller, including device information, configuration time, operation type, and delivered packets, need to be queried. ## Function ##   Query details about configurations delivered from the controller. ## Constraint ##   The controller is running properly. 
     * @param iuiHiscmd  (required)
     * @return ApiResponse&lt;GetBriefHiscmdOutput&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<GetBriefHiscmdOutput> getBriefHiscmdWithHttpInfo(GetBriefHiscmdInput iuiHiscmd) throws ApiException {
        com.squareup.okhttp.Call call = getBriefHiscmdValidateBeforeCall(iuiHiscmd, null, null);
        Type localVarReturnType = new TypeToken<GetBriefHiscmdOutput>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Query Configuration Records (asynchronously)
     * ## Typical Scenario ##   Details about configurations delivered from the controller, including device information, configuration time, operation type, and delivered packets, need to be queried. ## Function ##   Query details about configurations delivered from the controller. ## Constraint ##   The controller is running properly. 
     * @param iuiHiscmd  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getBriefHiscmdAsync(GetBriefHiscmdInput iuiHiscmd, final ApiCallback<GetBriefHiscmdOutput> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getBriefHiscmdValidateBeforeCall(iuiHiscmd, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<GetBriefHiscmdOutput>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getFpHiscmd
     * @param iuiHiscmd  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getFpHiscmdCall(GetFpHiscmdInput iuiHiscmd, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = iuiHiscmd;

        // create path and map variables
        String localVarPath = "/restconf/operations/huawei-ac-iui-hiscmd:get-fp-hiscmd";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getFpHiscmdValidateBeforeCall(GetFpHiscmdInput iuiHiscmd, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'iuiHiscmd' is set
        if (iuiHiscmd == null) {
            throw new ApiException("Missing the required parameter 'iuiHiscmd' when calling getFpHiscmd(Async)");
        }
        

        com.squareup.okhttp.Call call = getFpHiscmdCall(iuiHiscmd, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Query Details About Historical Device Configuration Records
     * ## Typical Scenario ##   Details about device configurations delivered from the controller, including the feature name, configuration time, operation type, and delivered packets, need to be queried. ## Function ##   Query details about device configurations delivered from the controller. ## Constraint ##   The controller is running properly. 
     * @param iuiHiscmd  (required)
     * @return GetFpHiscmdOutput
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public GetFpHiscmdOutput getFpHiscmd(GetFpHiscmdInput iuiHiscmd) throws ApiException {
        ApiResponse<GetFpHiscmdOutput> resp = getFpHiscmdWithHttpInfo(iuiHiscmd);
        return resp.getData();
    }

    /**
     * Query Details About Historical Device Configuration Records
     * ## Typical Scenario ##   Details about device configurations delivered from the controller, including the feature name, configuration time, operation type, and delivered packets, need to be queried. ## Function ##   Query details about device configurations delivered from the controller. ## Constraint ##   The controller is running properly. 
     * @param iuiHiscmd  (required)
     * @return ApiResponse&lt;GetFpHiscmdOutput&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<GetFpHiscmdOutput> getFpHiscmdWithHttpInfo(GetFpHiscmdInput iuiHiscmd) throws ApiException {
        com.squareup.okhttp.Call call = getFpHiscmdValidateBeforeCall(iuiHiscmd, null, null);
        Type localVarReturnType = new TypeToken<GetFpHiscmdOutput>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Query Details About Historical Device Configuration Records (asynchronously)
     * ## Typical Scenario ##   Details about device configurations delivered from the controller, including the feature name, configuration time, operation type, and delivered packets, need to be queried. ## Function ##   Query details about device configurations delivered from the controller. ## Constraint ##   The controller is running properly. 
     * @param iuiHiscmd  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getFpHiscmdAsync(GetFpHiscmdInput iuiHiscmd, final ApiCallback<GetFpHiscmdOutput> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getFpHiscmdValidateBeforeCall(iuiHiscmd, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<GetFpHiscmdOutput>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for queryExportHiscmdStatus
     * @param iuiHiscmd  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call queryExportHiscmdStatusCall(QueryExportHiscmdStatusInput iuiHiscmd, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = iuiHiscmd;

        // create path and map variables
        String localVarPath = "/restconf/operations/huawei-ac-iui-hiscmd:query-export-hiscmd-status";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call queryExportHiscmdStatusValidateBeforeCall(QueryExportHiscmdStatusInput iuiHiscmd, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'iuiHiscmd' is set
        if (iuiHiscmd == null) {
            throw new ApiException("Missing the required parameter 'iuiHiscmd' when calling queryExportHiscmdStatus(Async)");
        }
        

        com.squareup.okhttp.Call call = queryExportHiscmdStatusCall(iuiHiscmd, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Query the Progress of Exporting Configuration Records
     * ## Typical Scenario ##   After a configuration record export request is initiated, whether the configuration record export task is complete needs to be checked. ## Function ##   Query the progress of a configuration record export task. ## Constraint ##   The controller is running properly. 
     * @param iuiHiscmd  (required)
     * @return QueryExportHiscmdOutput
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public QueryExportHiscmdOutput queryExportHiscmdStatus(QueryExportHiscmdStatusInput iuiHiscmd) throws ApiException {
        ApiResponse<QueryExportHiscmdOutput> resp = queryExportHiscmdStatusWithHttpInfo(iuiHiscmd);
        return resp.getData();
    }

    /**
     * Query the Progress of Exporting Configuration Records
     * ## Typical Scenario ##   After a configuration record export request is initiated, whether the configuration record export task is complete needs to be checked. ## Function ##   Query the progress of a configuration record export task. ## Constraint ##   The controller is running properly. 
     * @param iuiHiscmd  (required)
     * @return ApiResponse&lt;QueryExportHiscmdOutput&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<QueryExportHiscmdOutput> queryExportHiscmdStatusWithHttpInfo(QueryExportHiscmdStatusInput iuiHiscmd) throws ApiException {
        com.squareup.okhttp.Call call = queryExportHiscmdStatusValidateBeforeCall(iuiHiscmd, null, null);
        Type localVarReturnType = new TypeToken<QueryExportHiscmdOutput>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Query the Progress of Exporting Configuration Records (asynchronously)
     * ## Typical Scenario ##   After a configuration record export request is initiated, whether the configuration record export task is complete needs to be checked. ## Function ##   Query the progress of a configuration record export task. ## Constraint ##   The controller is running properly. 
     * @param iuiHiscmd  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call queryExportHiscmdStatusAsync(QueryExportHiscmdStatusInput iuiHiscmd, final ApiCallback<QueryExportHiscmdOutput> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = queryExportHiscmdStatusValidateBeforeCall(iuiHiscmd, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<QueryExportHiscmdOutput>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for saveFp
     * @param iuiHiscmd  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call saveFpCall(SaveFpInput iuiHiscmd, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = iuiHiscmd;

        // create path and map variables
        String localVarPath = "/restconf/operations/huawei-ac-iui-hiscmd:save-fp";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call saveFpValidateBeforeCall(SaveFpInput iuiHiscmd, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'iuiHiscmd' is set
        if (iuiHiscmd == null) {
            throw new ApiException("Missing the required parameter 'iuiHiscmd' when calling saveFp(Async)");
        }
        

        com.squareup.okhttp.Call call = saveFpCall(iuiHiscmd, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Save Southbound Device Configurations
     * ## Typical Scenario ##   After new configurations are added to a southbound device, a configuration saving request needs to be sent to prevent configuration loss. ## Function ##   Send a configuration saving command to the southbound device. ## Constraint ##   1. The southbound device is running properly.   2. The controller is running properly. 
     * @param iuiHiscmd  (required)
     * @return SaveFpOutput
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public SaveFpOutput saveFp(SaveFpInput iuiHiscmd) throws ApiException {
        ApiResponse<SaveFpOutput> resp = saveFpWithHttpInfo(iuiHiscmd);
        return resp.getData();
    }

    /**
     * Save Southbound Device Configurations
     * ## Typical Scenario ##   After new configurations are added to a southbound device, a configuration saving request needs to be sent to prevent configuration loss. ## Function ##   Send a configuration saving command to the southbound device. ## Constraint ##   1. The southbound device is running properly.   2. The controller is running properly. 
     * @param iuiHiscmd  (required)
     * @return ApiResponse&lt;SaveFpOutput&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<SaveFpOutput> saveFpWithHttpInfo(SaveFpInput iuiHiscmd) throws ApiException {
        com.squareup.okhttp.Call call = saveFpValidateBeforeCall(iuiHiscmd, null, null);
        Type localVarReturnType = new TypeToken<SaveFpOutput>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Save Southbound Device Configurations (asynchronously)
     * ## Typical Scenario ##   After new configurations are added to a southbound device, a configuration saving request needs to be sent to prevent configuration loss. ## Function ##   Send a configuration saving command to the southbound device. ## Constraint ##   1. The southbound device is running properly.   2. The controller is running properly. 
     * @param iuiHiscmd  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call saveFpAsync(SaveFpInput iuiHiscmd, final ApiCallback<SaveFpOutput> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = saveFpValidateBeforeCall(iuiHiscmd, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<SaveFpOutput>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
