/*
 * Northbound Transparent Transmission API for Issuing CLI Commands
 * Northbound Transparent Transmission API for Issuing CLI Commands · Deliver CLI Commands 
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.service;

import com.huawei.aoc.api.ApiCallback;
import com.huawei.aoc.api.ApiClient;
import com.huawei.aoc.api.ApiException;
import com.huawei.aoc.api.ApiResponse;
import com.huawei.aoc.api.Configuration;
import com.huawei.aoc.api.Pair;
import com.huawei.aoc.api.ProgressRequestBody;
import com.huawei.aoc.api.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import com.huawei.aoc.api.model.PassthroughSendCliInput;
import com.huawei.aoc.api.model.PassthroughSendCliOutput;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class HuaweiNcePassthroughCliNorthboundApi {
    private ApiClient apiClient;

    public HuaweiNcePassthroughCliNorthboundApi() {
        this(Configuration.getDefaultApiClient());
    }

    public HuaweiNcePassthroughCliNorthboundApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for passthroughSendCli
     * @param input  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call passthroughSendCliCall(PassthroughSendCliInput input, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = input;

        // create path and map variables
        String localVarPath = "/restconf/operations/huawei-nce-passthrough-cli-northbound:passthrough-send-cli";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call passthroughSendCliValidateBeforeCall(PassthroughSendCliInput input, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        

        com.squareup.okhttp.Call call = passthroughSendCliCall(input, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Deliver CLI Commands
     * ## Typical Scenario ##  The CLI query commands or commands for entering views need to be issued to a device. ## Function ##  Deliver the CLI query commands or commands for entering views to a device. ## Constraint ##  1. This API applies only to subscribers and can be used only after user sessions are established. A command whitelist must be created before you deliver CLI query commands or commands for entering views. Only commands in the whitelist can be successfully delivered.  2. When delivering a command, you need to confirm the view of the current operation based on the previously delivered command. Ensure that the command to be delivered is allowed and correct in the view.  3. When delivering a CLI command, you are advised to deliver a command for entering the initial view on the desired device and then perform related query. 
     * @param input  (optional)
     * @return PassthroughSendCliOutput
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PassthroughSendCliOutput passthroughSendCli(PassthroughSendCliInput input) throws ApiException {
        ApiResponse<PassthroughSendCliOutput> resp = passthroughSendCliWithHttpInfo(input);
        return resp.getData();
    }

    /**
     * Deliver CLI Commands
     * ## Typical Scenario ##  The CLI query commands or commands for entering views need to be issued to a device. ## Function ##  Deliver the CLI query commands or commands for entering views to a device. ## Constraint ##  1. This API applies only to subscribers and can be used only after user sessions are established. A command whitelist must be created before you deliver CLI query commands or commands for entering views. Only commands in the whitelist can be successfully delivered.  2. When delivering a command, you need to confirm the view of the current operation based on the previously delivered command. Ensure that the command to be delivered is allowed and correct in the view.  3. When delivering a CLI command, you are advised to deliver a command for entering the initial view on the desired device and then perform related query. 
     * @param input  (optional)
     * @return ApiResponse&lt;PassthroughSendCliOutput&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PassthroughSendCliOutput> passthroughSendCliWithHttpInfo(PassthroughSendCliInput input) throws ApiException {
        com.squareup.okhttp.Call call = passthroughSendCliValidateBeforeCall(input, null, null);
        Type localVarReturnType = new TypeToken<PassthroughSendCliOutput>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Deliver CLI Commands (asynchronously)
     * ## Typical Scenario ##  The CLI query commands or commands for entering views need to be issued to a device. ## Function ##  Deliver the CLI query commands or commands for entering views to a device. ## Constraint ##  1. This API applies only to subscribers and can be used only after user sessions are established. A command whitelist must be created before you deliver CLI query commands or commands for entering views. Only commands in the whitelist can be successfully delivered.  2. When delivering a command, you need to confirm the view of the current operation based on the previously delivered command. Ensure that the command to be delivered is allowed and correct in the view.  3. When delivering a CLI command, you are advised to deliver a command for entering the initial view on the desired device and then perform related query. 
     * @param input  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call passthroughSendCliAsync(PassthroughSendCliInput input, final ApiCallback<PassthroughSendCliOutput> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = passthroughSendCliValidateBeforeCall(input, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PassthroughSendCliOutput>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
