/*
 * Device Management
 * Device management APIs, including: Creating, deleting, modifying, viewing, and importing NEs  ** SLA: **  |SLA item|Definition| |-----|-----| |Request success rate| ≥ 99%| |Availability|Tier2| |Data consistency|Eventually consistent, inconsistent duration <1 minute| |Throughput|1000 tps| |TP50 request delay|200 ms| |TP99.9 request delay|1000 ms| 
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.service;

import com.huawei.aoc.api.ApiCallback;
import com.huawei.aoc.api.ApiClient;
import com.huawei.aoc.api.ApiException;
import com.huawei.aoc.api.ApiResponse;
import com.huawei.aoc.api.Configuration;
import com.huawei.aoc.api.Pair;
import com.huawei.aoc.api.ProgressRequestBody;
import com.huawei.aoc.api.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import com.huawei.aoc.api.model.CreateNECommuParamTemplateRspDTO;
import com.huawei.aoc.api.model.NECommuParamTemplateFullInfoDTO;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class NeCommuParamTemplateService1Api {
    private ApiClient apiClient;

    public NeCommuParamTemplateService1Api() {
        this(Configuration.getDefaultApiClient());
    }

    public NeCommuParamTemplateService1Api(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for createNECommuParamTemplate
     * @param paramTemplate Complete template information, including basic template information and detailed communication parameters. (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createNECommuParamTemplateCall(NECommuParamTemplateFullInfoDTO paramTemplate, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = paramTemplate;

        // create path and map variables
        String localVarPath = "/rest/neresmgmtservice/v1/necommuparam-templates";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createNECommuParamTemplateValidateBeforeCall(NECommuParamTemplateFullInfoDTO paramTemplate, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'paramTemplate' is set
        if (paramTemplate == null) {
            throw new ApiException("Missing the required parameter 'paramTemplate' when calling createNECommuParamTemplate(Async)");
        }
        

        com.squareup.okhttp.Call call = createNECommuParamTemplateCall(paramTemplate, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Create a Communication Parameter Template
     * ## Typical Scenario ##  A communication parameter template needs to be created. ## Function ##  Create a communication parameter template. ## Constraint ##  This is a northbound API. The request header must contain the northbound token obtained in advance. 
     * @param paramTemplate Complete template information, including basic template information and detailed communication parameters. (required)
     * @return CreateNECommuParamTemplateRspDTO
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public CreateNECommuParamTemplateRspDTO createNECommuParamTemplate(NECommuParamTemplateFullInfoDTO paramTemplate) throws ApiException {
        ApiResponse<CreateNECommuParamTemplateRspDTO> resp = createNECommuParamTemplateWithHttpInfo(paramTemplate);
        return resp.getData();
    }

    /**
     * Create a Communication Parameter Template
     * ## Typical Scenario ##  A communication parameter template needs to be created. ## Function ##  Create a communication parameter template. ## Constraint ##  This is a northbound API. The request header must contain the northbound token obtained in advance. 
     * @param paramTemplate Complete template information, including basic template information and detailed communication parameters. (required)
     * @return ApiResponse&lt;CreateNECommuParamTemplateRspDTO&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<CreateNECommuParamTemplateRspDTO> createNECommuParamTemplateWithHttpInfo(NECommuParamTemplateFullInfoDTO paramTemplate) throws ApiException {
        com.squareup.okhttp.Call call = createNECommuParamTemplateValidateBeforeCall(paramTemplate, null, null);
        Type localVarReturnType = new TypeToken<CreateNECommuParamTemplateRspDTO>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Create a Communication Parameter Template (asynchronously)
     * ## Typical Scenario ##  A communication parameter template needs to be created. ## Function ##  Create a communication parameter template. ## Constraint ##  This is a northbound API. The request header must contain the northbound token obtained in advance. 
     * @param paramTemplate Complete template information, including basic template information and detailed communication parameters. (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createNECommuParamTemplateAsync(NECommuParamTemplateFullInfoDTO paramTemplate, final ApiCallback<CreateNECommuParamTemplateRspDTO> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createNECommuParamTemplateValidateBeforeCall(paramTemplate, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<CreateNECommuParamTemplateRspDTO>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
