/*
 * Device Management
 * Device management APIs, including: Creating, deleting, modifying, viewing, and importing NEs  ** SLA: **  |SLA item|Definition| |-----|-----| |Request success rate| ≥ 99%| |Availability|Tier2| |Data consistency|Eventually consistent, inconsistent duration <1 minute| |Throughput|1000 tps| |TP50 request delay|200 ms| |TP99.9 request delay|1000 ms| 
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.service;

import com.huawei.aoc.api.ApiCallback;
import com.huawei.aoc.api.ApiClient;
import com.huawei.aoc.api.ApiException;
import com.huawei.aoc.api.ApiResponse;
import com.huawei.aoc.api.Configuration;
import com.huawei.aoc.api.Pair;
import com.huawei.aoc.api.ProgressRequestBody;
import com.huawei.aoc.api.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import com.huawei.aoc.api.model.NECommuParamTemplateListDTO;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class NeCommuParamTemplateServiceApi {
    private ApiClient apiClient;

    public NeCommuParamTemplateServiceApi() {
        this(Configuration.getDefaultApiClient());
    }

    public NeCommuParamTemplateServiceApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for getNECommuParamTemplates
     * @param name Template name, which is matched in fuzzy mode. (optional)
     * @param templateType Template type. The value can be SNMP, NETCONF, TELNET, STELNET, or QX. (optional)
     * @param limit Maximum number of templates that can be queried at a time. The default value is 1000. (optional, default to 1000)
     * @param marker Pagination marker. (optional)
     * @param sortName Sorting field. (optional)
     * @param sortType Sorting type. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getNECommuParamTemplatesCall(String name, String templateType, Integer limit, String marker, String sortName, String sortType, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/rest/neresmgmtservice/v1/necommuparam-templates";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (name != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("name", name));
        if (templateType != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("template-type", templateType));
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("limit", limit));
        if (marker != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("marker", marker));
        if (sortName != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sort-name", sortName));
        if (sortType != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sort-type", sortType));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getNECommuParamTemplatesValidateBeforeCall(String name, String templateType, Integer limit, String marker, String sortName, String sortType, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        

        com.squareup.okhttp.Call call = getNECommuParamTemplatesCall(name, templateType, limit, marker, sortName, sortType, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Query a Communication Parameter Template
     * ## Typical Scenario ##  A communication parameter template needs to be queried. ## Function ##  Query a communication parameter template. ## Constraint ##  This is a northbound API. The request header must contain the northbound token obtained in advance. 
     * @param name Template name, which is matched in fuzzy mode. (optional)
     * @param templateType Template type. The value can be SNMP, NETCONF, TELNET, STELNET, or QX. (optional)
     * @param limit Maximum number of templates that can be queried at a time. The default value is 1000. (optional, default to 1000)
     * @param marker Pagination marker. (optional)
     * @param sortName Sorting field. (optional)
     * @param sortType Sorting type. (optional)
     * @return NECommuParamTemplateListDTO
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public NECommuParamTemplateListDTO getNECommuParamTemplates(String name, String templateType, Integer limit, String marker, String sortName, String sortType) throws ApiException {
        ApiResponse<NECommuParamTemplateListDTO> resp = getNECommuParamTemplatesWithHttpInfo(name, templateType, limit, marker, sortName, sortType);
        return resp.getData();
    }

    /**
     * Query a Communication Parameter Template
     * ## Typical Scenario ##  A communication parameter template needs to be queried. ## Function ##  Query a communication parameter template. ## Constraint ##  This is a northbound API. The request header must contain the northbound token obtained in advance. 
     * @param name Template name, which is matched in fuzzy mode. (optional)
     * @param templateType Template type. The value can be SNMP, NETCONF, TELNET, STELNET, or QX. (optional)
     * @param limit Maximum number of templates that can be queried at a time. The default value is 1000. (optional, default to 1000)
     * @param marker Pagination marker. (optional)
     * @param sortName Sorting field. (optional)
     * @param sortType Sorting type. (optional)
     * @return ApiResponse&lt;NECommuParamTemplateListDTO&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<NECommuParamTemplateListDTO> getNECommuParamTemplatesWithHttpInfo(String name, String templateType, Integer limit, String marker, String sortName, String sortType) throws ApiException {
        com.squareup.okhttp.Call call = getNECommuParamTemplatesValidateBeforeCall(name, templateType, limit, marker, sortName, sortType, null, null);
        Type localVarReturnType = new TypeToken<NECommuParamTemplateListDTO>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Query a Communication Parameter Template (asynchronously)
     * ## Typical Scenario ##  A communication parameter template needs to be queried. ## Function ##  Query a communication parameter template. ## Constraint ##  This is a northbound API. The request header must contain the northbound token obtained in advance. 
     * @param name Template name, which is matched in fuzzy mode. (optional)
     * @param templateType Template type. The value can be SNMP, NETCONF, TELNET, STELNET, or QX. (optional)
     * @param limit Maximum number of templates that can be queried at a time. The default value is 1000. (optional, default to 1000)
     * @param marker Pagination marker. (optional)
     * @param sortName Sorting field. (optional)
     * @param sortType Sorting type. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getNECommuParamTemplatesAsync(String name, String templateType, Integer limit, String marker, String sortName, String sortType, final ApiCallback<NECommuParamTemplateListDTO> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getNECommuParamTemplatesValidateBeforeCall(name, templateType, limit, marker, sortName, sortType, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<NECommuParamTemplateListDTO>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
