/*
 * Device Management
 * Device management APIs, including: Creating, deleting, modifying, viewing, and importing NEs  ** SLA: **  |SLA item|Definition| |-----|-----| |Request success rate| ≥ 99%| |Availability|Tier2| |Data consistency|Eventually consistent, inconsistent duration <1 minute| |Throughput|1000 tps| |TP50 request delay|200 ms| |TP99.9 request delay|1000 ms| 
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.service;

import com.huawei.aoc.api.ApiCallback;
import com.huawei.aoc.api.ApiClient;
import com.huawei.aoc.api.ApiException;
import com.huawei.aoc.api.ApiResponse;
import com.huawei.aoc.api.Configuration;
import com.huawei.aoc.api.Pair;
import com.huawei.aoc.api.ProgressRequestBody;
import com.huawei.aoc.api.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import com.huawei.aoc.api.model.OperateResult;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class NeResManagementService3Api {
    private ApiClient apiClient;

    public NeResManagementService3Api() {
        this(Configuration.getDefaultApiClient());
    }

    public NeResManagementService3Api(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for batchDeleteNEs
     * @param neIdList Complete device information, including basic device information and detailed communication parameters. (required)
     * @param forceDelete Whether to forcibly delete the device. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call batchDeleteNEsCall(List<String> neIdList, String forceDelete, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = neIdList;

        // create path and map variables
        String localVarPath = "/rest/neresmgmtservice/v1/nes/action/batch-delete";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (forceDelete != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("forceDelete", forceDelete));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call batchDeleteNEsValidateBeforeCall(List<String> neIdList, String forceDelete, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'neIdList' is set
        if (neIdList == null) {
            throw new ApiException("Missing the required parameter 'neIdList' when calling batchDeleteNEs(Async)");
        }
        

        com.squareup.okhttp.Call call = batchDeleteNEsCall(neIdList, forceDelete, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Delete a Device
     * ## Typical Scenario ##   Device information needs to be deleted. ## Function ##   Delete basic device information. ## Constraint ##   This is a northbound API. The request header must contain the northbound token obtained in advance. 
     * @param neIdList Complete device information, including basic device information and detailed communication parameters. (required)
     * @param forceDelete Whether to forcibly delete the device. (optional)
     * @return OperateResult
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public OperateResult batchDeleteNEs(List<String> neIdList, String forceDelete) throws ApiException {
        ApiResponse<OperateResult> resp = batchDeleteNEsWithHttpInfo(neIdList, forceDelete);
        return resp.getData();
    }

    /**
     * Delete a Device
     * ## Typical Scenario ##   Device information needs to be deleted. ## Function ##   Delete basic device information. ## Constraint ##   This is a northbound API. The request header must contain the northbound token obtained in advance. 
     * @param neIdList Complete device information, including basic device information and detailed communication parameters. (required)
     * @param forceDelete Whether to forcibly delete the device. (optional)
     * @return ApiResponse&lt;OperateResult&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<OperateResult> batchDeleteNEsWithHttpInfo(List<String> neIdList, String forceDelete) throws ApiException {
        com.squareup.okhttp.Call call = batchDeleteNEsValidateBeforeCall(neIdList, forceDelete, null, null);
        Type localVarReturnType = new TypeToken<OperateResult>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Delete a Device (asynchronously)
     * ## Typical Scenario ##   Device information needs to be deleted. ## Function ##   Delete basic device information. ## Constraint ##   This is a northbound API. The request header must contain the northbound token obtained in advance. 
     * @param neIdList Complete device information, including basic device information and detailed communication parameters. (required)
     * @param forceDelete Whether to forcibly delete the device. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call batchDeleteNEsAsync(List<String> neIdList, String forceDelete, final ApiCallback<OperateResult> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = batchDeleteNEsValidateBeforeCall(neIdList, forceDelete, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<OperateResult>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
