/*
 * Device Management
 * Device management APIs, including: Creating, deleting, modifying, viewing, and importing NEs  ** SLA: **  |SLA item|Definition| |-----|-----| |Request success rate| ≥ 99%| |Availability|Tier2| |Data consistency|Eventually consistent, inconsistent duration <1 minute| |Throughput|1000 tps| |TP50 request delay|200 ms| |TP99.9 request delay|1000 ms| 
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.service;

import com.huawei.aoc.api.ApiCallback;
import com.huawei.aoc.api.ApiClient;
import com.huawei.aoc.api.ApiException;
import com.huawei.aoc.api.ApiResponse;
import com.huawei.aoc.api.Configuration;
import com.huawei.aoc.api.Pair;
import com.huawei.aoc.api.ProgressRequestBody;
import com.huawei.aoc.api.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import com.huawei.aoc.api.model.NeDetailInfoDto;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class NeResManagementService4Api {
    private ApiClient apiClient;

    public NeResManagementService4Api() {
        this(Configuration.getDefaultApiClient());
    }

    public NeResManagementService4Api(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for getNeDetailInfoById
     * @param neId Device UUID. (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getNeDetailInfoByIdCall(String neId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/rest/neresmgmtservice/v1/nes/{ne-id}"
            .replaceAll("\\{" + "ne-id" + "\\}", apiClient.escapeString(neId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getNeDetailInfoByIdValidateBeforeCall(String neId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'neId' is set
        if (neId == null) {
            throw new ApiException("Missing the required parameter 'neId' when calling getNeDetailInfoById(Async)");
        }
        

        com.squareup.okhttp.Call call = getNeDetailInfoByIdCall(neId, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Query Device Details
     * ## Typical Scenario ##   Detailed device information needs to be queried. ## Function ##   Query detailed device information. ## Constraint ##   This is a northbound API. The request header must contain the northbound token obtained in advance. 
     * @param neId Device UUID. (required)
     * @return NeDetailInfoDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public NeDetailInfoDto getNeDetailInfoById(String neId) throws ApiException {
        ApiResponse<NeDetailInfoDto> resp = getNeDetailInfoByIdWithHttpInfo(neId);
        return resp.getData();
    }

    /**
     * Query Device Details
     * ## Typical Scenario ##   Detailed device information needs to be queried. ## Function ##   Query detailed device information. ## Constraint ##   This is a northbound API. The request header must contain the northbound token obtained in advance. 
     * @param neId Device UUID. (required)
     * @return ApiResponse&lt;NeDetailInfoDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<NeDetailInfoDto> getNeDetailInfoByIdWithHttpInfo(String neId) throws ApiException {
        com.squareup.okhttp.Call call = getNeDetailInfoByIdValidateBeforeCall(neId, null, null);
        Type localVarReturnType = new TypeToken<NeDetailInfoDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Query Device Details (asynchronously)
     * ## Typical Scenario ##   Detailed device information needs to be queried. ## Function ##   Query detailed device information. ## Constraint ##   This is a northbound API. The request header must contain the northbound token obtained in advance. 
     * @param neId Device UUID. (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getNeDetailInfoByIdAsync(String neId, final ApiCallback<NeDetailInfoDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getNeDetailInfoByIdValidateBeforeCall(neId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<NeDetailInfoDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
