/*
 * Device Data Consistency
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.service;

import com.huawei.aoc.api.ApiCallback;
import com.huawei.aoc.api.ApiClient;
import com.huawei.aoc.api.ApiException;
import com.huawei.aoc.api.ApiResponse;
import com.huawei.aoc.api.Configuration;
import com.huawei.aoc.api.Pair;
import com.huawei.aoc.api.ProgressRequestBody;
import com.huawei.aoc.api.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import com.huawei.aoc.api.model.DeviceDiffDiscoveryReq;
import com.huawei.aoc.api.model.DeviceDiffDiscoveryRes;
import com.huawei.aoc.api.model.DiffDiscoveryResultReq;
import com.huawei.aoc.api.model.DiffDiscoveryResultRes;
import com.huawei.aoc.api.model.GroupDiffDiscoveryReq;
import com.huawei.aoc.api.model.QueryDeviceStatusListReq;
import com.huawei.aoc.api.model.QueryDeviceStatusListRes;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class OpfSyncEcsServiceApi {
    private ApiClient apiClient;

    public OpfSyncEcsServiceApi() {
        this(Configuration.getDefaultApiClient());
    }

    public OpfSyncEcsServiceApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for compareConfig
     * @param body Inconsistency discovery parameter. (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call compareConfigCall(DeviceDiffDiscoveryReq body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;

        // create path and map variables
        String localVarPath = "/restconf/operations/huawei-ac-opf-sync-ecs:compare-config";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call compareConfigValidateBeforeCall(DeviceDiffDiscoveryReq body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling compareConfig(Async)");
        }
        

        com.squareup.okhttp.Call call = compareConfigCall(body, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Perform Inconsistency Discovery, Synchronization, and Consistency Verification
     * ## Typical Scenario ##   During routine maintenance, the inconsistency discovery function needs to be used to discover inconsistencies between the controller and southbound devices, and then configuration synchronization from the controller or devices needs to be performed. ## Function ##   Perform inconsistency discovery to view the configuration inconsistencies between the controller and southbound devices, and quickly perform configuration synchronization from the controller or devices. ## Constraint ##   1. The southbound device is running properly.   2. The controller is running properly. 
     * @param body Inconsistency discovery parameter. (required)
     * @return DeviceDiffDiscoveryRes
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public DeviceDiffDiscoveryRes compareConfig(DeviceDiffDiscoveryReq body) throws ApiException {
        ApiResponse<DeviceDiffDiscoveryRes> resp = compareConfigWithHttpInfo(body);
        return resp.getData();
    }

    /**
     * Perform Inconsistency Discovery, Synchronization, and Consistency Verification
     * ## Typical Scenario ##   During routine maintenance, the inconsistency discovery function needs to be used to discover inconsistencies between the controller and southbound devices, and then configuration synchronization from the controller or devices needs to be performed. ## Function ##   Perform inconsistency discovery to view the configuration inconsistencies between the controller and southbound devices, and quickly perform configuration synchronization from the controller or devices. ## Constraint ##   1. The southbound device is running properly.   2. The controller is running properly. 
     * @param body Inconsistency discovery parameter. (required)
     * @return ApiResponse&lt;DeviceDiffDiscoveryRes&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<DeviceDiffDiscoveryRes> compareConfigWithHttpInfo(DeviceDiffDiscoveryReq body) throws ApiException {
        com.squareup.okhttp.Call call = compareConfigValidateBeforeCall(body, null, null);
        Type localVarReturnType = new TypeToken<DeviceDiffDiscoveryRes>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Perform Inconsistency Discovery, Synchronization, and Consistency Verification (asynchronously)
     * ## Typical Scenario ##   During routine maintenance, the inconsistency discovery function needs to be used to discover inconsistencies between the controller and southbound devices, and then configuration synchronization from the controller or devices needs to be performed. ## Function ##   Perform inconsistency discovery to view the configuration inconsistencies between the controller and southbound devices, and quickly perform configuration synchronization from the controller or devices. ## Constraint ##   1. The southbound device is running properly.   2. The controller is running properly. 
     * @param body Inconsistency discovery parameter. (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call compareConfigAsync(DeviceDiffDiscoveryReq body, final ApiCallback<DeviceDiffDiscoveryRes> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = compareConfigValidateBeforeCall(body, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<DeviceDiffDiscoveryRes>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for compareGroupConfig
     * @param body Inconsistency discovery parameter. (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call compareGroupConfigCall(GroupDiffDiscoveryReq body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;

        // create path and map variables
        String localVarPath = "/restconf/operations/huawei-ac-opf-sync-ecs:compare-group-config";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call compareGroupConfigValidateBeforeCall(GroupDiffDiscoveryReq body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling compareGroupConfig(Async)");
        }
        

        com.squareup.okhttp.Call call = compareGroupConfigCall(body, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Perform Device Group Inconsistency Discovery, Synchronization, and Consistency Verification
     * ## Typical Scenario ##   During routine maintenance, the inconsistency discovery function needs to be performed for all devices in a device group, and then configuration synchronization and data consistency verification need to be performed. ## Function ##   Perform inconsistency discovery for all devices in a device group, and then perform configuration synchronization and data consistency verification. ## Constraint ##   1. The southbound device is running properly.   2. The controller is running properly. 
     * @param body Inconsistency discovery parameter. (required)
     * @return DeviceDiffDiscoveryRes
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public DeviceDiffDiscoveryRes compareGroupConfig(GroupDiffDiscoveryReq body) throws ApiException {
        ApiResponse<DeviceDiffDiscoveryRes> resp = compareGroupConfigWithHttpInfo(body);
        return resp.getData();
    }

    /**
     * Perform Device Group Inconsistency Discovery, Synchronization, and Consistency Verification
     * ## Typical Scenario ##   During routine maintenance, the inconsistency discovery function needs to be performed for all devices in a device group, and then configuration synchronization and data consistency verification need to be performed. ## Function ##   Perform inconsistency discovery for all devices in a device group, and then perform configuration synchronization and data consistency verification. ## Constraint ##   1. The southbound device is running properly.   2. The controller is running properly. 
     * @param body Inconsistency discovery parameter. (required)
     * @return ApiResponse&lt;DeviceDiffDiscoveryRes&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<DeviceDiffDiscoveryRes> compareGroupConfigWithHttpInfo(GroupDiffDiscoveryReq body) throws ApiException {
        com.squareup.okhttp.Call call = compareGroupConfigValidateBeforeCall(body, null, null);
        Type localVarReturnType = new TypeToken<DeviceDiffDiscoveryRes>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Perform Device Group Inconsistency Discovery, Synchronization, and Consistency Verification (asynchronously)
     * ## Typical Scenario ##   During routine maintenance, the inconsistency discovery function needs to be performed for all devices in a device group, and then configuration synchronization and data consistency verification need to be performed. ## Function ##   Perform inconsistency discovery for all devices in a device group, and then perform configuration synchronization and data consistency verification. ## Constraint ##   1. The southbound device is running properly.   2. The controller is running properly. 
     * @param body Inconsistency discovery parameter. (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call compareGroupConfigAsync(GroupDiffDiscoveryReq body, final ApiCallback<DeviceDiffDiscoveryRes> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = compareGroupConfigValidateBeforeCall(body, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<DeviceDiffDiscoveryRes>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for queryDeviceDiffJson
     * @param body Parameter for querying the inconsistency discovery result. (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call queryDeviceDiffJsonCall(DiffDiscoveryResultReq body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;

        // create path and map variables
        String localVarPath = "/restconf/operations/huawei-ac-opf-sync-ecs:query-device-diff-json";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call queryDeviceDiffJsonValidateBeforeCall(DiffDiscoveryResultReq body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling queryDeviceDiffJson(Async)");
        }
        

        com.squareup.okhttp.Call call = queryDeviceDiffJsonCall(body, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Query Inconsistency Details
     * ## Typical Scenario ##   After inconsistency discovery is complete, inconsistencies between the NE data on the controller and southbound device configuration data need to be queried. ## Function ##   Check inconsistencies between the NE data on the controller and southbound device configuration data. ## Constraint ##   The controller is running properly. 
     * @param body Parameter for querying the inconsistency discovery result. (required)
     * @return DiffDiscoveryResultRes
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public DiffDiscoveryResultRes queryDeviceDiffJson(DiffDiscoveryResultReq body) throws ApiException {
        ApiResponse<DiffDiscoveryResultRes> resp = queryDeviceDiffJsonWithHttpInfo(body);
        return resp.getData();
    }

    /**
     * Query Inconsistency Details
     * ## Typical Scenario ##   After inconsistency discovery is complete, inconsistencies between the NE data on the controller and southbound device configuration data need to be queried. ## Function ##   Check inconsistencies between the NE data on the controller and southbound device configuration data. ## Constraint ##   The controller is running properly. 
     * @param body Parameter for querying the inconsistency discovery result. (required)
     * @return ApiResponse&lt;DiffDiscoveryResultRes&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<DiffDiscoveryResultRes> queryDeviceDiffJsonWithHttpInfo(DiffDiscoveryResultReq body) throws ApiException {
        com.squareup.okhttp.Call call = queryDeviceDiffJsonValidateBeforeCall(body, null, null);
        Type localVarReturnType = new TypeToken<DiffDiscoveryResultRes>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Query Inconsistency Details (asynchronously)
     * ## Typical Scenario ##   After inconsistency discovery is complete, inconsistencies between the NE data on the controller and southbound device configuration data need to be queried. ## Function ##   Check inconsistencies between the NE data on the controller and southbound device configuration data. ## Constraint ##   The controller is running properly. 
     * @param body Parameter for querying the inconsistency discovery result. (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call queryDeviceDiffJsonAsync(DiffDiscoveryResultReq body, final ApiCallback<DiffDiscoveryResultRes> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = queryDeviceDiffJsonValidateBeforeCall(body, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<DiffDiscoveryResultRes>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for queryDeviceStatusList
     * @param body Inconsistency discovery parameter. (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call queryDeviceStatusListCall(QueryDeviceStatusListReq body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;

        // create path and map variables
        String localVarPath = "/restconf/operations/huawei-ac-opf-sync-ecs:query-device-status-list";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call queryDeviceStatusListValidateBeforeCall(QueryDeviceStatusListReq body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling queryDeviceStatusList(Async)");
        }
        

        com.squareup.okhttp.Call call = queryDeviceStatusListCall(body, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Query Data Consistency Verification Status
     * ## Typical Scenario ##   During inconsistency discovery, synchronization, and consistency verification, the consistency verification status of devices needs to be queried in batches. ## Function ##   Query the consistency verification status of devices in batches based on the device IDs. ## Constraint ##   The controller is running properly. 
     * @param body Inconsistency discovery parameter. (required)
     * @return QueryDeviceStatusListRes
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public QueryDeviceStatusListRes queryDeviceStatusList(QueryDeviceStatusListReq body) throws ApiException {
        ApiResponse<QueryDeviceStatusListRes> resp = queryDeviceStatusListWithHttpInfo(body);
        return resp.getData();
    }

    /**
     * Query Data Consistency Verification Status
     * ## Typical Scenario ##   During inconsistency discovery, synchronization, and consistency verification, the consistency verification status of devices needs to be queried in batches. ## Function ##   Query the consistency verification status of devices in batches based on the device IDs. ## Constraint ##   The controller is running properly. 
     * @param body Inconsistency discovery parameter. (required)
     * @return ApiResponse&lt;QueryDeviceStatusListRes&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<QueryDeviceStatusListRes> queryDeviceStatusListWithHttpInfo(QueryDeviceStatusListReq body) throws ApiException {
        com.squareup.okhttp.Call call = queryDeviceStatusListValidateBeforeCall(body, null, null);
        Type localVarReturnType = new TypeToken<QueryDeviceStatusListRes>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Query Data Consistency Verification Status (asynchronously)
     * ## Typical Scenario ##   During inconsistency discovery, synchronization, and consistency verification, the consistency verification status of devices needs to be queried in batches. ## Function ##   Query the consistency verification status of devices in batches based on the device IDs. ## Constraint ##   The controller is running properly. 
     * @param body Inconsistency discovery parameter. (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call queryDeviceStatusListAsync(QueryDeviceStatusListReq body, final ApiCallback<QueryDeviceStatusListRes> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = queryDeviceStatusListValidateBeforeCall(body, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<QueryDeviceStatusListRes>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
