/*
 * Service Management
 * Third-party northbound APIs for service management: · Apply for a Transaction · Modify Services · Preview Configuration Differences · Perform Dry Run · Check the NE Configuration After Dry Run · Submit a Transaction · Cancel a Transaction · Check Service Association Configuration · Re-Deploy Resources · Undeploy Resources · Query a Data Source · Restore Services 
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.service;

import com.huawei.aoc.api.ApiCallback;
import com.huawei.aoc.api.ApiClient;
import com.huawei.aoc.api.ApiException;
import com.huawei.aoc.api.ApiResponse;
import com.huawei.aoc.api.Configuration;
import com.huawei.aoc.api.Pair;
import com.huawei.aoc.api.ProgressRequestBody;
import com.huawei.aoc.api.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import com.huawei.aoc.api.model.QueryAsyncExecutionReq;
import com.huawei.aoc.api.model.QueryAsyncExecutionRes;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class QueryAsyncExecutionApi {
    private ApiClient apiClient;

    public QueryAsyncExecutionApi() {
        this(Configuration.getDefaultApiClient());
    }

    public QueryAsyncExecutionApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for queryAsyncExecution
     * @param huaweiAcRestconfTransactionsinput  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call queryAsyncExecutionCall(QueryAsyncExecutionReq huaweiAcRestconfTransactionsinput, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = huaweiAcRestconfTransactionsinput;

        // create path and map variables
        String localVarPath = "/restconf/restconf/operations/huawei-ac-restconf-transactions:query-async-execution-result";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call queryAsyncExecutionValidateBeforeCall(QueryAsyncExecutionReq huaweiAcRestconfTransactionsinput, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        

        com.squareup.okhttp.Call call = queryAsyncExecutionCall(huaweiAcRestconfTransactionsinput, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Query Asynchronous Execution Result
     * ## Typical Scenario ##  After a user submits a transaction and selects asynchronous execution, the execution result needs to be queried. ## Function ##  Query the asynchronous execution result. ## Constraint ##  This API can be invoked only after the asynchronous commit operation is performed. 
     * @param huaweiAcRestconfTransactionsinput  (optional)
     * @return QueryAsyncExecutionRes
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public QueryAsyncExecutionRes queryAsyncExecution(QueryAsyncExecutionReq huaweiAcRestconfTransactionsinput) throws ApiException {
        ApiResponse<QueryAsyncExecutionRes> resp = queryAsyncExecutionWithHttpInfo(huaweiAcRestconfTransactionsinput);
        return resp.getData();
    }

    /**
     * Query Asynchronous Execution Result
     * ## Typical Scenario ##  After a user submits a transaction and selects asynchronous execution, the execution result needs to be queried. ## Function ##  Query the asynchronous execution result. ## Constraint ##  This API can be invoked only after the asynchronous commit operation is performed. 
     * @param huaweiAcRestconfTransactionsinput  (optional)
     * @return ApiResponse&lt;QueryAsyncExecutionRes&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<QueryAsyncExecutionRes> queryAsyncExecutionWithHttpInfo(QueryAsyncExecutionReq huaweiAcRestconfTransactionsinput) throws ApiException {
        com.squareup.okhttp.Call call = queryAsyncExecutionValidateBeforeCall(huaweiAcRestconfTransactionsinput, null, null);
        Type localVarReturnType = new TypeToken<QueryAsyncExecutionRes>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Query Asynchronous Execution Result (asynchronously)
     * ## Typical Scenario ##  After a user submits a transaction and selects asynchronous execution, the execution result needs to be queried. ## Function ##  Query the asynchronous execution result. ## Constraint ##  This API can be invoked only after the asynchronous commit operation is performed. 
     * @param huaweiAcRestconfTransactionsinput  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call queryAsyncExecutionAsync(QueryAsyncExecutionReq huaweiAcRestconfTransactionsinput, final ApiCallback<QueryAsyncExecutionRes> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = queryAsyncExecutionValidateBeforeCall(huaweiAcRestconfTransactionsinput, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<QueryAsyncExecutionRes>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
