/*
 * Application Templates
 * · Create an Application Template Instance · Update an Application Template · Query a Template in Use · Query a Template Group in Use · Query Parameters in Use · Submit an Application Template · Cancel an Application Template · Query Available Templates · Query Available Template Groups · Query Driver ID Details · Preview the Device List · Query Configurations Based on a Device · Query Parameters Based on a Device · Modify Parameters Based on a Device · Query NE Task Overview · Query NE Task Details 
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.service;

import com.huawei.aoc.api.ApiCallback;
import com.huawei.aoc.api.ApiClient;
import com.huawei.aoc.api.ApiException;
import com.huawei.aoc.api.ApiResponse;
import com.huawei.aoc.api.Configuration;
import com.huawei.aoc.api.Pair;
import com.huawei.aoc.api.ProgressRequestBody;
import com.huawei.aoc.api.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import com.huawei.aoc.api.model.DetailRes;
import com.huawei.aoc.api.model.QueryDriverIdentificationDetailsReq;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class QueryDriverIdentificationDetailsApi {
    private ApiClient apiClient;

    public QueryDriverIdentificationDetailsApi() {
        this(Configuration.getDefaultApiClient());
    }

    public QueryDriverIdentificationDetailsApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for queryDriverIdentificationDetails
     * @param input  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call queryDriverIdentificationDetailsCall(QueryDriverIdentificationDetailsReq input, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = input;

        // create path and map variables
        String localVarPath = "/restconf/operations/huawei-ac-application-template-north:query-driver-detail";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call queryDriverIdentificationDetailsValidateBeforeCall(QueryDriverIdentificationDetailsReq input, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        

        com.squareup.okhttp.Call call = queryDriverIdentificationDetailsCall(input, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Query Driver ID Details
     * ## Typical Scenario ##  The third-party package ID corresponding to a template needs to be queried to determine the third-party package to which a template belongs. ## Function ##  Query driver ID details. ## Constraint ##  This API applies only to subscribers and can be used only after user sessions are established. 
     * @param input  (optional)
     * @return DetailRes
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public DetailRes queryDriverIdentificationDetails(QueryDriverIdentificationDetailsReq input) throws ApiException {
        ApiResponse<DetailRes> resp = queryDriverIdentificationDetailsWithHttpInfo(input);
        return resp.getData();
    }

    /**
     * Query Driver ID Details
     * ## Typical Scenario ##  The third-party package ID corresponding to a template needs to be queried to determine the third-party package to which a template belongs. ## Function ##  Query driver ID details. ## Constraint ##  This API applies only to subscribers and can be used only after user sessions are established. 
     * @param input  (optional)
     * @return ApiResponse&lt;DetailRes&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<DetailRes> queryDriverIdentificationDetailsWithHttpInfo(QueryDriverIdentificationDetailsReq input) throws ApiException {
        com.squareup.okhttp.Call call = queryDriverIdentificationDetailsValidateBeforeCall(input, null, null);
        Type localVarReturnType = new TypeToken<DetailRes>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Query Driver ID Details (asynchronously)
     * ## Typical Scenario ##  The third-party package ID corresponding to a template needs to be queried to determine the third-party package to which a template belongs. ## Function ##  Query driver ID details. ## Constraint ##  This API applies only to subscribers and can be used only after user sessions are established. 
     * @param input  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call queryDriverIdentificationDetailsAsync(QueryDriverIdentificationDetailsReq input, final ApiCallback<DetailRes> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = queryDriverIdentificationDetailsValidateBeforeCall(input, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<DetailRes>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
