/*
 * Template Management
 * APIs for adding, deleting, querying, and modifying templates
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.service;

import com.huawei.aoc.api.ApiCallback;
import com.huawei.aoc.api.ApiClient;
import com.huawei.aoc.api.ApiException;
import com.huawei.aoc.api.ApiResponse;
import com.huawei.aoc.api.Configuration;
import com.huawei.aoc.api.Pair;
import com.huawei.aoc.api.ProgressRequestBody;
import com.huawei.aoc.api.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import com.huawei.aoc.api.model.QueryOneTemplate;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class QuerySingleTemplateApi {
    private ApiClient apiClient;

    public QuerySingleTemplateApi() {
        this(Configuration.getDefaultApiClient());
    }

    public QuerySingleTemplateApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for querySingleTemplateObject
     * @param templateName Name of an existing template to be deleted, which can contain digits, letters, and one or more of the following special characters, hyphen (-), underscore (_), and at sign (@). The value cannot start with a digit. (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call querySingleTemplateObjectCall(String templateName, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/restconf/data/config-template-north:config-template/template/{template-name}"
            .replaceAll("\\{" + "template-name" + "\\}", apiClient.escapeString(templateName.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call querySingleTemplateObjectValidateBeforeCall(String templateName, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'templateName' is set
        if (templateName == null) {
            throw new ApiException("Missing the required parameter 'templateName' when calling querySingleTemplateObject(Async)");
        }
        

        com.squareup.okhttp.Call call = querySingleTemplateObjectCall(templateName, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Query a Single Template
     * ## Typical Scenario ##   Information about a template needs to be queried. ## Function ##   Query information about a specified template. ## Constraint ##   This is a northbound API. The request header must contain the northbound token obtained in advance. 
     * @param templateName Name of an existing template to be deleted, which can contain digits, letters, and one or more of the following special characters, hyphen (-), underscore (_), and at sign (@). The value cannot start with a digit. (required)
     * @return QueryOneTemplate
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public QueryOneTemplate querySingleTemplateObject(String templateName) throws ApiException {
        ApiResponse<QueryOneTemplate> resp = querySingleTemplateObjectWithHttpInfo(templateName);
        return resp.getData();
    }

    /**
     * Query a Single Template
     * ## Typical Scenario ##   Information about a template needs to be queried. ## Function ##   Query information about a specified template. ## Constraint ##   This is a northbound API. The request header must contain the northbound token obtained in advance. 
     * @param templateName Name of an existing template to be deleted, which can contain digits, letters, and one or more of the following special characters, hyphen (-), underscore (_), and at sign (@). The value cannot start with a digit. (required)
     * @return ApiResponse&lt;QueryOneTemplate&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<QueryOneTemplate> querySingleTemplateObjectWithHttpInfo(String templateName) throws ApiException {
        com.squareup.okhttp.Call call = querySingleTemplateObjectValidateBeforeCall(templateName, null, null);
        Type localVarReturnType = new TypeToken<QueryOneTemplate>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Query a Single Template (asynchronously)
     * ## Typical Scenario ##   Information about a template needs to be queried. ## Function ##   Query information about a specified template. ## Constraint ##   This is a northbound API. The request header must contain the northbound token obtained in advance. 
     * @param templateName Name of an existing template to be deleted, which can contain digits, letters, and one or more of the following special characters, hyphen (-), underscore (_), and at sign (@). The value cannot start with a digit. (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call querySingleTemplateObjectAsync(String templateName, final ApiCallback<QueryOneTemplate> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = querySingleTemplateObjectValidateBeforeCall(templateName, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<QueryOneTemplate>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
