/*
 * Resource Management
 * Resource management APIs: · Create a Resource Pool · Apply for Resources · Release Resources · Release Resources Based on User Information · Query Resource Usage · Delete a Resource Pool 
 *
 * OpenAPI spec version: 1.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.service;

import com.huawei.aoc.api.ApiCallback;
import com.huawei.aoc.api.ApiClient;
import com.huawei.aoc.api.ApiException;
import com.huawei.aoc.api.ApiResponse;
import com.huawei.aoc.api.Configuration;
import com.huawei.aoc.api.Pair;
import com.huawei.aoc.api.ProgressRequestBody;
import com.huawei.aoc.api.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import com.huawei.aoc.api.model.AllocateInput;
import com.huawei.aoc.api.model.CreatePoolInput;
import com.huawei.aoc.api.model.CreatePoolOutput;
import com.huawei.aoc.api.model.DestroyPoolInput;
import com.huawei.aoc.api.model.DestroyPoolOutput;
import com.huawei.aoc.api.model.ReleaseByConsumerRestypeInput;
import com.huawei.aoc.api.model.ReleaseByConsumerRestypeOutput;
import com.huawei.aoc.api.model.ReleaseInput;
import com.huawei.aoc.api.model.ReleaseOutput;
import com.huawei.aoc.api.model.ResourceAllocations;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ResourceMgrServiceApi {
    private ApiClient apiClient;

    public ResourceMgrServiceApi() {
        this(Configuration.getDefaultApiClient());
    }

    public ResourceMgrServiceApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for allocate
     * @param input  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call allocateCall(AllocateInput input, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = input;

        // create path and map variables
        String localVarPath = "/restconf/operations/resource-mgr:allocate";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call allocateValidateBeforeCall(AllocateInput input, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        

        com.squareup.okhttp.Call call = allocateCall(input, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Apply for Resources
     * ## Typical Scenario ##   After a type of service is deployed, resources in a service resource pool need to be applied for the service. ## Function ##   Apply for resources from a created resource pool. ## Constraint ##   NA 
     * @param input  (optional)
     * @return ResourceAllocations
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResourceAllocations allocate(AllocateInput input) throws ApiException {
        ApiResponse<ResourceAllocations> resp = allocateWithHttpInfo(input);
        return resp.getData();
    }

    /**
     * Apply for Resources
     * ## Typical Scenario ##   After a type of service is deployed, resources in a service resource pool need to be applied for the service. ## Function ##   Apply for resources from a created resource pool. ## Constraint ##   NA 
     * @param input  (optional)
     * @return ApiResponse&lt;ResourceAllocations&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResourceAllocations> allocateWithHttpInfo(AllocateInput input) throws ApiException {
        com.squareup.okhttp.Call call = allocateValidateBeforeCall(input, null, null);
        Type localVarReturnType = new TypeToken<ResourceAllocations>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Apply for Resources (asynchronously)
     * ## Typical Scenario ##   After a type of service is deployed, resources in a service resource pool need to be applied for the service. ## Function ##   Apply for resources from a created resource pool. ## Constraint ##   NA 
     * @param input  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call allocateAsync(AllocateInput input, final ApiCallback<ResourceAllocations> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = allocateValidateBeforeCall(input, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResourceAllocations>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for createPool
     * @param input  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createPoolCall(CreatePoolInput input, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = input;

        // create path and map variables
        String localVarPath = "/restconf/operations/resource-mgr:create-pool";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createPoolValidateBeforeCall(CreatePoolInput input, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        

        com.squareup.okhttp.Call call = createPoolCall(input, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Create a Resource Pool
     * ## Typical Scenario ##   Before a user deploys a service, a resource pool needs to be created to record the service deployment information. ## Function ##   Create a resource pool. The system returns a message indicating whether the resource pool is successfully created. ## Constraint ##   NA 
     * @param input  (optional)
     * @return CreatePoolOutput
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public CreatePoolOutput createPool(CreatePoolInput input) throws ApiException {
        ApiResponse<CreatePoolOutput> resp = createPoolWithHttpInfo(input);
        return resp.getData();
    }

    /**
     * Create a Resource Pool
     * ## Typical Scenario ##   Before a user deploys a service, a resource pool needs to be created to record the service deployment information. ## Function ##   Create a resource pool. The system returns a message indicating whether the resource pool is successfully created. ## Constraint ##   NA 
     * @param input  (optional)
     * @return ApiResponse&lt;CreatePoolOutput&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<CreatePoolOutput> createPoolWithHttpInfo(CreatePoolInput input) throws ApiException {
        com.squareup.okhttp.Call call = createPoolValidateBeforeCall(input, null, null);
        Type localVarReturnType = new TypeToken<CreatePoolOutput>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Create a Resource Pool (asynchronously)
     * ## Typical Scenario ##   Before a user deploys a service, a resource pool needs to be created to record the service deployment information. ## Function ##   Create a resource pool. The system returns a message indicating whether the resource pool is successfully created. ## Constraint ##   NA 
     * @param input  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createPoolAsync(CreatePoolInput input, final ApiCallback<CreatePoolOutput> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createPoolValidateBeforeCall(input, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<CreatePoolOutput>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for destroyPool
     * @param input  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call destroyPoolCall(DestroyPoolInput input, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = input;

        // create path and map variables
        String localVarPath = "/restconf/operations/resource-mgr:destroy-pool";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call destroyPoolValidateBeforeCall(DestroyPoolInput input, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        

        com.squareup.okhttp.Call call = destroyPoolCall(input, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Delete a Resource Pool
     * ## Typical Scenario ##   A created resource pool needs to be deleted. ## Function ##   Delete a created resource pool. ## Constraint ##   NA 
     * @param input  (optional)
     * @return DestroyPoolOutput
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public DestroyPoolOutput destroyPool(DestroyPoolInput input) throws ApiException {
        ApiResponse<DestroyPoolOutput> resp = destroyPoolWithHttpInfo(input);
        return resp.getData();
    }

    /**
     * Delete a Resource Pool
     * ## Typical Scenario ##   A created resource pool needs to be deleted. ## Function ##   Delete a created resource pool. ## Constraint ##   NA 
     * @param input  (optional)
     * @return ApiResponse&lt;DestroyPoolOutput&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<DestroyPoolOutput> destroyPoolWithHttpInfo(DestroyPoolInput input) throws ApiException {
        com.squareup.okhttp.Call call = destroyPoolValidateBeforeCall(input, null, null);
        Type localVarReturnType = new TypeToken<DestroyPoolOutput>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Delete a Resource Pool (asynchronously)
     * ## Typical Scenario ##   A created resource pool needs to be deleted. ## Function ##   Delete a created resource pool. ## Constraint ##   NA 
     * @param input  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call destroyPoolAsync(DestroyPoolInput input, final ApiCallback<DestroyPoolOutput> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = destroyPoolValidateBeforeCall(input, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<DestroyPoolOutput>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for release
     * @param input  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call releaseCall(ReleaseInput input, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = input;

        // create path and map variables
        String localVarPath = "/restconf/operations/resource-mgr:release";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call releaseValidateBeforeCall(ReleaseInput input, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        

        com.squareup.okhttp.Call call = releaseCall(input, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Release Resources
     * ## Typical Scenario ##   After a service is undeployed, the resources in use need to be released. ## Function ##   Release used resources. ## Constraint ##   NA 
     * @param input  (optional)
     * @return ReleaseOutput
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ReleaseOutput release(ReleaseInput input) throws ApiException {
        ApiResponse<ReleaseOutput> resp = releaseWithHttpInfo(input);
        return resp.getData();
    }

    /**
     * Release Resources
     * ## Typical Scenario ##   After a service is undeployed, the resources in use need to be released. ## Function ##   Release used resources. ## Constraint ##   NA 
     * @param input  (optional)
     * @return ApiResponse&lt;ReleaseOutput&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ReleaseOutput> releaseWithHttpInfo(ReleaseInput input) throws ApiException {
        com.squareup.okhttp.Call call = releaseValidateBeforeCall(input, null, null);
        Type localVarReturnType = new TypeToken<ReleaseOutput>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Release Resources (asynchronously)
     * ## Typical Scenario ##   After a service is undeployed, the resources in use need to be released. ## Function ##   Release used resources. ## Constraint ##   NA 
     * @param input  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call releaseAsync(ReleaseInput input, final ApiCallback<ReleaseOutput> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = releaseValidateBeforeCall(input, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ReleaseOutput>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for releaseByConsumerRestype
     * @param input  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call releaseByConsumerRestypeCall(ReleaseByConsumerRestypeInput input, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = input;

        // create path and map variables
        String localVarPath = "/restconf/operations/resource-mgr:release-by-consumer-restype";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call releaseByConsumerRestypeValidateBeforeCall(ReleaseByConsumerRestypeInput input, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        

        com.squareup.okhttp.Call call = releaseByConsumerRestypeCall(input, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Release Resources Based on User Information
     * ## Typical Scenario ##   Resources need to be released based on user information. ## Function ##   Release resources based on user information. ## Constraint ##   NA 
     * @param input  (optional)
     * @return ReleaseByConsumerRestypeOutput
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ReleaseByConsumerRestypeOutput releaseByConsumerRestype(ReleaseByConsumerRestypeInput input) throws ApiException {
        ApiResponse<ReleaseByConsumerRestypeOutput> resp = releaseByConsumerRestypeWithHttpInfo(input);
        return resp.getData();
    }

    /**
     * Release Resources Based on User Information
     * ## Typical Scenario ##   Resources need to be released based on user information. ## Function ##   Release resources based on user information. ## Constraint ##   NA 
     * @param input  (optional)
     * @return ApiResponse&lt;ReleaseByConsumerRestypeOutput&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ReleaseByConsumerRestypeOutput> releaseByConsumerRestypeWithHttpInfo(ReleaseByConsumerRestypeInput input) throws ApiException {
        com.squareup.okhttp.Call call = releaseByConsumerRestypeValidateBeforeCall(input, null, null);
        Type localVarReturnType = new TypeToken<ReleaseByConsumerRestypeOutput>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Release Resources Based on User Information (asynchronously)
     * ## Typical Scenario ##   Resources need to be released based on user information. ## Function ##   Release resources based on user information. ## Constraint ##   NA 
     * @param input  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call releaseByConsumerRestypeAsync(ReleaseByConsumerRestypeInput input, final ApiCallback<ReleaseByConsumerRestypeOutput> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = releaseByConsumerRestypeValidateBeforeCall(input, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ReleaseByConsumerRestypeOutput>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
