/*
 * Resource Management
 * Resource management APIs: · Create a Resource Pool · Apply for Resources · Release Resources · Release Resources Based on User Information · Query Resource Usage · Delete a Resource Pool 
 *
 * OpenAPI spec version: 1.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.service;

import com.huawei.aoc.api.ApiCallback;
import com.huawei.aoc.api.ApiClient;
import com.huawei.aoc.api.ApiException;
import com.huawei.aoc.api.ApiResponse;
import com.huawei.aoc.api.Configuration;
import com.huawei.aoc.api.Pair;
import com.huawei.aoc.api.ProgressRequestBody;
import com.huawei.aoc.api.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import com.huawei.aoc.api.model.GetResourceUsageInput;
import com.huawei.aoc.api.model.GetResourceUsageOutput;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ResourcepoolMgrServiceApi {
    private ApiClient apiClient;

    public ResourcepoolMgrServiceApi() {
        this(Configuration.getDefaultApiClient());
    }

    public ResourcepoolMgrServiceApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for getResourceUsage
     * @param input  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getResourceUsageCall(GetResourceUsageInput input, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = input;

        // create path and map variables
        String localVarPath = "/restconf/operations/resourcepool-mgr:get-resource-usage";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getResourceUsageValidateBeforeCall(GetResourceUsageInput input, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        

        com.squareup.okhttp.Call call = getResourceUsageCall(input, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Query Resource Usage
     * ## Typical Scenario ##   The range and usage of a resource pool need to be queried based on the URL keyword. ## Function ##   Query the range and usage of a resource pool based on the URL keyword. ## Constraint ##   NA 
     * @param input  (optional)
     * @return GetResourceUsageOutput
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public GetResourceUsageOutput getResourceUsage(GetResourceUsageInput input) throws ApiException {
        ApiResponse<GetResourceUsageOutput> resp = getResourceUsageWithHttpInfo(input);
        return resp.getData();
    }

    /**
     * Query Resource Usage
     * ## Typical Scenario ##   The range and usage of a resource pool need to be queried based on the URL keyword. ## Function ##   Query the range and usage of a resource pool based on the URL keyword. ## Constraint ##   NA 
     * @param input  (optional)
     * @return ApiResponse&lt;GetResourceUsageOutput&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<GetResourceUsageOutput> getResourceUsageWithHttpInfo(GetResourceUsageInput input) throws ApiException {
        com.squareup.okhttp.Call call = getResourceUsageValidateBeforeCall(input, null, null);
        Type localVarReturnType = new TypeToken<GetResourceUsageOutput>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Query Resource Usage (asynchronously)
     * ## Typical Scenario ##   The range and usage of a resource pool need to be queried based on the URL keyword. ## Function ##   Query the range and usage of a resource pool based on the URL keyword. ## Constraint ##   NA 
     * @param input  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getResourceUsageAsync(GetResourceUsageInput input, final ApiCallback<GetResourceUsageOutput> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getResourceUsageValidateBeforeCall(input, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<GetResourceUsageOutput>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
