/*
 * Application Templates
 * · Create an Application Template Instance · Update an Application Template · Query a Template in Use · Query a Template Group in Use · Query Parameters in Use · Submit an Application Template · Cancel an Application Template · Query Available Templates · Query Available Template Groups · Query Driver ID Details · Preview the Device List · Query Configurations Based on a Device · Query Parameters Based on a Device · Modify Parameters Based on a Device · Query NE Task Overview · Query NE Task Details 
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.service;

import com.huawei.aoc.api.ApiCallback;
import com.huawei.aoc.api.ApiClient;
import com.huawei.aoc.api.ApiException;
import com.huawei.aoc.api.ApiResponse;
import com.huawei.aoc.api.Configuration;
import com.huawei.aoc.api.Pair;
import com.huawei.aoc.api.ProgressRequestBody;
import com.huawei.aoc.api.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import com.huawei.aoc.api.model.SubmitApplicationTemplateReq;
import com.huawei.aoc.api.model.TaskIdRes;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class SubmitApplicationTemplateApi {
    private ApiClient apiClient;

    public SubmitApplicationTemplateApi() {
        this(Configuration.getDefaultApiClient());
    }

    public SubmitApplicationTemplateApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for submitApplicationTemplate
     * @param input  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call submitApplicationTemplateCall(SubmitApplicationTemplateReq input, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = input;

        // create path and map variables
        String localVarPath = "/restconf/operations/huawei-ac-application-template-north:submit-template-application";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call submitApplicationTemplateValidateBeforeCall(SubmitApplicationTemplateReq input, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        

        com.squareup.okhttp.Call call = submitApplicationTemplateCall(input, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Submit an Application Template
     * ## Typical Scenario ##  Service data needs to be submitted to the controller for caching or directly delivered to forwarders after services are orchestrated and parameters are assigned for an application instance. ## Function ##  Submit service data to the controller for caching or deliver the data to forwarders. The data in the controller cache is saved only on the controller and is not delivered to devices. The data is delivered to devices only when forwarders are selected. ## Constraint ##  1. Devices have been added.  2. Interconnection between the controller and device is normal.  3. A template has been created.  4. (Optional) The parameter set required by the template has been created. 
     * @param input  (optional)
     * @return TaskIdRes
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public TaskIdRes submitApplicationTemplate(SubmitApplicationTemplateReq input) throws ApiException {
        ApiResponse<TaskIdRes> resp = submitApplicationTemplateWithHttpInfo(input);
        return resp.getData();
    }

    /**
     * Submit an Application Template
     * ## Typical Scenario ##  Service data needs to be submitted to the controller for caching or directly delivered to forwarders after services are orchestrated and parameters are assigned for an application instance. ## Function ##  Submit service data to the controller for caching or deliver the data to forwarders. The data in the controller cache is saved only on the controller and is not delivered to devices. The data is delivered to devices only when forwarders are selected. ## Constraint ##  1. Devices have been added.  2. Interconnection between the controller and device is normal.  3. A template has been created.  4. (Optional) The parameter set required by the template has been created. 
     * @param input  (optional)
     * @return ApiResponse&lt;TaskIdRes&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<TaskIdRes> submitApplicationTemplateWithHttpInfo(SubmitApplicationTemplateReq input) throws ApiException {
        com.squareup.okhttp.Call call = submitApplicationTemplateValidateBeforeCall(input, null, null);
        Type localVarReturnType = new TypeToken<TaskIdRes>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Submit an Application Template (asynchronously)
     * ## Typical Scenario ##  Service data needs to be submitted to the controller for caching or directly delivered to forwarders after services are orchestrated and parameters are assigned for an application instance. ## Function ##  Submit service data to the controller for caching or deliver the data to forwarders. The data in the controller cache is saved only on the controller and is not delivered to devices. The data is delivered to devices only when forwarders are selected. ## Constraint ##  1. Devices have been added.  2. Interconnection between the controller and device is normal.  3. A template has been created.  4. (Optional) The parameter set required by the template has been created. 
     * @param input  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call submitApplicationTemplateAsync(SubmitApplicationTemplateReq input, final ApiCallback<TaskIdRes> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = submitApplicationTemplateValidateBeforeCall(input, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<TaskIdRes>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
