/*
 * Parameter Set Management
 * Create a Parameter Set Delete a Parameter Set Query a Parameter Set Add Parameters to a Parameter Set Delete Parameters from a Parameter Set Update Parameters in a Parameter Set
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.aoc.api.service;

import com.huawei.aoc.api.ApiCallback;
import com.huawei.aoc.api.ApiClient;
import com.huawei.aoc.api.ApiException;
import com.huawei.aoc.api.ApiResponse;
import com.huawei.aoc.api.Configuration;
import com.huawei.aoc.api.Pair;
import com.huawei.aoc.api.ProgressRequestBody;
import com.huawei.aoc.api.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import com.huawei.aoc.api.model.ParameterAddSet;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class UpdateParameterToSetApi {
    private ApiClient apiClient;

    public UpdateParameterToSetApi() {
        this(Configuration.getDefaultApiClient());
    }

    public UpdateParameterToSetApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for setUpdateTemplateParameter
     * @param parameterSetName Name of an existing parameter set in the environment, which can contain digits, letters, and one or more of the following special characters, hyphen (-), underscore (_), and at sign (@). The value cannot start with a digit. (required)
     * @param name Name of a parameter in the preceding parameter set, which can contain digits, letters, and one or more of the following special characters, hyphens (-), underscores (_), and at signs (@). The value cannot start with a digit. (required)
     * @param huaweiAcConfigTemplateParameterNorthparameters  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call setUpdateTemplateParameterCall(String parameterSetName, String name, ParameterAddSet huaweiAcConfigTemplateParameterNorthparameters, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = huaweiAcConfigTemplateParameterNorthparameters;

        // create path and map variables
        String localVarPath = "/restconf/data/huawei-ac-config-template-parameter-north:template-parameter/parameter-set/{parameter-set-name}/parameters/{name}"
            .replaceAll("\\{" + "parameter-set-name" + "\\}", apiClient.escapeString(parameterSetName.toString()))
            .replaceAll("\\{" + "name" + "\\}", apiClient.escapeString(name.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call setUpdateTemplateParameterValidateBeforeCall(String parameterSetName, String name, ParameterAddSet huaweiAcConfigTemplateParameterNorthparameters, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'parameterSetName' is set
        if (parameterSetName == null) {
            throw new ApiException("Missing the required parameter 'parameterSetName' when calling setUpdateTemplateParameter(Async)");
        }
        
        // verify the required parameter 'name' is set
        if (name == null) {
            throw new ApiException("Missing the required parameter 'name' when calling setUpdateTemplateParameter(Async)");
        }
        
        // verify the required parameter 'huaweiAcConfigTemplateParameterNorthparameters' is set
        if (huaweiAcConfigTemplateParameterNorthparameters == null) {
            throw new ApiException("Missing the required parameter 'huaweiAcConfigTemplateParameterNorthparameters' when calling setUpdateTemplateParameter(Async)");
        }
        

        com.squareup.okhttp.Call call = setUpdateTemplateParameterCall(parameterSetName, name, huaweiAcConfigTemplateParameterNorthparameters, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Update Parameters in a Parameter Set
     * ## Typical Scenario ##   A parameter needs to be updated for a parameter set. ## Function ##   Update specified parameter information for a specified parameter set. ## Constraint ##   This is a northbound API. The request header must contain the northbound token obtained in advance. The parameter set and the parameters to be updated must exist. 
     * @param parameterSetName Name of an existing parameter set in the environment, which can contain digits, letters, and one or more of the following special characters, hyphen (-), underscore (_), and at sign (@). The value cannot start with a digit. (required)
     * @param name Name of a parameter in the preceding parameter set, which can contain digits, letters, and one or more of the following special characters, hyphens (-), underscores (_), and at signs (@). The value cannot start with a digit. (required)
     * @param huaweiAcConfigTemplateParameterNorthparameters  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void setUpdateTemplateParameter(String parameterSetName, String name, ParameterAddSet huaweiAcConfigTemplateParameterNorthparameters) throws ApiException {
        setUpdateTemplateParameterWithHttpInfo(parameterSetName, name, huaweiAcConfigTemplateParameterNorthparameters);
    }

    /**
     * Update Parameters in a Parameter Set
     * ## Typical Scenario ##   A parameter needs to be updated for a parameter set. ## Function ##   Update specified parameter information for a specified parameter set. ## Constraint ##   This is a northbound API. The request header must contain the northbound token obtained in advance. The parameter set and the parameters to be updated must exist. 
     * @param parameterSetName Name of an existing parameter set in the environment, which can contain digits, letters, and one or more of the following special characters, hyphen (-), underscore (_), and at sign (@). The value cannot start with a digit. (required)
     * @param name Name of a parameter in the preceding parameter set, which can contain digits, letters, and one or more of the following special characters, hyphens (-), underscores (_), and at signs (@). The value cannot start with a digit. (required)
     * @param huaweiAcConfigTemplateParameterNorthparameters  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> setUpdateTemplateParameterWithHttpInfo(String parameterSetName, String name, ParameterAddSet huaweiAcConfigTemplateParameterNorthparameters) throws ApiException {
        com.squareup.okhttp.Call call = setUpdateTemplateParameterValidateBeforeCall(parameterSetName, name, huaweiAcConfigTemplateParameterNorthparameters, null, null);
        return apiClient.execute(call);
    }

    /**
     * Update Parameters in a Parameter Set (asynchronously)
     * ## Typical Scenario ##   A parameter needs to be updated for a parameter set. ## Function ##   Update specified parameter information for a specified parameter set. ## Constraint ##   This is a northbound API. The request header must contain the northbound token obtained in advance. The parameter set and the parameters to be updated must exist. 
     * @param parameterSetName Name of an existing parameter set in the environment, which can contain digits, letters, and one or more of the following special characters, hyphen (-), underscore (_), and at sign (@). The value cannot start with a digit. (required)
     * @param name Name of a parameter in the preceding parameter set, which can contain digits, letters, and one or more of the following special characters, hyphens (-), underscores (_), and at signs (@). The value cannot start with a digit. (required)
     * @param huaweiAcConfigTemplateParameterNorthparameters  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call setUpdateTemplateParameterAsync(String parameterSetName, String name, ParameterAddSet huaweiAcConfigTemplateParameterNorthparameters, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = setUpdateTemplateParameterValidateBeforeCall(parameterSetName, name, huaweiAcConfigTemplateParameterNorthparameters, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
}
